clear all


%Generatorspesifikasjoner

    disp('Reading data from file');

    [num]=xlsread('Input.xls', 1,'C5:C32');                             %Henter inputverdier fra tabellen "Required Values" i inputfil

    Sn=num(1);
    Cosphi=num(2);
    f=num(3);
    Np=num(4);
    nr=num(5);
    dTmx=num(6);
    M=num(7);
    Vmx=num(8);
    xd=num(9);
    xd1=num(10);
    xd2=num(11);
    Btmx=num(12);
    Bpmx=num(13);
    Bymx=num(14);
    budbd=num(15);
    bcs=num(16);
    bv=num(17);
    kFe=num(18);
    Ssxls=num(19);
    hcusxls=num(20);
    Vf=num(21);
    Sfi=num(22);
    Vnmx=num(23);
    s=num(24);
    Dri=num(25);
    alfar=num(26);
    Br=num(27);
    myr_pm=num(28);
    
    [num1]=xlsread('Input.xls', 1,'C34:C51');                           %Henter inputverdier fra tabellen "Optional Values" i inputfil
        
    PMcalc=num1(1);
    Unxls=num1(2);
    Cxls=num1(3);
    Qsxls=num1(4);
    pnrxls=num1(5);
    tnrxls=num1(6);
    yxls=num1(7);
    Dixls=num1(8);
    lbxls=num1(9);
    Bdeltaxls=num1(10);
    hyrxls=num1(11);
    qthxls=num1(12);
    GD2addxls=num1(13);
    delta0xls=num1(14);
    bcufxls=num1(15);
    P10xls=num1(16);
    FeOldxls=num1(17);
    lavxls=num1(18);
    
    [num2]=xlsread('Input.xls', 1,'C55:C68');                           %Henter inputverdier fra tabellen "Chosen Slot Dimensions" i inputfil
    
    hsxls=num2(1);
    buxls=num2(2);
    ndlxls=num2(3);
    ndlpxls=num2(4);
    ndlhxls=num2(5);
    bcusxls=num2(6);
    hdsxls=num2(7);
    hspkxls=num2(8);
    hglsxls=num2(9);
    hmxls=num2(10);
    drsxls=num2(11);
    dijxls=num2(12);
    dicuxls=num2(13);
    diwxls=num2(14);
    
    [num3]=xlsread('Input.xls', 1,'C73:C83');                           %Henter inputverdier fra tabellen "Chosen Pole Dimensions" i inputfil
    
    bpsxls=num3(1);
    hpsxls=num3(2);
    bpkxls=num3(3);
    hpkxls=num3(4);
    hfxls=num3(5);
    nfxls=num3(6);
    hcufxls=num3(7);
    NDsxls=num3(8);
    Pmagnxls=num3(9);
    bixls=num3(10);
    bifxls=num3(11);

    
    
    if Unxls~=0 && Cxls~=0
        
        disp('NB!: Either Un or C must be 0!!!')
        break
    
    end
    
    if lbxls~=0 && Bdeltaxls~=0
    
        disp('NB : Either lbxls or Bdeltaxls must be 0')
        break
    
    end
    
    if PMcalc == 0
        PMcalc=input('Do you want to do the calculation for surface mounted PM? (1 for "yes", 0 for "no")');
        disp(' ');
    end
    
    if PMcalc == 0                                                          %Gjr beregninger for ordinr synkronmaskin
    
    disp(' ');

    disp('Chosen parameters:');                                             %Skriver ut valgte verdier fra tabell "Required Values"
    disp(' ');
    disp(['Sn = ',num2str(Sn),' MVA']);
    disp(['Cos(phi) = ',num2str(Cosphi),]);
    disp(['f = ',num2str(f),' Hz']);
    disp(['2p = ',num2str(Np),]);
    disp(['nr = ',num2str(nr),' rpm']);
    disp(['dTmx = ',num2str(dTmx),' degC']);
    disp(['M = ',num2str(M),' tm^2']);
    disp(['Vmx = ',num2str(Vmx),' KV']);
    disp(['xd = ',num2str(xd),' pu']);
    disp(['xd` = ',num2str(xd1),' pu']);
    disp(['xd`` = ',num2str(xd2),' pu']);
    disp(['Btmx = ',num2str(Btmx),' T']);
    disp(['Bpmx = ',num2str(Bpmx),' T']);
    disp(['Bymx = ',num2str(Bymx),' T']);
    disp(['bs/bt = ',num2str(budbd),]);
    disp(['lcs = ',num2str(bcs),'m']);
    disp(['lcd = ',num2str(bv),'m']);
    disp(['kFe = ',num2str(kFe),]);
    disp(['Ss = ',num2str(Ssxls),'A/mm2']);
    disp(['hcus = ',num2str(hcusxls),'mm']);
    disp(['Vf = ',num2str(Vf),'V']);
    disp(['Vnmx = ',num2str(Vnmx),'']);
    disp(['s = ',num2str(s),'']);
    disp(['Dri = ', num2str(Dri), 'm']);
    disp(['alfa = ',num2str(alfar),'']);
  


%Definering av konstanter og variabler

    my0=pi*4e-7;                                                            %Permeabilitiet for luft
    m=3;                                                                    %Antall faser
    p=Np/2;                                                                 %Antall polpar
    w=2*pi*f;                                                               %Ohmega, vinkelhastighet
       
    
%Diameter og jernlengde

    C=0.02*Sn+5.6;                                                          %Bestemmer utnyttelsessifferet
    
    if Cxls~=0
         C=Cxls;   
    end    
    
    if M==0
        M=30.38*((1.5+3.1e-3*(Sn*Np))/2.2)*(Sn/14)*(Np/14)-13.5;
    end    
        
        
    ns=120*f/(Np);                                                          %Beregner nominelt turtall
    D2l=Sn*1000/(C*ns);                                                     %Empirisk faktor for  bestemme Diameter og lengde
    beta=-0.06*Np/2+2.9;                                                    %Empirisk konstant for  beregne GD2
    GD2=4*M;                                                                %Faktor for  bestemme D4l
    D4l=GD2/beta;                                                           %Empirisk faktor for  bestemme Diameter og lengde
    
    if Dixls == 0
        Di=sqrt(D4l/D2l);                                                   %Indre statordiameter
    else
        Di=Dixls;
    end
    
    if lbxls == 0
            
        lb=D2l/(Di^2);                                                      %Brutto jernlengde
    else
        lb=lbxls;
    end                                                                     

    Vr=pi()*Di*nr/60;                                                      %Kontroll av maksimal periferihastighet[m/s], br ikke overstige 150[m/s]
    
    
%Valg av antall spor
    
    if Qsxls==0
                                                                            %Antall parallelle kretser
        pnr=1;                                                              %Variabel som brukes til for-slyfe for parallelle kretser

        Qmin=round(Di*pi/0.12);                                             %Beregning av minste sportall som skal kontrolleres
        Qmax=round(Di*pi/0.04);                                             %Beregning av strste sportall som skal kontrolleres
        Qs=Qmin;                                                            %Variabel som brukes til kontroll av sportallene

        sportab(100,30)=0;                                                  %Setter tabellen som de godkjente sportallene skrives inn i lik 0
        sporkonst=1;                                                        %Konstant til spormatrise
        parkonst=1;                                                         %Konstant til spormatrise

        for pnr=1:1:15


          for Qs=Qmin:1:Qmax    

            k1=Qs/6;                                                        %Konstant som brukes til  kontrollere krav om at sportall er delelig p 6 (2x3) (skal bil et heltall)
            k2=round(k1);                                                   %Konstant som brukes til  kontrollere krav om at sportall er delelig p 6 (2x3)

                if k1==k2

                    k11=Qs/pnr;                                             %Konstant som brukes til  kontrollere krav om at sportall er delelig p antall poler (skal bil et heltall)
                    k22=Np/pnr;                                             %Konstant som brukes til  kontrollere krav om at antall poler er delelig p antall parallelle krester (skal bil et heltall)
                    k111=round(k11);                                        %k11 rundes av for  kontrollere om den er et heltall (betingelse til if-slyfe)
                    k222=round(k22);                                        %k22 rundes av for  kontrollere om den er et heltall (betingelse til if-slyfe)

                    if k111==k11 && k222==k22

                        sportab(sporkonst,parkonst)=Qs;                     %Tillatt sportall legges inn i matrise

                        parkonst=parkonst+1;

                        q=(Qs/(m*Np));                                      %Antall spor per pol og fase beregnes for det aktuelle sportallet

                        sportab(sporkonst,parkonst)=q;                      %q legges til matrisen ved siden av det samsvarende sportallet

                        parkonst=parkonst-1;


                        sporkonst=sporkonst+1;  

                    end
                end   


            Qs=Qs+1;
          end

        parkonst=parkonst+2;
        sporkonst=1;
        end

        xlswrite('sporfil.xls',sportab,1,'C3');                             %Matrise for alle aktuelle sportall Qs og tilsvarenede q skrives til excel
        disp(' ');
    end
    
    if Qsxls~=0                                                             %Velger sprotall
        Qs=Qsxls; 
    else
        Qs=input('Select number of slots from table:');                      
        disp(' ');
    end
    
                                                                            
    if pnrxls~=0                                                            %Velger antall parallelle kretser
        pnr=pnrxls;        
    else
        pnr=input('Select the number of paralell cricuits:'); 
        disp(' ');
    end
    
    if tnrxls~=0                                                            %Velger antall turn per vinding
        tnr=tnrxls;                                                    
    else
        tnr=input('Select the number of turns per coil:');                    
        disp(' ');
    end
                                                                            
    
    q=(Qs/(m*Np));                                                          %Beregner antall spor per pol og fase
    
    tauu=pi*Di/Qs;                                                          %Spordeling i meter
    taup=pi*Di/(Np);                                                        %Poldeling i meter
    taups=Qs/Np;                                                            %Poldeling i antall spor
    Ns=Qs*tnr/(m*pnr);                                                      %Antall vindinger i serie per fase
    
    
%valg av spenning og ankerbelastning
    
    km=1.515;                                                               %Forholdet mellom maksimal luftgapinduksjon i tomgang og midlere induksjon
    kf=1.11;                                                                %Omregnigsfaktor
    fw=0.925;                                                               %Gjennomsnittlig viklingsfaktor
    fj=0.83;                                                                %Faktor som bestr av forholdet mellom netto og brutto jernlengde
                                                               
    Ams=(C*60*km*1000)/(pi^2*kf*fw*fj*Btmx/(1+(budbd)));                    %Estimert ankerbelastning ut i fra utnyttelsessiffer 
    Amsdelta=Ams;
    

% Fra ankerbelastningen kan strmmen i en stav berenges
 
    Inm=Ams*tauu/(tnr*2);                                                   %Beregner strmmen i en stav
    In=Inm*pnr;                                                             %Generatorens merkestrm
    Un=Sn*1e6/(In*sqrt(3));                                                 %Generatorens klemmespenning
    Ic=In*tnr/pnr;                                                          %Stavstrm
    
    As=Ic*2/tauu;                                                           %Ny ankerbelastning                                                                     
    
    if Unxls~=0                                                             %Valgt spenning fra inputfil
    
    Un=Unxls;                                                               %M beregne ny strm og ankerbelastning
    In=Sn*1e6/(sqrt(3)*Un);
    Ic=In*tnr/pnr;
    As=Ic*2/tauu;
   
    C2=pi^2/60*kf*fw/km*fj/(1+budbd)*As*0.001*Btmx;    
    C2delta=0.0001*As;
   
    Ckonst=abs(1-C/C2);                                                     %Ittererer for  f korrekt utnyttelsessiffer
    
    while Ckonst>=0.01
    
        C=C2;   

        ns=120*f/(Np);                                                      %Beregner nominelt turtall
        D2l=Sn*1000/(C*ns);                                                 %Empirisk faktor for  bestemme Diameter og lengde
        beta=-0.06*Np/2+2.9;                                                %Empirisk konstant for  beregne GD2
        GD2=4*M;                                                            %Faktor for  bestemme D4l
        D4l=GD2/beta;                                                       %Empirisk faktor for  bestemme Diameter og lengde
        
        if Dixls == 0
            Di=sqrt(D4l/D2l);                                               %Indre statordiameter
        else
            Di=Dixls;
        end
            
        if lbxls == 0                                                       %Brutto jernlengde
            
            lb=D2l/(Di^2);                                                  
        else
            lb=lbxls;
        end                                                                

        Vr=pi()*Di*nr/60;                                                   %Kontroll av maksimal periferihastighet[m/s], br ikke overstige 150[m/s]



    %Valg av antall spor

        m=3;                                                                %Antall parallelle kretser
        
        if Qsxls==0
            pnr=1;                                                          %Variabel som brukes til for-slyfe for parallelle kretser


            Qmin=round(Di*pi/0.12);                                         %Beregning av minste sportall som skal kontrolleres
            Qmax=round(Di*pi/0.04);                                         %Beregning av strste sportall som skal kontrolleres
            Qs=Qmin;                                                        %Variabel som brukes til kontroll av sportallene


            sportab(100,20)=0;                                              %Setter tabellen som de godkjente sportallene skrives inn i lik 0
            sporkonst=1;                                                    %Konstant til spormatrise
            parkonst=1;                                                     %Konstant til spormatrise

            for pnr=1:1:10


              for Qs=Qmin:1:Qmax    

                k1=Qs/6;                                                    %Konstant som brukes til  kontrollere krav om at sportall er delelig p 6 (2x3) (skal bil et heltall)
                k2=round(k1);                                               %Konstant som brukes til  kontrollere krav om at sportall er delelig p 6 (2x3)

                    if k1==k2

                    k11=Qs/pnr;                                             %Konstant som brukes til  kontrollere krav om at sportall er delelig p antall poler (skal bil et heltall)
                    k22=Np/pnr;                                             %Konstant som brukes til  kontrollere krav om at antall poler er delelig p antall parallelle krester (skal bil et heltall)
                    k111=round(k11);                                        %k11 rundes av for  kontrollere om den er et heltall (betingelse til if-slyfe)
                    k222=round(k22);                                        %k22 rundes av for  kontrollere om den er et heltall (betingelse til if-slyfe)

                        if k111==k11 && k222==k22

                            sportab(sporkonst,parkonst)=Qs;                 %Tillatt sportall legges inn i matrise

                            parkonst=parkonst+1;

                            q=(Qs/(m*Np));                                  %Antall spor per pol og fase beregnes for det aktuelle sportallet

                            sportab(sporkonst,parkonst)=q;                  %q legges til matrisen ved siden av det samsvarende sportallet

                            parkonst=parkonst-1;


                            sporkonst=sporkonst+1;  

                        end
                    end   


                Qs=Qs+1;
              end

            parkonst=parkonst+2;
            sporkonst=1;
            end

            xlswrite('sporfil.xls',sportab,1,'C3');                         %Matrise for alle aktuelle sportall Qs og tilsvarenede q skrives til excel
        end
        disp(' ');

        if Qsxls~=0
            Qs=Qsxls; 
        else
            Qs=input('Select number of slots from table:');
            disp(' ');
        end

        if pnrxls~=0                                                        %Velger antall parallelle kretser 
            pnr=pnrxls;        
        else
            pnr=input('Select the number of paralell cricuits:'); 
            disp(' ');
        end

        if tnrxls~=0                                                        %Velger antall turn
            tnr=tnrxls;        
        else
            tnr=input('Select the number of turns per coil:');  
            disp(' ');
        end


        q=(Qs/(m*Np));                                                      %Beregner antall spor per pol og fase

        tauu=pi*Di/Qs;                                                      %Spordeling i meter
        taup=pi*Di/(Np);                                                    %Poldeling i meter
        taups=Qs/Np;                                                        %Poldeling i antall spor
        Ns=Qs*tnr/(m*pnr);                                                  %Antall vindinger i serie per fase

    
    %valg av spenning og ankerbelastning

        km=1.515;                                                           %Forholdet mellom maksimal luftgapindusjon i tomgang og midlere indusjon
        kf=1.11;                                                            %Omregnigsfaktor
        fw=0.925;                                                           %Gjennomsnittlig viklingsfaktor
        fj=0.83;                                                            %Faktor som bestr av forholdet mellom netto og brutto jernlengde

        Ams=(C*60*km*1000)/(pi^2*kf*fw*fj*Btmx/(1+(budbd)));                %Estimert ankerbelastning ut i fra utnyttelsessiffer 
        Amsdelta=(C2delta*60*km*1000)/(pi^2*kf*fw*fj*Btmx/(1+(budbd)));

        As=Ic*2/tauu; 

        C2=pi^2/60*kf*fw/km*fj/(1+budbd)*As*0.001*Btmx;    

        Ckonst=abs(1-C/C2);

    end
    
    Ascm=As/100;
    C=C2;
    
    end
    
    
    Rref=Un^2/(Sn*1e6);                                                     %Referanseverdi for resistans/reaktans
    
    if buxls ~= 0                                                           %Beregning av sporbredde
        bu=buxls;
    else
        bu=tauu/(1+1/budbd);                                                
    end
    
    bd=tauu-bu;                                                             %Beregning av tannbredde
    
    %Beregning av sporet
    
    if hsxls ~= 0
        if tnr==1
% 
%             Ss=Ssxls*1e6;                                                   %Strmtetthet i spor
%             hcus=hcusxls/1e3;                                               %Hyde p en delleder
%             hspk=hspkxls;                                                   %Hyde p sporkile
%             hm=hmxls;                                                       %Hyde p mellomstrimmel
%             hgls=hglsxls;                                                   %Hyde p glidestrimmel
%             hds=hdsxls;                                                     %Hyde avstand mellom sporkile og luftgap
%             drs=drsxls;                                                     %Bredde p rbelseparator
%             dij=dijxls;                                                     %Beregner jordisolasjon
%             dicu=dicuxls;                                                   %Dellederisolasjon 1.-sidig
%             bcus=bcusxls;                                                   %Bredde p en delleder  
%             bcu=2*bcus;                                                     %Beregner kobberbredde for sporet                                                                 
%             ndl=ndlxls;                                                     %Antall delledere
%             ndlp=2;
%             ndlh=1;
%             Ss=In/(ndl*bcus*hcus);                                          %Ny strmtetthet i stator
%             hcu=hcus*ndl;                                                   %Total kobberhyde i et spor
%             hs=hsxls;                                                       %Hyde av sporet
%             diw=0;                                                          %Turnisolasjon i tillegg til lakkisolasjon
%             fsp=0;                                                          %Faktor til temperaturberegning
%             hstav=hcu/2+ndl*dicu+2*dij;                                     %Beregner hyde av stav
            
            Ss=Ssxls*1e6;                                                   %Strmtetthet i spor
            hcus=hcusxls/1e3;                                               %Hyde p en delleder
            hspk=0.006;                                                     %Hyde p sporkile
            hm=0.007;                                                       %Hyde p mellomstrimmel
            hgls=0.002;                                                     %Hyde p glidestrimmel
            hds=0.001;                                                      %Hyde avstand mellom sporkile og luftgap
            drs=0.0005;                                                     %Bredde p rbelseparator
            dij=0.0003+2.35e-7*Un;                                          %Beregner jordisolasjon
            dicu=0.0001;                                                    %Dellederisolasjon 1.-sidig
            bcus=(bu-2*dij-4*dicu-drs)/2;                                   %Bredde p en delleder
            bcu=bcus*2;                                                     %Beregner kobberbredde for sporet
            ndl=(Ic/(Ss*bcus*hcus));                                        %Mellomregning for antall delledere
            ndl=round(ndl/2);                                               %Mellomregning for antall delledere
            ndl=ndl*2;                                                      %Antall delledere
            ndlp=2;
            ndlh=1;
            Ss=In/(ndl*bcus*hcus);                                          %Ny strmtetthet i stator
            hcu=hcus*ndl;                                                   %Total kobberhyde i et spor
            hs=hsxls;                         %Hyde av sporet
            diw=0;                                                          %Turnisolasjon i tillegg til lakkisolasjon
            
            fsp=0;                                                          %Faktor til temperaturberegning
            
            hstav=hcu/2+ndl*dicu+2*dij;                                     %Beregner hyde av stav
            
        end

        if tnr~=1

            Ss=Ssxls*1e6;
            hcus=hcusxls/1e3;                                               %Gjr om til millimeter
            hspk=hspkxls;                                                   %Hyde p sporkile
            hm=hmxls;                                                       %Hyde p mellomstrimmel
            hgls=hglsxls;                                                   %Hyde glidestrimmel
            hds=hdsxls;                                                     %Hyde mellom sporkile og luftgap
            dij=dijxls;                                                     %Jordisolasjon
            Uturn=Un/(sqrt(3)*Ns);                                          %Spenning mellom hver vinding
            ndlp=ndlpxls;                                                   %Antall delledere i parallell
            ndlh=ndlhxls;                                                   %Antall delledere i hyden per turn
            diw=diwxls;
            dicu=dicuxls;                                                   %Runder av til nrmeste tiendedels milimeter
            bcus=bcusxls;                                                   %Bredde p hver delleder
            bcu=bcus*ndlp/ndlh;                                             %Kobberbredde
            ndl=ndlxls;                                                     %Finner antall delledere
            hcu=2*tnr*ndlh*hcus;                                            %Total hyde med kobber i hvert spor
            hs=hsxls;                                                       %Sporhyde
                                                                  
            fsp=round(0.14*Uturn)/1e4;                                      %Faktor til temperaturberegning

            hstav=hcu/2+2*ndlh*tnr*dicu+2*dij;                              %Beregner hyde av stav
        end
    else
        if tnr==1


            Ss=Ssxls*1e6;                                                   %Strmtetthet i spor
            hcus=hcusxls/1e3;                                               %Hyde p en delleder
            hspk=0.006;                                                     %Hyde p sporkile
            hm=0.007;                                                       %Hyde p mellomstrimmel
            hgls=0.002;                                                     %Hyde p glidestrimmel
            hds=0.001;                                                      %Hyde avstand mellom sporkile og luftgap
            drs=0.0005;                                                     %Bredde p rbelseparator
            dij=0.0003+2.35e-7*Un;                                          %Beregner jordisolasjon
            dicu=0.0001;                                                    %Dellederisolasjon 1.-sidig
            bcus=(bu-2*dij-4*dicu-drs)/2;                                   %Bredde p en delleder
            bcu=bcus*2;                                                     %Beregner kobberbredde for sporet
            ndl=(Ic/(Ss*bcus*hcus));                                        %Mellomregning for antall delledere
            ndl=round(ndl/2);                                               %Mellomregning for antall delledere
            ndl=ndl*2;                                                      %Antall delledere
            ndlp=2;
            ndlh=1;
            Ss=In/(ndl*bcus*hcus);                                          %Ny strmtetthet i stator
            hcu=hcus*ndl;                                                   %Total kobberhyde i et spor
            hs=hcu+ndl*dicu+hm+hspk+hgls+hds+4*dij;                         %Hyde av sporet
            diw=0;                                                          %Turnisolasjon i tillegg til lakkisolasjon
            
            fsp=0;                                                          %Faktor til temperaturberegning
            
            hstav=hcu/2+ndl*dicu+2*dij;                                     %Beregner hyde av stav
        end

        if tnr~=1

            Ss=Ssxls*1e6;
            hcus=hcusxls/1e3;                                               %Gjr om til millimeter
            hspk=0.006;                                                     %Hyde p sporkile
            hm=0.007;                                                       %Hyde mellomstrimmel
            hgls=0.002;                                                     %Hyde glidestrimmel
            hds=0.001;                                                      %Hyde mellom sporkile og luftgap
            dij=0.0003+2.35e-7*Un;                                          %Jordisolasjon
            Uturn=Un/(sqrt(3)*Ns);                                          %Spenning mellom hver vinding
            diw=0;                                                          %Turnisolasjon i tillegg til lakkisolasjon
            dicu=0.0002;                                                    %Runder av til nrmeste tiendedels milimeter
            bcus=(bu-2*dij-2*dicu-2*diw);                                   %Bredde p hver delleder
            ndlp=ceil(Ic/(tnr*Ss*bcus*hcus));                               %Finner antall delledere
            ndlh=ndlp;
            ndl=ndlp*tnr;                                                   %Beregner antall delledere per stav
            hcu=2*ndl*hcus;                                                 %Total hyde med kobber i hvert spor
            hs=hcu+2*ndl*dicu+hm+hspk+hgls+hds+4*dij+4*tnr*diw;             %Sporhyde
            bcu=bcus;                                                       %Kobberbredde
            
            fsp=round(0.14*Uturn)/1e4;                                      %Faktor til temperaturberegning

            hstav=hcu/2+2*ndl*dicu+2*dij;                                   %Beregner hyde av stav
        end
    end
        
    OBst=1.3*(0.135-0.003*Un/1000)*(1+0.02*(dTmx-60));                      %Tillatt overflatebelastning
    Acus=0.98*bcus*hcus*ndl/tnr;                                            %Kobberarealet av en stav
    OBsa=2.1e-12*Ic^2/(Acus*(bu+hs-hspk-hds));                              %Aktuell overflatebelastning    
    Ss=In/(pnr*Acus);                                                       %Strmtetthet
    Ssmm=Ss*1e-6;                                                           %Strmtetthet i [mm2]
    
    if OBsa>OBst
        disp('NB!: The winding surface loading is too high, the stator may overheat!')
        disp(' ');
    end
    
    [Nw,Dw]=rat(taups);                                                     %Beregner antall forskjellige spenningsvektorer (Westgaard Nw=N og Dw=U)
    Fw=Qs/Nw;
    
    qm=Qs/(3*Fw);                                                           %Bereger antall forskjellige spenningsvektorer
    kd=sin(pi/6)/(qm*sin(pi/(qm*6)));                                       %Beregner fordelingsfaktoren
      
    
    if yxls~=0
        Ww=yxls; 
    else
        disp(['The fullpitch coil span of this machine is ',num2str(taups),' slots '])
        disp(' ');
        Ww=input('Select the desired coil span (has to be an integer):');
        disp(' ');
    end
    
    kp=sin(Ww*pi/(taups*2));                                                %Beregner skrittforkortningsfaktor
    
    yQ=Ww/taups;                                                            %Relativt spoleskritt
    
    Y=1;
    N=2;
   
    if s~=0
    
        aksq=1;                                                             %Med skewing
    else
        aksq=2;                                                             %Uten skewing
    end
    
    disp(' ');

    if (aksq==1)                                                            %Beregner den totale viklingsfaktoren for en vikling med og uten skewing
        
        ksq=sin(s*pi/(taups*2))/(s*pi/(taups*2));                           %Skewing faktor
        kw=kd*kp*ksq;                                                       %Viklingsfaktor med skewing
              
    elseif (aksq==2)
    
        kw=kd*kp;                                                           %Viklingsfaktor uten skewing
        ksq=1;
        
    end
    
   
    FIm=Un/(sqrt(3)*4*kf*kw*f*Ns);                                          %Beregner masimal fluks gjennom faseviklingen % ndvendig flukst for  oppn nsket spenning i fasevikling
    
    if Bdeltaxls ~= 0 && lbxls == 0
        lb=km*FIm/(Bdeltaxls*taup);                                         %Beregning av brutto jernlengde
    end
        
    gamma=4e-7;                                                             %Faktor for  bestemme minimum luftgap
    
    if delta0xls~=0
        delta0=delta0xls/1e3;                                               %Minimum luftgap
    else
        delta0=gamma*taup*Amsdelta/0.95;                                    %Beregning av minimum luftgap % 0.95 = nsket maks flukstetthet
    end
    
    tauukj=bv+bcs;                                                          %Bredde p en kjlekanal i tillegg til blikkpakke
    nv=lb/(bv+bcs);                                                         %Beregning av antall kjlekanaler
    nv=round(nv);                                                                                                                       
    kckj=tauukj/(tauukj-((bv/delta0)/(5+(bv/delta0))*bv));                  %Karters koeffisient for kjlekanal
    bve=kckj*bv;                                                            %Ekvivalent bredde p luftgap    
    lm=lb-nv*bve+2*delta0;                                                  %Ekvivalent jernlengde
    lb=nv*bv+(nv+1)*bcs;                                                    %Brutto jernlengde
    ln=lb-nv*bv;                                                            %Netto jernlengde
    
    Bdelta=km*FIm/(lb*taup);                                                %Flukstetthet i luftgap
    
    hys=FIm/(2*kFe*ln*Bymx);                                                %Hyde p k
    
    Dy=Di+2*(hs+hys);                                                       %Yttre diameter p stator
    
    
%Beregning av Rac
rho75=2.165e-8;                                                             %Resistivitet for vikling ve 75 grader
rho20=1.78e-8;                                                              %Resistivitet for vikling ve 20 grader


%Rbelstav

    if tnrxls==1 
        if lavxls ~= 0                                                      %Vindingslengde (total vindingslengde per 2 staver)
            lav=lavxls;
        else
            lav=2*lb+tauu*Ww*2/cos(0.95);                                   %Kobberlengde per vinding
        end
                                                                        
        lfs=lav*Qs/(3*pnr);                                                 %Kobberlengde for en fasevikling
           
        Rdc=1.06*rho75*lfs/(Acus*pnr);                                      %DC-resistans for en fasevikling
        alphaKra=sqrt(pi*f*4*pi*1e-7*(1/(rho75))*(2*bcus/bu));              %Faktor for beregning av Rac
        zeta=alphaKra*hcus ;                                                %Faktor for beregning av Rac    
        mcu=ndl/2;    
        ficu=zeta*(sinh(2*zeta)+sin(2*zeta))/(cosh(2*zeta)-cos(2*zeta));    %Faktor for beregning av Rac
        psicu=2*zeta*(sinh(zeta)-sin(zeta))/(cosh(zeta)+cos(zeta));         %Faktor for beregning av Rac

        Krau=ficu+(((ndl/2)^2-1)/3)*psicu;                                  %Resistansfaktor for understav
        Krao=Krau*(1+(2*(mcu^2))/3*zeta^4);                                 %Resistansfaktor for overstav
        
        lrac=lb*Ns;                                                         %Beregning av lengden for den delen som ligger i sporet
        Rdcprm=Rdc/lfs;                                                     %DC-resistans per meter
          
        Raco=Krao*Rdcprm*lrac;                                              %Resistans for overstav
        Racu=Krau*Rdcprm*lrac;                                              %Resistans for understav
        
        Rac=Rdcprm*(lfs-2*lrac)+Raco+Racu;                                  %AC-resistans for viklingen                      
        
        Krad=ficu+((ndl)^2-1)/3*psicu;                                      %Resistansfaktor for viklingen i sporet (br vre mindre enn 1.15)
        Kra=Rac/Rdc;                                                        %Resistansfaktor for viklingen
        Kmx=1+0.294e8*(bcu/bu*hcu*hcus*f/50)^2;                             %Resistansfaktor for verste delleder
    
        Rdc20=Rdc/rho75*rho20;                                              %DC-resistans ved 20 grader
    else
        
        
%Formspole        

        if lavxls ~= 0
            lav=lavxls;
        else
            lav=tnr*(2*lb+4*taup*Ww/taups+0.5);
        end
        
        lfs=lav*Qs/3;                                                       %Lengde p
                
        Rdc=1.06*rho75*lfs/(Acus*pnr^2);
        alphaKra=sqrt(pi*f*4*pi*1e-7*(1/(rho75))*(bcu/bu));                 %Faktor for beregning av Rac
        zeta=alphaKra*hcus ;                                                %Faktor for beregning av Rac    
        ficu=zeta*(sinh(2*zeta)+sin(2*zeta))/(cosh(2*zeta)-cos(2*zeta));    %Faktor for beregning av Rac
        psicu=2*zeta*(sinh(zeta)-sin(zeta))/(cosh(zeta)+cos(zeta));         %Faktor for beregning av Rac
        Krad=ficu+((2*tnr*ndlh)^2-1)/3*psicu;
        
        if hsxls == 0 && tnr > 1
            Krau=ficu+(((ndl)^2-1)/3)*psicu;                                %Resistansfaktor for understav
            Krao=Krau*(1+(2*(ndl)^2)/3*zeta^4);                             %Resistansfaktor for overstav
        else
            Krau=ficu+(((ndl/2)^2-1)/3)*psicu;                              %Resistansfaktor for understav
            Krao=Krau*(1+(2*(ndl/2)^2)/3*zeta^4);                           %Resistansfaktor for overstav
        end    
        lrac=lb*Ns;                                                         %Beregning av lengden for den delen som ligger i sporet
        Rdcprm=Rdc*pnr^2/lfs;                                               %DC-resistans per meter
        Raco=Krao*Rdcprm*lrac;                                              %Resistans for overstav
        Racu=Krau*Rdcprm*lrac;                                              %Resistans for understav
        Rac=(Rdcprm*(lfs/pnr-2*lrac)+Raco+Racu)/pnr;                        %AC-resistans for viklingen 
        Kra=Rac/Rdc;                                                        %Resistansfaktor for viklingen
        
        Kmx=1+0.294e8*(bcu/bu*hcu*hcus*f/50)^2;                             %Resistansfaktor for verste delleder
        
        Rdc20=Rdc/rho75*rho20;                                              %DC-resistans ved 20 grader
    end
    
    disp('Stator Calculations Completed');
 

%Rotorberegninger
  

%Beregninger av dempeviklingen

    Nsp=Qs/(2*p)*0.7;                                                       %Antall statorspor over en rotorpol
    
    if(Nsp<7)                                                               %Valg av spordeling for dempeviklingen
        taur=0.85*tauu;                                                     %for  redusere harmoniske. nsker 
    else                                                                    %minimum 6 dempestaver
        taur=1.15*tauu;
    end
    
    if NDsxls ~= 0
        NDs=NDsxls;
    else
        NDs=floor(taup*0.7/taur);                                           %Antall dempestaver
    end
    
    IDtot=Vnmx*As*0.7*taup*(1-2/(NDs+2))/(NDs*100);                         %Maksimal strm per dempestav [A]
    SD=3;                                                                   %Tillatte strmtetthet i dempestavene [A/mm^2]
    AcuD=IDtot/(SD*1000000);                                                %Arealet av en dempestav [mm^2]
                                                                
    
%Ekvivalent luftgap

    kCs=tauu/(tauu-((bu/delta0)/(5+bu/delta0))*bu);                         %Carterskoeffisient for statorspor
    bD=0.003;                                                               %Sporpningen for dempestavene [m]
    kCr=taur/(taur-((bD/delta0)/(5+bD/delta0))*bD);                         %Carterskoeffiseint for rotorspor (dempevikling)
    kC=kCs*kCr;                                                             %Den totale Carterskoeffisienten
    delta0e=kC*delta0;                                                      %Ekvivalent luftgap [m]
    
%Poldimensjoner

                                                        
    taupr=alfar*taup;                                                       %Polbuebredde [m]
    rr=alfar*Di/2;                                                          %Polbueradius [m]
    
    if bpsxls ~= 0
        bps=bpsxls;
    else
        bps=2*rr*sin(taupr/(2*rr));                                         %Polskobredde [m]
    end
    
    if hpsxls ~= 0
        hps=hpsxls;
    else
        hps=0.05;                                                           %Polskohyde [m]
    end
    
    hpt=0.028;                                                              %Poltannhyde [m]
    
    if bpkxls ~= 0
        bpk=bpkxls;
    else
        bpk=1.8*hys;                                                        %Bredde p polkjerne (forelpig verdi)[m]
    end
    
    deltamx=1.5*delta0;                                                     %Maksimalt reelt luftgap [m]
    deltame=delta0e*(1+1/3*(1.5-1));                                        %Midlere ekvivalent luftgap [m]
    
    if hpkxls ~= 0
        hpk=hpkxls;
    else
        hpk=2*1.2/100+sqrt((2.1e-6*0.935)/((0.22+0.0055*pi*Di*ns/60)*...
            (1+0.016*(dTmx-60))*5.1))*(1e5/(4*pi)*Bdelta*...
            (Bdelta-0.1)^0.5*1.65*0.014*(delta0e/0.014)^0.85);              %Empirisk formel for hyden av polkjernen [m]
    end                                                                     
       
    
%Magnetiske beregninger

    Umdelta=Bdelta*delta0e/(my0);                                           %Magnetisk spenningsfall over luftgapet
    
    Sd=kFe*(lb-nv*bv)*bd;                                                   %Statortannens minsteareal
    Su=lm*tauu-Sd;                                                          %Statorsporets areal
    Bd=(lb*tauu*Bdelta/Sd)*0.99;                                            %Maksimal flukstetthet i statortennene
    FId=Sd*Bd;                                                              %Maksimal fluks i en statortann
    
    bdmin=bd;                                                               %Minste tannbredde [m]
    bdmax=(Di+2*hs)*pi/Qs-bu;                                               %Strste tannbredde [m]
    
    Bdmax=FId/(kFe*(lb-nv*bv)*(bdmin+(bdmax-bdmin)/hs*0));                  %Maksimal flukstettheten i statortennene som funksjon av hyden i sporet
    Bdmin=FId/(kFe*(lb-nv*bv)*(bdmin+(bdmax-bdmin)));
                                            
    INT=1;
    
    save('Test','hs','hys','FId','FIm','kFe','lb','nv','bv','bdmin',...
        'bdmax','INT','FeOldxls')                                           %Matrise for bruk i quad-funksjon

    Umd=quad(@Int,0,hs);                                                    %Integralberegning for magnetisk spenningsfall i spor
   
    Bys=FIm/(2*kFe*(lb-nv*bv)*hys)*sin(pi/2);                               %Flukstettheten i ket
    
    tauys=pi*(Dy-hys)/Np;                                                   %Lengden p fluksveien i ket
    INT=2;
    
    save('Test','hs','hys','FId','FIm','kFe','lb','nv','bv','bdmin',...
        'bdmax','INT','tauys','FeOldxls')
    
    Umys=quad(@Int,0,tauys);                                                %Integralberegning for magnetisk spenningsfall i k
       
    gamma2=pi/(Np);                                                         %Halv vinkel mellom to nabopoler i mekaniske grader
    taupt=2*((Di/2)-delta0-hps)*sin(gamma2)-bps*cos(gamma2);                % [m]
    taumx=2*((Di/2)-delta0-hps)*sin(gamma2)-bpk*cos(gamma2);                % [m]
    taumd=2*((Di/2)-delta0-hps-hpk/2)*sin(gamma2)-bpk*cos(gamma2);          % [m]
    taumn=2*((Di/2)-delta0-hps-hpk)*sin(gamma2)-bpk*cos(gamma2);            % [m]  
    Aps=4*my0*(lb*((0.5*deltamx+hpt)/taupt+(bps-bpk)*sin(gamma2)/...
        (taupt+taumx))+(hpt+2*hps)*bps/(3*(taupt+pi*bps/4)));               %Permeansen mellom polskoene for to nrliggende poler
                                                                            
    kl=1/((taumx/taumn-1)^2)*(1+(taumx/taumn-1)/2)*((taumx/taumn-1)...
        -log(1+(taumx/taumn-1)));                                           %Faktor som tar hensyn til liner stigning i drivende ampervindinger
                                                                            
    Apk=4*my0*kl*(lb*hpk/taumd+bpk*hpk/(taumd+pi*bpk/4));                   %Permeansen mollom polkjernene for to nrliggende poler    
    Asigma=Aps+Apk;                                                         %Total permeans mellom to nrliggende poler
    
    myrpk=1000;                                                             %Antatt permeabilitet for polkjernen
    myryr=2000;                                                             %Antatt permeabilitet for rotorringen
    hyr=FIm/(2*kFe*lb);                                                     %Hyde p rotorring nr nsket flukstetthet settes til 1.4T
    Dry=Di-2*(delta0+hps+hpk);                                              %Rotorringens ytre diameter
    tauyr=pi*(Dry-hyr)/(2*p);                                               %Midlere buelengde for rotorring mellom to nabopoler
    
    y=Ww*Np/Qs;                                                             %Relativt spoleskritt
    Fa=2.7*kw*In*Ns/Np;                                                     %Midlertidig ankerreaksjon
    Fdelta=1e6*Bdelta*delta0e/1.256;                                        %Midlertidig magntisk spenningsfall for luftgapet
    xadw=Fa*0.835/Fdelta;                                                   %Midlertidig realtiv ankerreaksjonsreaktans
    xlw=6.54e-7*Fa*lb/(FIm*kw^2)*(Np/Qs*(3*y+1)*(hs+dicu+dij+2*hspk)/...
        bu+3.6/Np*(3*y-1)*Di/lb)+1.1*Fa/Fdelta*(Np/Qs)^2+...
        (Np*deltame/Di)^2*xadw/2;                                           %Midlertidig relativ lekkreaktans
                                                                            
    xdw=xadw+xlw;                                                           %Midlertidig relativ synkronreaktans
    Ei=sqrt((1+xlw*sin(acos(Cosphi)))^2+(xlw*Cosphi)^2);                    %Midlertidig relativ indusert spenning
    Eb=sqrt((1+xdw*sin(acos(Cosphi)))^2+(xdw*Cosphi)^2);                    %Midlertidig relativ magnetisering
    Tetasigma=Eb*(Umdelta+Umd+Umys/2+FIm/(myrpk*bpk*lb)+FIm*tauyr/(...
        2*kFe*lb*hyr))/(1-(2*Asigma-Apk)/(2*myrpk*bpk*lb)-...
        (Asigma*tauyr/(2*kFe*lb*hyr)));                                     %Forelpig drivende amperevindinger for pollekkfluksen
                                                                            
    FIsigma=Asigma*Tetasigma;                                               %Pollekkfluksen
    FIsigmaps=Aps*Tetasigma;                                                %Lekkfluksen for polskoen
    Bdrmx=(Ei*FIm+FIsigma)/(bpk*lb);                                        %Flukstettheten i bunn av polkjernen
    Bdrmn=(Ei*FIm+FIsigmaps)/(bpk*lb);                                      %Flukstettheten i toppen av polkjernen
    Bxx=Bdrmx;
    
    FIL=(FIsigma/FIm)*100;                                                  %Prosentvis lekkfluks
    
    if FeOldxls ~= 0
        Hdrmx=-2250000*Bxx^6 + 18941667*Bxx^5 - 66025000*Bxx^4 + ...
            122029053*Bxx^3 - 126164843*Bxx^2 + 69200135*Bxx - 15733616;    %Feltstyrken i bunnen av polen
    else
        Hdrmx=(5627*Bxx^6-20591*Bxx^5+27732*Bxx^4-16559*Bxx^3+...
            4154*Bxx^2-172.71*Bxx+13.144);                                  %Feltstyrken i bunnen av polen med moderne blikk
    end
    
    Bxx=Bdrmn;
    
    if FeOldxls ~= 0
        Hdrmn=-2250000*Bxx^6 + 18941667*Bxx^5 - 66025000*Bxx^4 + ...
            122029053*Bxx^3 - 126164843*Bxx^2 + 69200135*Bxx - 15733616;    %Feltstyrken i toppen av polen
    else
        Hdrmn=(5627*Bxx^6-20591*Bxx^5+27732*Bxx^4-16559*Bxx^3+...
            4154*Bxx^2-172.71*Bxx+13.144);                                  %Feltstyrken i toppen av polen med moderne blikk
    end
    
    Umdr=(Hdrmx+Hdrmn)*hpk/2;                                               %Magnetisk spenningsfall for polkjernen
    
    Byr=(Ei*FIm+FIsigma)/(2*kFe*lb*hyr);                                   %Flukstettheten i rotorringen
    Bxx=Byr;
    
    if FeOldxls ~= 0
        Umyr=(-2250000*Bxx^6 + 18941667*Bxx^5 - 66025000*Bxx^4 + ...
            122029053*Bxx^3 - 126164843*Bxx^2 + 69200135*Bxx - ...
            15733616)*tauyr;
    else
        Umyr=(5627*Bxx^6-20591*Bxx^5+27732*Bxx^4-16559*Bxx^3+...
            4154*Bxx^2-172.71*Bxx+13.144)*tauyr;                            %Magnetisk spenningsfall i rotorringen
    end
    
    Umtot=Umdelta+Umd+Umdr+Umys/2+Umyr/2;                                   %Totalt magnetisk spenningsfall for en fluksvei

         
%Ankerreaksjonsinduktanser
    
    deltade=4*delta0e/pi;                                                   %Ekvivalent luftgap for d-akse
    deltaqe=2.4*deltade;                                                    %Ekvivalent luftgap for q-akse
    deltadef=Umtot*deltade/Umdelta;                                         %Inkluderer magnetisk spenningsfall i jernet i deltade
    deltaqef=Umtot*deltaqe/Umdelta;                                         %Inkluderer magnetisk spenningsfall i jernet i deltaqe
    
    kdx=0.835;                                                              %d-akse faktor
    kqx=0.47;                                                               %q-akse faktor
    
    Xma=my0*m*kw*q*2*tnr*In/(2*kf*pnr*delta0e*Bdelta);                      %Ankerreaksjonsreaktansen
    Lma=Xma*Rref/w;                                                         %Ankerraksjonsinduktansen
   
    Xmd=kdx*Xma;                                                            %Ankerreaksjonsreaktansen i d-aksen
    Xmq=kqx*Xma;                                                            %Ankerreaksjonsreaktansen i q-aksen
    
    Lmd=Xmd*Rref/w;                                                         %Ankerraksjonsinduktansen i d-aksen
    Lmq=Xmq*Rref/w;                                                         %Ankerraksjonsinduktansen i q-aksen
    

%Lekkinduktanser
    
    Ldelta=0;                                                                      
    harm(20,2)=0;
    harm(1,1)=1;
    harm(1,2)=kw;
    hk=2;
    
    if (aksq==1)                                                            
        
        for v=3:2:41
        kwsv=sin(v*Ww*pi/(2*taups))*(sin(v*pi/(m*2))/(qm*sin(v*pi/...
            (m*2*qm))))*(sin(v*s*pi/(taup*2))/(v*s*pi/(taup*2)));           %Viklingsfaktoren for v.-harmoniske
                                                                                
        harm(hk,1)=v;
        harm(hk,2)=kwsv;
                                                                            
        Ldeltav=my0*m*Di*lm/(pi*deltadef)*(Ns/p)^2*(kwsv/v)^2;
        Ldelta=Ldelta+Ldeltav;                                              %Luftgaplekkinduktansen
        hk=hk+1;
        end 
              
    elseif (aksq==2)
    
        for v=3:2:41
        kwsv=sin(v*Ww*pi/(2*taups))*(sin(v*pi/(m*2))/...
            (qm*sin(v*pi/(m*2*qm))));                                       %Viklingsfaktoren for v.-harmoniske 
                                                                               
        harm(hk,1)=v;
        harm(hk,2)=kwsv;
                                                                            
        Ldeltav=my0*m*Di*lm/(pi*deltadef)*(Ns/p)^2*(kwsv/v)^2;
        Ldelta=Ldelta+Ldeltav;                                              %Luftgaplekkinduktansen
        hk=hk+1;        
        end    
   
    end    
  
    hk3=1;
    
    
    for hk3=1:1:19                                                          %Beregning av maskinens harmoniske komponenter
        
        harma=harm(hk3,1);
        harmb=harm(hk3,2);
        harmb=abs((1/harma)*harmb);
        
        hk4=round(harma/3);
        hk44=harma/3;
        
        harm2(hk3,1)=harma;
        
        if hk4~=hk44
            harm2(hk3,2)=harmb*100;
            harm3(hk3,2)=harmb;
        end
    
    end
    
    THF=100*sqrt(harm3(1,2)^2*4.44e-5^2+harm3(2,2)^2*6.65e-3^2+...
        harm3(3,2)^2*55.6e-3^2+harm3(4,2)^2*0.165^2+harm3(5,2)^2*...
        0.327^2+harm3(6,2)^2*0.505^2+harm3(7,2)^2*0.61^2+harm3(8,2)^2*...
        0.895^2+harm3(9,2)^2*1.1^2+harm3(10,2)^2*1.32^2+harm3(11,2)^2*...
        1.46^2+harm3(12,2)^2*1.49^2+harm3(13,2)^2*1.53^2+harm3(14,2)^2*...
        1.57^2+harm3(15,2)^2*1.6^2+harm3(16,2)^2*1.63^2+harm3(17,2)^2*...
        1.66^2+harm3(18,2)^2*1.7^2+harm3(19,2)^2*1.72)^2;                   %Telephone Harmonic Factor fra statorvikling
        
    harm2(1,2)=0;
    
    sigmacu75=4.62e7;                                                       %Konduktans for kobber ved 70 grader C
    epsilon=1-Ww/taups;                                                     %Skrittforkortning i antall spor
    zt=ndl*2/(ndlp/ndlh);                                                   %Antall delledere i hyden i et spor
    ksi=hcu*sqrt(w*my0*sigmacu75*bcu/(2*bu));                               %Redusert lederhyde
    fimksi=3/(2*ksi)*((sinh(2*ksi)-sin(2*ksi))/(cosh(2*ksi)-cos(2*ksi)));   %Funksjon av ksi
    psimksi=1/ksi*((sinh(ksi)-sin(ksi))/(cosh(ksi)-cos(ksi)));              %Funksjon av ksi
    kL=(1/zt^2)*fimksi+((zt^2-1)/zt^2)*psimksi;                             %Skin effekt faktor
    g=1-3/2*epsilon;                                                        %Gjennomsnittlig faseforskyvning mellom to staver i ett spor
    k1=(5+3*g)/8;                                                           %Faktor for beregning av permeansfaktoren
    k2=(1+g)/2;                                                             %Faktor for beregning av permeansfaktoren
    h3=hgls+dij;                                                            
    lambdau=kL*k1*(hcu-hm)/(3*bu)+k2*(h3/bu+hds/bcu+hspk/(bu-bcu)*...
        log(bu/bcu))+hm/(4*bu);                                             %Permeansfaktoren for et spor med tolagsvikling
     
    Lu=(4*m/Qs)*my0*lm*Ns^2*lambdau;                                        %Sporlekkinduktansen
    
    lambdad=k2*(5*(deltame/bcu)/(5+4*(deltame/bcu)));                       %Permeansfaktoren for en tann
    
    Ld=(4*m/Qs)*my0*lm*Ns^2*lambdad;                                        %Tannlekkinduktansen
    
    lambdalew=0.477;                                                        %Permeansfaktor for spolehodet
    lambdaw=0.187;                                                          %Permeansfaktor for spolehodet
    Wewm=taup*Ww/taups;                                                     %Spoleskritt i meter
    Wew=0.6*Wewm;                                                           %Midlere spoleskritt for spolehodet
    lew=0.7*((lav/tnr-2*lb)/2-Wewm)/2;                                      %Aksial lengde av spolehodet
        
    Lw=(4*m/Qs)*q*my0*Ns^2*(2*lew*lambdalew+Wew*lambdaw);                   %Spolehodelekkinduktansen
    
    Lsq=(1-ksq^2)*Lmd;                                                      %Vridningslekkinduktans
    
    Lsigma=Ldelta+Lu+Ld+Lw+Lsq;                                             %Total lekkinduktans
    
     
 %Magnetiseringsbehov
    
    Inpu=1;                                                                 %pu verdi av nominell generatorstrm
    Unpu=1;                                                                 %pu verdi av nominell generatorspenning
    Racpu=Rac/Rref;                                                         %pu verdi av statorresistansen
    Xmdpu=Xmd;
    Xmqpu=Xmq;
    Xsigma=w*Lsigma/Rref;                                                   %pu verdi av lekkreaktansen    
    Xdpu=Xmdpu+Xsigma;                                                      %pu verdi av synkronreaksjonsreaktansen i d-aksen
    Xqpu=Xmqpu+Xsigma;                                                      %pu verdi av synkronreaksjonsreaktansen i q-aksen
    fi2=acos(Cosphi);                                                       %Faseforskyvning ved nominell last
    InpuCx=Inpu*(cos(fi2)-1i*sin(fi2));                                     %Kompleks nominell generatorstrm i pu
    EQpuCx=Unpu+(Racpu+1i*Xqpu)*InpuCx;
    delta2=atan(imag(EQpuCx)/real(EQpuCx));                                 %Lastvinkel
    beta2=delta2+fi2;
    Idpu=-Inpu*sin(beta2);                                                  %d-akse strm i pu
    VId=delta2-pi/2;                                                        %Vinkelen til d-akse strmmen
    IdpuCx=abs(Idpu)*cos(VId)+1i*abs(Idpu)*sin(VId);                        %Kompleks d-akse strm i pu
    EfpuCx=EQpuCx+1i*(Xdpu-Xqpu)*IdpuCx;                                    %Relativ magnetisering
    Efpu=abs(EfpuCx);
    
    Tetamn=Efpu*Umtot;                                                      %Totalt magnetiseringsbehov
    
    EipuCx=Unpu+(Racpu+1i*Xsigma)*InpuCx;
    Eipu=abs(EipuCx);                                                       %Relativ indusert spenning i belastning
    
    
%Feltviklingens konstruksjon

    OBrt=(0.22+0.0055*pi*Di*ns/60)*(1+0.016*(dTmx-60))*10000;               %Tillatte overflatebelatning for rotorviklingen
    
    hkr=0.007;                                                              %Hyden av feltkraven
    
    if bixls ~= 0
        bi=bixls;
    else
        bi=0.004;                                                           %Isolasjon mellom feltvikling og pol inkludert klaring
    end
       
    if bifxls ~= 0
        bif=bifxls;
    else
        bif=0.0003;                                                         %Isolasjonstykkelse for feltviklingen
    end
   
    if bcufxls ~= 0
        bcuf=bcufxls;
    else
        bcuf=(bps-bpk-3e-3)/2;                                              %Bredde p feltviklingen
    end
        
    if bcuf<=0.06 && bcufxls == 0
        bcuf=0.06;
    end
    
    Le=0.025;                                                               %Tykkelse av endeplate
    af=0.935;                                                               %Forhold mellom midlere p max vindingslengde for feltviklingen
    
    Sfm=Sfi*1e6;                                                            %nsket strmtetthet
    Sf=1;    
    aSf=abs(1-Sf/Sfm);
    aaSf=1;
    bcuf3=0;

if hfxls == 0 && hpkxls == 0

while aSf > 0.05                                                            %Slyfe for kning av feltviklingens strmtetthet
        
    if aaSf == 1
        hf=sqrt(2.1e-8*af/(OBrt*0.85*bcuf))*Tetamn/(1.3*...             
            (0.83/Bdelta+(Bdelta/0.8)^13*0.01));                            %Hyden av feltspolen                                                                            
    else
        hf=hf-hf*(1-Sf/Sfm);
    end
                                
    hpk2=hf+2*hkr;                                                         %Ny hyde p polkjernen
    ahpk=abs(1-hpk2/hpk);

   
    while ahpk > 0.05                                                       %Slyfe for iterasjon av polkjernehyden
        
        disp('Iteration on pole core hight was performed');
                
        hpk=hpk2;
    
        %Magnetiske beregninger

            Umdelta=Bdelta*delta0e/(my0);                                   %Magnetisk spenningsfall over luftgapet
    
            Sd=kFe*(lb-nv*bv)*bd;                                           %Statortannens minsteareal
            Su=lm*tauu-Sd;                                                  %Statorsporets areal
            Bd=(lb*tauu*Bdelta/Sd);                                         %Maksimal flukstetthet i statortennene
            FId=Sd*Bd;                                                      %Maksimal fluks i en statortann
    
            bdmin=bd;                                                       %Minste tannbredde [m]
            bdmax=(Di+2*hs)*pi/Qs-bu;                                       %Strste tannbredde [m]
    
            Bdmax=FId/(kFe*(lb-nv*bv)*(bdmin+(bdmax-bdmin)/hs*0));          %Maksimal flukstettheten i statortennene som funksjon av hyden i sporet
            Bdmin=FId/(kFe*(lb-nv*bv)*(bdmin+(bdmax-bdmin)));
                                            
            INT=1;
    
            save('Test','hs','hys','FId','FIm','kFe','lb','nv','bv',...
                'bdmin','bdmax','INT','FeOldxls')

            Umd=quad(@Int,0,hs);
   
            Bys=FIm/(2*kFe*(lb-nv*bv)*hys)*sin(pi/2);                       %Flukstettheten i ket
    
            tauys=pi*(Dy-hys)/Np;                                           %Lengden p fluksveien i ket
            INT=2;
    
            save('Test','hs','hys','FId','FIm','kFe','lb','nv','bv',...
                'bdmin','bdmax','INT','tauys','FeOldxls')
    
            Umys=quad(@Int,0,tauys);
    
            gamma2=pi/(Np);                                                 %Halv vinkel mellom to nabopoler i mekaniske grader
            taupt=2*((Di/2)-delta0-hps)*sin(gamma2)-bps*cos(gamma2);        % [m]
            taumx=2*((Di/2)-delta0-hps)*sin(gamma2)-bpk*cos(gamma2);        % [m]
            taumd=2*((Di/2)-delta0-hps-hpk/2)*sin(gamma2)-bpk*cos(gamma2);  % [m]
            taumn=2*((Di/2)-delta0-hps-hpk)*sin(gamma2)-bpk*cos(gamma2);    % [m]  
            Aps=4*my0*(lb*((0.5*deltamx+hpt)/taupt+(bps-bpk)*...
                sin(gamma2)/(taupt+taumx))+(hpt+2*hps)*bps/...
                (3*(taupt+pi*bps/4)));                                      %Permeansen mellom polskoene for to nrliggende poler
                                                                            
            kl=1/((taumx/taumn-1)^2)*(1+(taumx/taumn-1)/2)*...
                ((taumx/taumn-1)-log(1+(taumx/taumn-1)));                   %Faktor som tar hensyn til liner stigning i drivende ampervindinger
                                                                            
            Apk=4*my0*kl*(lb*hpk/taumd+bpk*hpk/(taumd+pi*bpk/4));           %Permeansen mollom polkjernene for to nrliggende poler    
            Asigma=Aps+Apk;                                                 %Total permeans mellom to nrliggende poler
    
            myrpk=1000;                                                     %Antatt permeabilitet for polkjernen
            myryr=2000;                                                     %Antatt permeabilitet for rotorringen
            hyr=FIm/(2*kFe*lb);                                             %Hyde p rotorring nr nsket flukstetthet settes til 1.4T
            Dry=Di-2*(delta0+hps+hpk);                                      %Rotorringens ytre diameter
            tauyr=pi*(Dry-hyr)/(2*p);                                       %Midlere buelengde for rotorring mellom to nabopoler
    
            y=Ww*Np/Qs;
            Fa=2.7*kw*In*Ns/Np;
            Fdelta=1e6*Bdelta*delta0e/1.256;
            xadw=Fa*0.835/Fdelta;                                           %Midlertidig realtiv ankerreaksjonsreaktans
            xlw=6.54e-7*Fa*lb/(FIm*kw^2)*(Np/Qs*(3*y+1)*(hs+dicu+dij+...
                2*hspk)/bu+3.6/Np*(3*y-1)*Di/lb)+1.1*Fa/Fdelta*...
                (Np/Qs)^2+(Np*deltame/Di)^2*xadw/2;                         %Midlertidig relativ lekkreaktans
                                                                            
            xdw=xadw+xlw;                                                   %Midlertidig relativ synkronreaktans
            Ei=sqrt((1+xlw*sin(acos(Cosphi)))^2+(xlw*Cosphi)^2);            %Midlertidig relativ indusert spenning
            Eb=sqrt((1+xdw*sin(acos(Cosphi)))^2+(xdw*Cosphi)^2);            %Midlertidig relativ magnetisering
            Tetasigma=Eb*(Umdelta+Umd+Umys/2+FIm/(myrpk*bpk*lb)+...
                FIm*tauyr/(2*kFe*lb*hyr))/(1-(2*Asigma-Apk)/...
                (2*myrpk*bpk*lb)-(Asigma*tauyr/(2*kFe*lb*hyr)));            %Forelpig drivende amperevindinger for pollekkfluksen
                                                                            
            FIsigma=Asigma*Tetasigma;                                       %Pollekkfluksen
            FIsigmaps=Aps*Tetasigma;                                        %Lekkfluksen for polskoen
            Bdrmx=(Ei*FIm+FIsigma)/(bpk*lb);                                %Flukstettheten i bunn av polkjernen
            Bdrmn=(Ei*FIm+FIsigmaps)/(bpk*lb);                              %Flukstettheten i toppen av polkjernen
            Bxx=Bdrmx;
            
            FIL=(FIsigma/FIm)*100;                                          %Prosentvis lekkfluks
            
            if FeOldxls ~= 0
                Hdrmx=-2250000*Bxx^6 + 18941667*Bxx^5 - 66025000*Bxx^4 +...
                    122029053*Bxx^3 - 126164843*Bxx^2 + 69200135*Bxx -...
                    15733616;
            else
                Hdrmx=(5627*Bxx^6-20591*Bxx^5+27732*Bxx^4-16559*Bxx^3+...
                    4154*Bxx^2-172.71*Bxx+13.144);                          %Feltstyrken i bunnen av polen
            end

            Bxx=Bdrmn;

            if FeOldxls ~= 0
                Hdrmn=-2250000*Bxx^6 + 18941667*Bxx^5 - 66025000*Bxx^4 +...
                    122029053*Bxx^3 - 126164843*Bxx^2 + 69200135*Bxx -...
                    15733616;
            else
                Hdrmn=(5627*Bxx^6-20591*Bxx^5+27732*Bxx^4-16559*Bxx^3+...
                    4154*Bxx^2-172.71*Bxx+13.144);                          %Feltstyrken i toppen av polen
            end

            Umdr=(Hdrmx+Hdrmn)*hpk/2;                                       %Magnetisk spenningsfall for polkjernen

            Byr=(Ei*FIm+FIsigma)/(2*kFe*lb*hyr);                            %Flukstettheten i rotorringen
            Bxx=Byr;

            if FeOldxls ~= 0
                Umyr=-2250000*Bxx^6 + 18941667*Bxx^5 - 66025000*Bxx^4 +...
                    122029053*Bxx^3 - 126164843*Bxx^2 + 69200135*Bxx -...
                    15733616;
            else
                Umyr=(5627*Bxx^6-20591*Bxx^5+27732*Bxx^4-16559*Bxx^3+...
                    4154*Bxx^2-172.71*Bxx+13.144)*tauyr;                    %Magnetisk spenningsfall i rotorringen
            end
            
            Umtot=Umdelta+Umd+Umdr+Umys/2+Umyr/2;                           %Totalt magnetisk spenningsfall for en fluksvei
    

    
        %Ankerreaksjonsinduktanser
    
            deltade=4*delta0e/pi;                                           %Ekvivalent luftgap for d-akse
            deltaqe=2.4*deltade;                                            %Ekvivalent luftgap for q-akse
            deltadef=Umtot*deltade/Umdelta;                                 %Inkluderer magnetisk spenningsfall i jernet i deltade
            deltaqef=Umtot*deltaqe/Umdelta;                                 %Inkluderer magnetisk spenningsfall i jernet i deltaqe
                
            kdx=0.835;
            kqx=0.47;
    
            Xma=my0*m*kw*q*2*tnr*In/(2*kf*pnr*delta0e*Bdelta);
            Lma=Xma*Rref/w;
            Xma=Fa/Umdelta;
            Lma=Xma*Rref/w;
    
            Xmd=kdx*Xma;
            Xmq=kqx*Xma;
    
            Lmd=Xmd*Rref/w;
            Lmq=Xmq*Rref/w;
    
            
        %Lekkinduktanser
    
            Ldelta=0;                                                                      
    
            if (aksq==1)                                                            
        
                for v=3:2:41
                kwsv=sin(v*Ww*pi/(2*taups))*(sin(v*pi/(m*2))/...
                    (qm*sin(v*pi/(m*2*qm))))*(sin(v*s*pi/(taup*2))/...
                    (v*s*pi/(taup*2)));                                     %Viklingsfaktoren for v.-harmoniske
                                                                                
                Ldeltav=my0*m*Di*lm/(pi*deltadef)*(Ns/p)^2*(kwsv/v)^2;
                Ldelta=Ldelta+Ldeltav;                                      %Luftgaplekkinduktansen
                end 
              
            elseif (aksq==2)
    
                for v=3:2:41
                kwsv=sin(v*Ww*pi/(2*taups))*(sin(v*pi/(m*2))/...
                    (qm*sin(v*pi/(m*2*qm))));                               %Viklingsfaktoren for v.-harmoniske
                                                                                
                Ldeltav=my0*m*Di*lm/(pi*deltadef)*(Ns/p)^2*(kwsv/v)^2;
                Ldelta=Ldelta+Ldeltav;                                      %Luftgaplekkinduktansen
                end    
   
            end

            sigmacu75=4.695e7;                                              %Konduktans for kobber ved 70 grader C
            epsilon=1-Ww/taups;                                             %Skrittforkortning i antall spor
            zt=(ndl/2+1);                                                   %Antall delledere i hyden i et spor
            ksi=hcu*sqrt(w*my0*sigmacu75*bcu/(2*bu));                       %Redusert lederhyde
            fimksi=3/(2*ksi)*((sinh(2*ksi)-sin(2*ksi))/(cosh(2*ksi)-...
                cos(2*ksi)));                                               %Funksjon av ksi
            psimksi=1/ksi*((sinh(ksi)-sin(ksi))/(cosh(ksi)-cos(ksi)));      %Funksjon av ksi
            kL=(1/zt^2)*fimksi+((zt^2-1)/zt^2)*psimksi;                     %Skin effekt faktor
            g=1-3/2*epsilon;                                                %Gjennomsnittlig faseforskyvning mellom to staver i ett spor
            k1=(5+3*g)/8;                                                   %Faktor for beregning av permeansfaktoren
            k2=(1+g)/2;                                                     %Faktor for beregning av permeansfaktoren
            h3=hgls+dij;                                                            
            lambdau=kL*k1*(hcu-hm)/(3*bu)+k2*(h3/bu+hds/bcu+hspk/...
                (bu-bcu)*log(bu/bcu))+hm/(4*bu);                            %Permeansfaktoren for et spor med tolagsvikling
                                                                            
            Lu=(4*m/Qs)*my0*lm*Ns^2*lambdau;                                %Sporlekkinduktansen
    
            lambdad=k2*(5*(deltame/bcu)/(5+4*(deltame/bcu)));               %Permeansfaktoren for en tann
    
            Ld=(4*m/Qs)*my0*lm*Ns^2*lambdad;                                %Tannlekkinduktansen
    
            lambdalew=0.477;                                                %Permeansfaktor for spolehodet
            lambdaw=0.187;                                                  %Permeansfaktor for spolehodet
            Wewm=taup*Ww/taups;
            Wew=0.6*Wewm;
            lew=0.7*((lav/tnr-2*lb)/2-Wewm)/2;
        
            Lw=(4*m/Qs)*q*my0*Ns^2*(2*lew*lambdalew+Wew*lambdaw);           %Spolehodelekkinduktansen
    
            Lsq=(1-ksq^2)*Lmd;                                              %Vridningslekkinduktans
    
            Lsigma=Ldelta+Lu+Ld+Lw+Lsq;                                     %Total lekkinduktans
             
    
        %Magnetiseringsbehov
            Inpu=1;                                                         %pu verdi av nominell generatorstrm
            Unpu=1;                                                         %pu verdi av nominell generatorspenning
            Racpu=Rac/Rref;                                                 %pu verdi av statorresistansen
            Xmdpu=Xmd;
            Xmqpu=Xmq;
            Xsigma=w*Lsigma/(Un^2/(Sn*1e6));    
            Xdpu=Xmdpu+Xsigma;                                              %pu verdi av synkronreaksjonsreaktansen i d-aksen
            Xqpu=Xmqpu+Xsigma;                                              %pu verdi av synkronreaksjonsreaktansen i q-aksen
            fi2=acos(Cosphi);                                               %Faseforskyvning ved nominell last
            InpuCx=Inpu*(cos(fi2)-1i*sin(fi2));                             %Kompleks nominell generatorstrm i pu
            EQpuCx=Unpu+(Racpu+1i*Xqpu)*InpuCx;
            delta2=atan(imag(EQpuCx)/real(EQpuCx));                         %Lastvinkel
            beta2=delta2+fi2;
            Idpu=-Inpu*sin(beta2);                                          %d-akse strm i pu
            VId=delta2-pi/2;                                                %Vinkelen til d-akse strmmen
            IdpuCx=abs(Idpu)*cos(VId)+1i*abs(Idpu)*sin(VId);                %Kompleks d-akse strm i pu
            EfpuCx=EQpuCx+1i*(Xdpu-Xqpu)*IdpuCx;                            %Relativ magnetisering
            Efpu=abs(EfpuCx);
    
            Tetamn=Efpu*Umtot;                                              %Totalt magnetiseringsbehov
    
            EipuCx=Unpu+(Racpu+1i*Xsigma)*InpuCx;
            Eipu=abs(EipuCx);
    
    
        %Feltviklingens konstruksjon

            OBrt=(0.22+0.0055*pi*Di*ns/60)*(1+0.016*(dTmx-60))*10000;       %Tillatte overflatebelatning for rotorviklingen
    
            hkr=0.007;                                                      %Hyden av feltkraven
            
            if bixls ~= 0
                bi=bixls;
            else
                bi=0.004;                                                   %Isolasjon mellom feltvikling og pol inkludert klaring
            end

            if bifxls ~= 0
                bif=bifxls;
            else
                bif=0.0003;                                                 %Isolasjonstykkelse for feltviklingen
            end                                                             %Isolasjonstykkelse for feltviklingen
                       
            if bcufxls ~= 0
                bcuf=bcufxls;
            else
                bcuf=(bps-bpk-3e-3)/2;
            end
        
            if bcuf<=0.06 && bcufxls == 0
                bcuf=0.06;
            end
            
            Le=0.025;                                                       %Tykkelse av endeplate
            af=0.935;                                                       %Forhold mellom midlere p max vindingslengde for feltviklingen
    
            if aaSf ==1
                hf=sqrt(2.1e-8*af/(OBrt*0.85*bcuf))*Tetamn/(1.3*...
                    (0.83/Bdelta+(Bdelta/0.8)^13*0.01));                    %Hyden av feltspolen
                Tetamn2=Tetamn;
                OBrt2=OBrt;
            end
            
            hpk2=hf+2*hkr;                                                  %Ny hyde p polkjernen
            ahpk=abs(1-hpk2/hpk);

    end
    
    hpk=hpk2;    
    
    if aaSf == 1
        Afnf=2.1e-8*Tetamn^2*af/(OBrt*hf*(1.3*(0.83/Bdelta+...
            (Bdelta/0.8)^13*0.01))^2);                                      %Ndvendig kobbertverrsnitt for feltvikling [m^2]
    else
        Afnf=Afnf-Afnf*(1-Sf/Sfm);                                          %Ndvendig kobbertverrsnitt for feltvikling [m^2]
    end
    
    aaSf=2;
    Lfp=lb+2*0.008;                                                         %Indre lengde av feltvikling [m]
    bf=bpk+2*0.004;                                                         %Indre bredde av feltvikling [m]
    Lfmd=2*(Lfp+bf+2*bcuf);                                                 %Midlere vindingslengde [m]
    
    if nfxls ~= 0
        nf=nfxls;
    else
        nf=round(Vf*Afnf/(2.1e-8*Lfmd*Np*Tetamn));                          %Antall turn i feltviklingen
    end
    
    if hcufxls ~= 0
        hcuf=hcufxls;                                                       %Hyden av en feltvinding [m]
    else
        hcuf=(hf-bif*(nf-1))/nf;                                            %Hyden av en feltvinding [m]
    end
 
    if bcuf3 == 0 
        
        if bcufxls == 0
            
            bcuf2=Afnf/(nf*hcuf);                                           %Ny bredde p feltviklingen [m]

            if bcuf2 <= 0.06
                bcuf2=0.06;
            end

            abcuf=abs(1-bcuf/bcuf2);

            if abcuf>0.1
                disp(['NB!: bcuf deviate from original value with '...
                    ,num2str(abcuf*100),'%']);
                disp(' ');
            end

            bcuf=bcuf2;
        end
        
        Af=hcuf*(bcuf-(1-pi/4)*hcuf);                                       %Tverrsnitt av en feltvikling [m^2]
        Lfmd=2*(Lfp+bf+2*bcuf);                                             %Ny midlere vindingslengde [m]
        Lfmx=Lfmd+2*bcuf;                                                   %Maksimal vindingslengde [m]
    
        OBra=(2.1e-8*Tetamn*Lfmd/(Af*nf*hf*Lfmx))*10000;                    %Aktuell overflatebelastning [W/m^2]
    
        if OBra>OBrt
            disp('NB!: Rotor winding surface load is too high, rotor may overheat!');
            disp(' ');
        end
    
        polklaring=2*((Di/2-delta0-hps-hpk+hkr)*tan(gamma2)-...
            bpk/2-bi-bcuf)*cos(gamma2);                                     %Polklaringen
        
        If=Tetamn/nf;                                                       %Strmmen i feltviklingen
        Sf=Tetamn/(Af*nf);                                                  %Rotorviklingens strmtetthet [A/m^2]
    end
    
    if (polklaring > 0.05 && bcufxls == 0 && bcuf <= 0.065) ||...
            (bcuf3 ~= 0 && bcufxls == 0)
        bcuf3=Afnf/(nf*hcuf);                                               %Ny bredde p feltviklingen [m]
        if bcuf3 <= 0.07
            bcuf3=0.07;
        end
            
        abcuf=abs(1-bcuf/bcuf2);
    
        if abcuf>0.1
            disp(['NB!: bcuf deviate from original value with '...
                ,num2str(abcuf*100),'%']);
            disp(' ');
        end
        
        bcuf=bcuf3;
        
        Af=hcuf*(bcuf-(1-pi/4)*hcuf);                                       %Tverrsnitt av en feltvikling [m^2]
        Lfmd=2*(Lfp+bf+2*bcuf);                                             %Ny midlere vindingslengde [m]
        Lfmx=Lfmd+2*bcuf;                                                   %Maksimal vindingslengde [m]
    
        OBra=(2.1e-8*Tetamn*Lfmd/(Af*nf*hf*Lfmx))*10000;                    %Aktuell overflatebelastning [W/m^2]
    
        if OBra>OBrt
            disp('NB!: Rotor winding surface load is too high, rotor may overheat!');
            disp(' ');
        end
    
        polklaring=2*((Di/2-delta0-hps-hpk+hkr)*tan(gamma2)-bpk/2-bi-bcuf)*cos(gamma2);
        
        If=Tetamn/nf;                                                       %Strmmen i feltviklingen
        Sf=Tetamn/(Af*nf);                                                  %Rotorviklingens strmtetthet [A/m^2]
    end                                                      
    
    aSf=abs(1-Sf/Sfm);
end

else
    hf=hfxls;
    Lfp=lb+2*0.008;                                                         %Indre lengde av feltvikling [m]
    bf=bpk+2*0.004;                                                         %Indre bredde av feltvikling [m]
    Lfmd=2*(Lfp+bf+2*bcuf);                                                 %Midlere vindingslengde [m]
    
    if nfxls ~= 0
        nf=nfxls;
    else
        Afnf=2.1e-8*Tetamn^2*af/(OBrt*hf);                                  
        nf=round(Vf*Afnf/(2.1e-8*Lfmd*Np*Tetamn));                          %Antall turn i feltviklingen
    end
    
    if hcufxls ~= 0
        hcuf=hcufxls;
    else
        hcuf=(hf-bif*(nf-1))/nf;                                            %Hyden av en feltvinding [m]
    end
    
    Af=hcuf*(bcuf-(1-pi/4)*hcuf);                                           %Tverrsnitt av en feltvikling [m^2]
    Lfmd=2*(Lfp+bf+2*bcuf);                                                 %Ny midlere vindingslengde [m]
    Lfmx=Lfmd+2*bcuf;                                                       %Maksimal vindingslengde [m]

    OBra=(2.1e-8*Tetamn*Lfmd/(Af*nf*hf*Lfmx))*10000;                        %Aktuell overflatebelastning [W/m^2]
    
    if OBra>OBrt
        disp('NB!: Rotor winding surface load is too high, rotor may overheat!');
        disp(' ');
    end

    If=Tetamn/nf;                                                           %Strmmen i feltviklingen
    Sf=Tetamn/(Af*nf);                                                      %Rotorviklingens strmtetthet [A/m^2]
end

    Sfmm=Sf/1e6;
    
    if Sf>3.6e6
        disp(['NB!: Rotor winding current density is '...
            ,num2str(Sf/1000000),'A/mm^2!']);
        disp(' ');
    end
    
    polklaring=2*((Di/2-delta0-hps-hpk+hkr)*tan(gamma2)-...
        bpk/2-bi-bcuf)*cos(gamma2);                                         %Polklaring
   

    if polklaring < 0.001
        disp(['NB!: There is not enough space between the field windings. Smallest distance between windings is ',num2str(polklaring),'m']);
        disp(' ');
    end
    
    disp('Rotor Calculations Completed');
    
    
%Tapsberegninger
 
    
%Kobbertap
    
    Pcusdc=3*Rdc*In^2;                                                      %DC kobberstap i statorvikling
    Pcusdckw=Pcusdc/1000;
    Pcusac=3*(Rac-Rdc)*In^2;                                                %AC kobberstap i statorvikling
    Pcusackw=Pcusac/1000;
    
    Rrdc=2.165e-8*nf*Np*Lfmd/Af;                                            %Rotorresistans             
    Pr=Rrdc*If^2;                                                           %Rotortap                   
    Prkw=Pr/1000;
    Pre=Pr/Lfmd*2*(bf+2*bcuf);                                              %Rotortap p ende av polen
    Prl=Pr-Pre;                                                             %Rotortap langs polen
    
    Prnl=Pr/Efpu;                                                           %Kobbertap i rotor i tomgang
    Prnlkw=Prnl/1000;
    Prfl=Pr-Prnl;                                                           %Tillegg for rotortap ved merkedrift
    Prflkw=Prfl/1000;
    
    
%Jerntap                                                   

    kFey=1.6;                                                               %Faktor for  ta hensyn til metning i k
    kFed=2;                                                                 %Faktor for  ta hensyn til metning i tann
    
    if P10xls ~= 0                                                          %Jernap per kilo stl[W/kg]
        P10=P10xls;
    else
        P10=1.07;                                                           
    end
    
    mFe=pi*((Dy/2)^2-(Di/2+hs)^2)*ln*7.75e3*kFe;                            %Total masse for blikket i stator (uten tenner)                   
    mds=((bdmax+bdmin)/2)*hs*ln*Qs*7.75e3*kFe;                              %Massen til tenner             
    PFey=kFey*P10*Bys^2*mFe;                                                %Jerntap i k
    PFed=kFed*P10*((Bdmax+Bdmin)/2)^2*mds;                                  %Jerntap i tenner                                 
    PFe=(f/50)^1.3*(PFey+PFed);                                             %Totalt jerntap i k
    PFekw=PFe/1000;
    
    
%Tap i magnetisering
    
    if Pmagnxls ~= 0                                                        %Beregning av megnetiseringstap
        Pmagnkw=Pmagnxls;
        Pmagn=Pmagnkw*1000;
    else
        Pmagn=Pr*0.07;
        Pmagnkw=Pmagn/1000;
    end
    

%Luftfriksjonstap    
    
    myair=1.93e-5;                                                          %Viskositet for luft i 40 grader
    kmek=1.4;                                                               %Overflatekonstant som forteller hvor ujevn overflaten er varier mellom 1 og 1,4
    wm=ns*2*pi/60;                                                          %Mekanisk vinkelfrekvens
    rhoth=1.13;                                                             %Tettheten til luft ved 40graderC
    Dri=0.3;                                                                %Ytre diameter p aksling
    kpw=10;                                                                 %Varierer mellom 5 og 15. Er avhening av kjling
    
        Rlsdelta=rhoth*wm*(Di-deltame)*deltame/(2*myair);                   %Reynoldnummer for rotoroverflaten
    
    if Rlsdelta<64  
        
        Cm=10*(2*deltame/(Di-deltame))^0.3/Rlsdelta;
        
    end
    
    if 64<Rlsdelta<5e2
       
        Cm=2*(2*deltame/(Di-deltame))^0.3/Rlsdelta^0.6;
        
    end
    
    if 5e2<Rlsdelta<1e4
        
        Cm=1.03*(2*deltame/(Di-deltame))^0.3/Rlsdelta^0.5;
        
    end
    
    if Rlsdelta>1e4
       
        Cm=0.065*(2*deltame/(Di-deltame))^0.3/Rlsdelta^0.2;
        
    end
    
    Prhow1=1/32*kmek*Cm*pi*rhoth*wm^3*(Di-deltame)^4*lb;                    %Overflatetap rotor
    
    Rlrdelta=rhoth*wm*(Di-deltame)^2/(4*myair);                             %Reynoldnummer for ende p rotor
    
    if Rlrdelta<3e5
    
        Cm2=3.87/Rlrdelta^0.5;
    
    end
    
    if Rlrdelta>3e5
        
        Cm2=0.146/Rlrdelta^0.5;
    
    end
    
    Prhow2=1/64*Cm2*rhoth*wm^3*((Di-deltame)^5-Dri^5);                      %Overflatetap rotorende
    
    Prhow=Prhow1+Prhow2;     
    
%Tilleggstap
    
    Padd=0.0028*Sn*1e6*Cosphi+Prhow;                                        %Tilleggstap, varierer mellom 0,1% til 0,2% av levert effekt
    Paddkw=Padd/1000;                                                       %Tillegstapet bestr at fieldske tap i endeplater, polsko, statorkonstruksjon og AC-tap i spolehodene 
    
    
%Lager og viftetap

    kvw=(1.7+0.4*Di)*(1.75/Di)^0.1*(ns/428)^0.4;                            %Faktor for beregning av lagertap og viftetap    
    Pfw=800*kvw*Di^3*ns^2*sqrt(lb)*1e-5;                                    %Lager og viftetap
    Pfwkw=Pfw/1000;
    
    
%Totale tap
    
    Pwarming=Pcusac+Pcusdc+PFe+Pr+Padd;                                     %Tap som frer til oppvarming av kjleluft
    Ptot=Pcusac+Pcusdc+PFe+Padd+Pr+Pfw+Pmagn;                               %Totale tap
    Ptotkw=Ptot/1000;
    
    P=Sn*1e6*Cosphi;
    Eff=(P/(Ptot+P))*100;                                                   %Virkningsgrad

    
%Termiske beregninger
    

%Beregning av temperatur og ndvendig kjleluft
    
    cp=1.0;                                                                 %Spesifikk varmekapasitit for kjleluften [kJ/kg K]
    thc=0.2;                                                                %Termisk ledningsevne for den elektriske isolasjonen
    rhoth=1.13;                                                             %Kjleluftens tetthet ved 40 grader C [kg/m^2]
    lambdaair=0.025;                                                        %Termisk konduktivitet for kjleluften
    myair=1.93e-5;                                                          %Dynamisk viskositet for kjleluften
    Pqth=Pwarming;                                                          %Tap som m fraktes ut av maskinen
    aqth1=0;
    aqth2=0;
    
    while aqth1 == 0
        if qthxls == 0 && aqth2 == 0
            qth=2*Pqth/(rhoth*cp*dTmx);                                     %Ndvendig kjleluftstrm [m^3/s]
        elseif qthxls == 0 && aqth2 == 1
            qth=qth+1000;
        else
            qth=qthxls*1000;
            aqth1=1;
        end

        Rqth=1/(2*rhoth*cp*qth);

        Amin=Di*pi*nv*bv*bd/tauu;
        vim=qth/(1000*Amin);                                                %Hastigheten p kjleluften i kjlekanalene mellom stavene
        vi=vim*(Di/(1+budbd))/(Di+2*hs);                                    %Hastigheten p kjleluften i kjlekanalene bak staven
        vy=vim*(Di/(1+budbd))/(Dy);                                         %Hastigheten p kjleluften i kjlekanalene ved ytre diameter
        vmid=(vi+vy)/2;                                                     %Midlere hastigheten p kjleluften i kjlekanalene

    %Rth1
        ath1=350;                                                           %Varmeoverfringskoeffisient mellom statorramme og statorblikk [W/(K m^2)]
        lth1=40;                                                            %Termisk konduktivitet for strukturstl [W/(K m)]
        d1=0;                                                               %Tykkelsen p materialet som varmestrmmen m passere [m]
        h1=Dy*pi;                                                           %hyden av objektet [m]
        l1=ln;                                                              %Lengden av objektet [m]
        G1=h1*l1/(d1/lth1+1/ath1);                                          %Varmeledningskonduktansen for Rth1 [K/W]
        Rth1=1/G1;                                                          %Varmeledningsmotstanden mellom statorblikket og statorrammen [W/K]
        
    %Rth2, Rth4, Rth5 og Rth6
        lth2=32;                                                            %Termisk konduktivitet for blikket i samme reting som lamineringene
        lth4=0.6;                                                           %Termisk konduktivitet for blikket normalt p lamineringene
        d2=(Dy/2-Di/2-hs)/2;
        d4=bcs/2;                                                              
        h2=pi*(Dy-d2*2);
        l2=ln;
        S4=pi*((Dy/2)^2-(Di/2+hs)^2);                                                                     
        G2=1/(d4/(lth4*S4));
        R2=d2/(lth2*h2*l2);
        Rth2=sqrt(R2/G2)*tanh(sqrt(R2*G2)/2);                               %Varmeledningsmotstand fra midt i blikket og ut til ytre diameter
        Rth4=1/G2;                                                          %Varmeledningsmotstand fra midten av en blikkpakke og til nrmeste kjlekanal
        Rth5=1/G2*(sqrt(R2*G2)/sinh(sqrt(R2*G2))-1);                        %Varmeledningsmotstand for varme produsert i statorblikket
        Rth6=Rth2;    
    
    %Rth3
        %vv=8.75;                                                           %Lufthastigheten i kjlekanalene [m/s]
        ath3=7*sqrt(vmid/(Dy/2-Di/2-hs));                                                           
        lth3=32;                                                            
        d3=0;                                                    
        S3=2*pi*((Dy/2)^2-(Di/2+hs)^2);                                                            
        G3=S3/(d3/lth3+1/ath3);
        Rth3=1/G3;                                                          %Varmeoverfringsmotstanden mellom statorblikket og luftstrmmen i en kjlekanal

    %Rth8                                                              
        ath8=7.97*sqrt(vmid/(hs));                                                                                                               
        S8=2*hs*Qs*(bdmax+bdmin)/2;                                                            
        G8=S8*ath8;
        Rth8=1/G8;                                                          %Varmeoverfringsmotstanden mellom statortennene og luftstrmmen i en kjlekanal
        
    %Rth7, Rth9, Rth10 og Rth14
        lth7=32;                                                            %Termisk konduktivitet for blikket i samme reting som lamineringene
        lth9=0.6;                                                           %Termisk konduktivitet for blikket normalt p lamineringene
        d7=hs/2;
        d9=bcs/2;                                                              
        h7=pi*(Di+d7);
        l7=ln;
        S9=hs*Qs*(bdmax+bdmin)/2;
        G7=1/(d9/(lth9*S9));
        R7=d7/(lth7*h7*l7);
        Rth7=sqrt(R7/G7)*tanh(sqrt(R7*G7)/2);                               %Varmeledningsmotstand fra midt i blikket og ut til ytre diameter
        Rth9=1/G7;                                                          %Varmeledningsmotstand fra midten av en blikkpakke og til nrmeste kjlekanal
        Rth10=1/G7*(sqrt(R7*G7)/sinh(sqrt(R7*G7))-1);                       %Varmeledningsmotstand for varme produsert i statorblikket
        Rth14=Rth7;  
    
    %Rth11
        ath11=180;                                                          %Varmeoverfringskoffisienten mellom statorvikling og statorblekk
        S11=hs*ln*2*Qs;
        G11=S11*ath11;
        Rth11=1/G11;                                                        %Varmeoverfringsmotstanden mellom statorviklingen og statortennene
    
    %Rth12, Rth15, Rth20 og Rth21
        lth12=thc;                                                          %Termisk konduktivitet for vindingsisolasjonen (typisk verdi)
        lth15=394;                                                          %Termisk konduktivitet for kobber (elektroteknisk)
        d12=dij+dicu+diw+fsp;
        d15=lb/2;                                                              
        dl12=bcu/2;
        S12=(hs-hspk-hgls-hds+(bu+bcu)/2)*2*lb*Qs;
        Sl12=(hcu*3/4+bcu*3/4)*2*lb*Qs;
        S15=hcu*bcu*Qs;                                                       
        G15=1/(d12/(lth12*S12)+dl12/(lth15*Sl12));
        R15=d15/(lth15*S15);
        Rth12=1/G15;                                                        %Varmeledningsmotstand fra midt i staven og ut til yttersiden av isolasjonen
        Rth15=1/G15*(sqrt(R15*G15)/sinh(sqrt(R15*G15))-1);                  %Varmeledningsmotstand fra midten av en stav til endene av staven
        Rth20=sqrt(R15/G15)*tanh(sqrt(R15*G15)/2);                          %Varmeledningsmotstand for varme produsert i statorviklingen
        Rth21=Rth20;  
    
    %Rth13
        if tnr ~= 1
            ath13=17.39*sqrt(vim/(hs));
        else
            ath13=24.39*sqrt(vim/(hs));
        end
        S13=2*(hs+bu)*bv*nv*Qs;                                                            
        G13=S13*ath13;
        Rth13=1/G13;                                                        %Varmeoverfringsmotstanden mellom statorstavene og luftstrmmen i en kjlekanal
        
    %Rth16 og Rth25
        deltath16=hspk+hgls+hds+delta0+hps+hkr;
        Ta=rhoth^2*(ns*(2*pi)/60)^2*Di/2*deltath16^3/myair^2;
        Fg=pi^4*((Di-2.304*deltath16)/(Di-deltath16))/(1697*(0.0056+...
            0.0571*((Di-2.304*deltath16)/(Di-deltath16))^2)*...
            (1-deltath16/Di)^2);
        
        Tam=Ta/Fg;
        
        if Tam < 1700
            Nu=2;
        elseif 1700 < Tam < 1e4
            Nu=0.128*Tam^0.367;
        elseif 1e4 < Tam < 1e7    
            Nu=0.409*Tam^0.241;
        end
        
        ath16=1.23*Nu*lambdaair/deltath16;
        lspolh=(lav/tnr-2*lb)/2;
        S16=(hstav+bu)*2*lspolh*Qs;
        G16=S16*ath16;
        Rth16=1/G16;                                                        %Varmeovergangsmotstand fra spolehodene til kjleluften i spolehodeomrdet
        Rth25=Rth16;                                                        %Varmeovergangsmotstand fra spolehodene til kjleluften i spolehodeomrdet
    
    %Rth17, Rth18, Rth19, Rth22, Rth23 og Rth24
        lth17=thc;                                                          %Termisk konduktivitet for vindingsisolasjonen (typisk verdi)
        lth18=394;                                                          %Termisk konduktivitet for kobber (elektroteknisk)
        d17=dij+dicu;
        d18=lspolh/2;                                                              
        dl17=bcu/2;
        S17=(hstav+bu)*2*lspolh*Qs;
        Sl17=(hcu/4+bcu/2)*2*lspolh*Qs;
        S18=hcu/2*bcu*Qs;                                                          
        G18=1/(d17/(lth17*S17)+dl17/(lth18*Sl17));
        R18=d18/(lth18*S18);
        Rth17=1/G18;                                                        %Varmeledningsmotstand fra midt i spolehodet og ut til yttersiden av isolasjonen
        Rth19=sqrt(R18/G18)*tanh(sqrt(R18*G18)/2);                          %Varmeledningsmotstand fra midten av et spolehode til endene av spolehodet
        Rth18=1/G18*(sqrt(R18*G18)/sinh(sqrt(R18*G18))-1);                  %Varmeledningsmotstand for varme produsert i spolehodet
        Rth22=Rth19;                                                        %Varmeledningsmotstand for varme produsert i spolehodet
        Rth23=Rth18;                                                        %Varmeledningsmotstand fra midten av et spolehode til endene av spolehodet
        Rth24=Rth17;                                                        %Varmeledningsmotstand fra midt i spolehodet og ut til yttersiden av isolasjonen
        
    %Rth26 og Rth27
        Ta=rhoth^2*(ns*(2*pi)/60)^2*Di/2*(deltame/kC)^3/myair^2;
        Fg=pi^4*((Di-2.304*(deltame/kC))/(Di-(deltame/kC)))/...
            (1697*(0.0056+0.0571*((Di-2.304*(deltame/kC))/...
            (Di-(deltame/kC)))^2)*(1-(deltame/kC)/Di)^2);
        
        Tam=Ta/Fg;
        
        if Tam < 1700
            Nu=2;
        elseif 1700 < Tam < 1e4
            Nu=0.128*Tam^0.367;
        elseif 1e4 < Tam < 1e7    
            Nu=0.409*Tam^0.241;
        end
        
        ath26=1.25*Nu*lambdaair/(deltame/kC);
        ath27=ath26*2;
        S26=Di*pi*ln*bd/tauu;
        S27=taupr*lb*Np;
        G26=S26*ath26;
        G27=S27*ath27;
        Rth26=1/G26;                                                        %Varmeovergangsmotstand fra statorens til kjleluftstrmmen i luftgapet
        Rth27=1/G27;                                                        %Varmeovergangsmotstand fra overflaten av polskoene til kjleluftstrmmen i luftgapet
        
    %Rth28 og Rth37
        deltath28=hspk+hgls+hds+delta0+hps+hkr;
        Ta=rhoth^2*(ns*(2*pi)/60)^2*Di/2*deltath28^3/myair^2;
        Fg=pi^4*((Di-2.304*deltath28)/(Di-deltath28))/(1697*...
            (0.0056+0.0571*((Di-2.304*deltath28)/(Di-deltath28))^2)*...
            (1-deltath28/Di)^2);
        
        Tam=Ta/Fg;
        
        if Tam < 1700
            Nu=2;
        elseif 1700 < Tam < 1e4
            Nu=0.128*Tam^0.367;
        elseif 1e4 < Tam < 1e7    
            Nu=0.409*Tam^0.241;
        end
        
        ath28=2*Nu*lambdaair/deltath28;
        S28=((bf+2*bcuf)*(hf+bcuf+0.008)+2*bcuf*hf)*Np;
        G28=S28*ath28;
        Rth28=1/G28;                                                        %Varmeovergangsmotstand fra rotorens endeviklinger til kjleluften i spolehodeomrdet
        Rth37=Rth28;                                                        %Varmeovergangsmotstand fra rotorens endeviklinger til kjleluften i spolehodeomrdet
        
    %Rth29, Rth30, Rth31, Rth34, Rth35 og Rth36
        lth29=thc;                                                          %Termisk konduktivitet for vindingsisolasjonen (typisk verdi)
        lth30=394;                                                          %Termisk konduktivitet for kobber (elektroteknisk)
        d29=bif;
        dl29=bcuf/2;
        d30=(bf+bcuf)/2;                                                              
        S29=((bf+2*bcuf)*(hf+bcuf+0.008)+2*bcuf*hf)*Np;
        Sl29=(bf+2*bcuf)*hf*Np;
        S30=bcuf*hf*Np;                                                           
        G29=1/(d29/(lth29*S29)+dl29/(lth30*Sl29));
        R30=d30/(lth30*S30);
        Rth29=1/G29;                                                        %Varmeledningsmotstand fra midten av rotorens endevikling og ut til yttersiden av isolasjonen
        Rth30=1/G29*(sqrt(R30*G29)/sinh(sqrt(R30*G29))-1);                  %Varmeledningsmotstand for varme produsert i rotorens endevikling
        Rth31=sqrt(R30/G29)*tanh(sqrt(R30*G29)/2);                          %Varmeledningsmotstand fra midten av endeviklingen og til endene av endeviklingen
        Rth34=Rth31;                                                        %Varmeledningsmotstand fra midten av endeviklingen og til endene av endeviklingen
        Rth35=Rth30;                                                        %Varmeledningsmotstand for varme produsert i rotorens endevikling
        Rth36=Rth29;                                                        %Varmeledningsmotstand fra midten av rotorens endevikling og ut til yttersiden av isolasjonen
    
    %Rth32, Rth33, Rth39 og Rth42
        lth42=thc;                                                          %Termisk konduktivitet for vindingsisolasjonen (typisk verdi)
        lth39=394;                                                          %Termisk konduktivitet for kobber (elektroteknisk)
        d39=(Lfp+bcuf)/2;                                                              
        d42=bif;
        dl42=bcuf/2;
        S39=hf*bcuf*4*Np; 
        S42=hf*(Lfp+2*bcuf)*2*Np;
        Sl42=hf*(Lfp+bcuf)*2*Np;                                                       
        G39=1/(d42/(lth42*S42)+dl42/(lth39*Sl42));
        R39=d39/(lth39*S39);
        Rth42=1/G39;                                                        %Varmeledningsmotstand fra midten av feltviklingen og ut til yttersiden av isolasjonen i polluken
        Rth39=1/G39*(sqrt(R39*G39)/sinh(sqrt(R39*G39))-1);                  %Varmeledningsmotstand fra midten av feltviklingen og ut til endene av feltviklingen
        Rth32=sqrt(R39/G39)*tanh(sqrt(R39*G39)/2);                          %Varmeledningsmotstand for varme produsert i feltviklingen
        Rth33=Rth32;  
    
    %Rth38, Rth40 og Rth41
        lth38=38;                                                           %Termisk konduktivitet for blikket i samme reting som lamineringene
        lth41=14;                                                           %Termisk konduktivitet for blikket normalt p lamineringene
        lthl41=8;
        d38=hpk/2+hps;
        d41=bpk/2; 
        dl41=bi;
        S38=bpk*lb*Np;
        S41=hpk*lb*2*Np;
        Sl41=(hpk+(bps-bpk)/2+bcuf)*lb*2*Np;
        G38=1/(d41/(lth41*S41)+dl41/(lthl41*Sl41));
        R38=d38/(lth38*S38);
        Rth38=sqrt(R38/G38)*tanh(sqrt(R38*G38)/2);                          %Varmeledningsmotstand fra midten av en rotorpol og ut til polskoens overflate
        Rth40=1/G38*(sqrt(R38*G38)/sinh(sqrt(R38*G38))-1);                  %Varmeledningsmotstand for varme produsert i rotorpolen
        Rth41=1/G38;                                                        %Varmeledningsmotstand fra midten av en rotorpol og til feltviklingen

    %Rth43
        vpl=(3+7*(vim/15)^1.5)*(polklaring/0.019)^1.38*(ns/500)*(hf/0.14);
        ath43=11.5*sqrt(vpl/(lb/2));                                                                                                               
        S43=hf*lb*2*Np*5/3;                                                            
        G43=S43*ath43;
        Rth43=1/G43;                                                        %Varmeovergangsmotstand fra rotorens endeviklinger til kjleluften i spolehodeomrdet
     
        
%Termisk konduktansmatrise

    G=ones(21,21)*0;

    G(1,1)=1/(Rth1+Rth2)+1/(Rth5)+1/(Rth6+Rth7);
    G(1,2)=-1/(Rth5);
    G(2,1)=-1/(Rth5);
    G(1,3)=-1/(Rth6+Rth7);
    G(3,1)=-1/(Rth6+Rth7);
    G(2,2)=1/(Rth5)+1/(Rth3+Rth4);
    G(3,3)=1/(Rth6+Rth7)+1/(Rth10)+1/(Rth14+Rth26);
    G(3,4)=-1/(Rth10);
    G(4,3)=-1/(Rth10);
    G(3,20)=-1/(Rth14+Rth26);
    G(20,3)=-1/(Rth14+Rth26);
    G(4,4)=1/(Rth8+Rth9)+1/(Rth10)+1/(Rth11);
    G(4,5)=-1/(Rth11);
    G(5,4)=-1/(Rth11);
    G(5,5)=1/(Rth11)+1/(Rth12)+1/(Rth13);
    G(5,19)=-1/(Rth13);
    G(19,5)=-1/(Rth13);
    G(5,6)=-1/(Rth12);
    G(6,5)=-1/(Rth12);
    G(6,6)=1/(Rth12)+1/(Rth15);
    G(6,8)=-1/(Rth15);
    G(8,6)=-1/(Rth15);
    G(7,7)=1/(Rth16+Rth17)+1/(Rth18+Rth19+Rth20);
    G(7,8)=-1/(Rth18+Rth19+Rth20);
    G(8,7)=-1/(Rth18+Rth19+Rth20);
    G(8,8)=1/(Rth18+Rth19+Rth20)+1/(Rth21+Rth22+Rth23)+1/(Rth15);
    G(8,9)=-1/(Rth21+Rth22+Rth23);
    G(9,8)=-1/(Rth21+Rth22+Rth23);
    G(9,9)=1/(Rth21+Rth22+Rth23)+1/(Rth24+Rth25);
    G(9,21)=-1/(Rth24+Rth25);
    G(21,9)=-1/(Rth24+Rth25);
    G(10,10)=1/(Rth28+Rth29)+1/(Rth30+Rth31+Rth32);
    G(10,11)=-1/(Rth30+Rth31+Rth32);
    G(11,10)=-1/(Rth30+Rth31+Rth32);
    G(11,11)=1/(Rth30+Rth31+Rth32)+1/(Rth30+Rth31+Rth32)+1/(Rth39);
    G(11,12)=-1/(Rth30+Rth31+Rth32);
    G(12,11)=-1/(Rth30+Rth31+Rth32);
    G(11,13)=-1/(Rth39);
    G(13,11)=-1/(Rth39);
    G(12,12)=1/(Rth30+Rth31+Rth32)+1/(Rth36+Rth37);
    G(12,20)=-1/(Rth36+Rth37);
    G(20,12)=-1/(Rth36+Rth37);
    G(13,13)=1/(Rth39)+1/(Rth42);
    G(13,15)=-1/(Rth42);
    G(15,13)=-1/(Rth42);
    G(14,14)=1/(Rth27+Rth38+Rth40)+1/(Rth41);
    G(14,15)=-1/(Rth41);
    G(15,14)=-1/(Rth41);
    G(15,15)=1/(Rth41)+1/(Rth42)+1/(Rth43);
    G(15,20)=-1/(Rth43);
    G(20,15)=-1/(Rth43);
    G(16,16)=1/(Rth1+Rth2);
    G(16,1)=-1/(Rth1+Rth2);
    G(1,16)=-1/(Rth1+Rth2);
    G(17,17)=1/(Rth3+Rth4);
    G(17,2)=-1/(Rth3+Rth4);
    G(2,17)=-1/(Rth3+Rth4);
    G(18,18)=1/(Rth8+Rth9);
    G(18,4)=-1/(Rth8+Rth9);
    G(4,18)=-1/(Rth8+Rth9);
    G(19,19)=1/(Rth13);
    G(21,21)=1/(Rth16+Rth17)+1/(Rth24+Rth25)+1/(Rth28+Rth29)+1/(Rth36+Rth37);
    G(21,7)=-1/(Rth16+Rth17);
    G(7,21)=-1/(Rth16+Rth17);
    G(20,20)=1/(Rth14+Rth26)+1/(Rth27+Rth38+Rth40)+1/(Rth43);
    G(21,14)=-1/(Rth27+Rth38+Rth40);
    G(14,21)=-1/(Rth27+Rth38+Rth40);
    G(21,10)=-1/(Rth28+Rth29);
    G(10,21)=-1/(Rth28+Rth29);
    
    
%Varmestrmsmatrise
    
    P=ones(15,1)*0;
    
    P(2,1)=PFey;                                                            %Tap i k
    P(4,1)=PFed;                                                            %Tap i statortenner
    P(6,1)=(Pcusdc+Pcusac)*(2*lb/(lav/tnr));                                %Tap i spor
    P(7,1)=(Pcusdc+Pcusac)*(lspolh/(lav/tnr));                              %Tap i ett spolehode
    P(9,1)=(Pcusdc+Pcusac)*(lspolh/(lav/tnr));                              %Tap i ett spolehode
    P(10,1)=Pre/2;                                                          %Tap i rotorviklingen i polenden
    P(12,1)=Pre/2;                                                          %Tap i rotorviklingen i polenden
    P(13,1)=Prl;                                                            %Tap i rotorviklingen i luftgapet
    P(14,1)=0;                                                              %Tap i polkjernen
    
   
%Termisk resistansmatrise

    Re=ones(6,6)*0;
    
    Re(1,1)=Rqth;
    Re(1,2)=2*Rqth;
    Re(1,3)=2*Rqth;
    Re(1,4)=2*Rqth;
    Re(1,5)=2*Rqth;
    Re(1,6)=2*Rqth;
    
    Re(2,2)=Rqth;
    Re(2,3)=2*Rqth;
    Re(2,4)=2*Rqth;
    Re(2,5)=2*Rqth;
    Re(2,6)=2*Rqth;
    
    Re(3,3)=Rqth;
    Re(3,4)=2*Rqth;
    Re(3,5)=2*Rqth;
    Re(3,6)=2*Rqth;
    
    Re(4,4)=Rqth;
    Re(4,5)=2*Rqth;
    Re(4,6)=2*Rqth;
    
    Re(5,5)=Rqth;
    Re(5,6)=Rqth;
    
    Re(6,6)=Rqth;
    
    
%Friksjonstapmatrise

    Tp=ones(6,1)*0;
    
    Tp(1,1)=2*Rqth*Prhow2+2*Rqth*Prhow1;
    Tp(2,1)=2*Rqth*Prhow2+2*Rqth*Prhow1;
    Tp(3,1)=2*Rqth*Prhow2+2*Rqth*Prhow1;
    Tp(4,1)=2*Rqth*Prhow2+2*Rqth*Prhow1;
    Tp(5,1)=2*Rqth*Prhow2+Rqth*Prhow1;
    Tp(6,1)=Rqth*Prhow2;
        
    
%Temperaturmatrise

        Temp=ones(21,1)*0;

        Re2=Re^-1;
        P2=[P;(Re^-1)*Tp];

        Re3=ones(21,21)*0;

        for Re3x=1:1:6
            for Re3y=1:1:6

                Re3(15+Re3x,15+Re3y)=Re2(Re3x,Re3y);

            end
        end

        Temp=((G+Re3)^-1)*P2;
        Temp2=round(Temp);
        dTmxt=dTmx-14;
        
        if Temp2(2,1) > dTmxt || Temp2(4,1) > dTmxt || Temp2(6,1) > ...
                dTmxt || Temp2(7,1) > dTmxt || Temp2(10,1) > dTmxt || ...
                Temp2(13,1) > dTmxt || Temp2(14,1) > dTmxt || ...
                Temp2(16,1) > dTmxt || Temp2(17,1) > dTmxt || ...
                Temp2(18,1) > dTmxt || Temp2(19,1) > dTmxt || ...
                Temp2(20,1) > dTmxt || Temp2(21,1) > dTmxt
            
            aqth2=1;
        else
            aqth1=1;
        end
        
    end
    
    disp('Thermal Calculations Completed');
    

%Reaktanser og tidskonstanter

%Transiente reaktanser
    
    a=taumx/taumn-1;                                                        %Faktor for beregning av pollekkfluks
    kfi=0.99;                                                               %Faktor for beregning av feltviklingens relative lekkreaktans
    kmf=1/(a^3)*(1+a/8)*(log(1+a)+a*(a/2-1));                               %Reduksjonsfaktor for pollekkfluks
    Ampk=Apk*kmf/kl;                                                        %Lekkledningsevne mellom polkjernene tatt hensyn til stigning i forslynget fluks fra bunnen av polen
    Rf=2.1e-8*Lfmd*nf*Np/(Af);                                              %Feltviklingens resistans ved 75 grader
    Rf20=Rf/rho75*rho20;                                                    %Feltviklingens resistans ved 20 grader 
    
    Rmf=(Fa*kdx/Tetamn)^2*Rf*If^2/(Sn*1e6);                                 %Feltviklingsresistans referert til stator
    Xf=(4/pi)*(Fa*kdx^2/FIm)*(Ampk+Aps)+Xmd*((4/pi)*kfi*kdx-1);             %Feltviklingens relative lekkreaktans
    sigf=Xf/Xmd;                                                            %Faktor for beregning av reaktanser
    Xdt=Xsigma+Xmd*(sigf/(1+sigf));                                         %Transient d-akse reaktans
    Xdtt=Xsigma+0.6*(sigf/(1+sigf));                                    %Sub-transient d-akse reaktans
    Xqtt=Xdtt*1.15;                                                         %Sub-transient q-akse reaktans
    
    Lfsigma=Xf*Rref/w;                                                      %Feltviklingens lekkinduktans
    Ldt=Xdt*Rref/w;                                                         %Transient d-akse induktans
    Ldtt=Xdtt*Rref/w;                                                       %Sub-transient d-akse induktans
    Lqtt=Xqtt*Rref/w;                                                       %Sub-transient q-akse induktas
   
%Transiente tidskonstanter
    
    as=(NDs-1)*taur/taup;                                                   %Avstans mellom de to ytterste dempestavene p en pol
    k=(kw*Ns)^2/(Np/2);                                                     %Faktor for beregning av dempestavens resistans referet til stator
    RmD=1.37*m*2.1e-8*(as*lb/(NDs*AcuD)+(Di/(pi*3.5*AcuD*(Np/2))))^2*k*1e-2;%Dempestavens resistans referet til stator

    ADs=0.47+0.066*(bu/bcu)+hds/bcu;                                        %Permeansfaktor for en dempestav
    LmD=8*4*pi*1e-7*w*m*lm*(as/NDs)*(ADs+0.133*(as*Di/((Np/2)*NDs*...       %Dempeviklingen lekkinduktans referet til stator
        delta0)))*k*1e-2;

    zetad=1.746-0.422*as-0.2913/(as-0.138);                                 %Faktor for beregning av tidskonstant i d-akse
    zetaq=1.222-0.1*as-0.102/(as-0.1);                                      %Faktor for beregning av tidskonstant i q-akse

    LmDd=LmD/zetad;                                                         %Dempeviklingens d-akse lekkinduktans referet til stator
    LmDq=LmD/zetaq;                                                         %Dempeviklingens q-akse lekkinduktans referet til stator
        
    Tdt0=(Lfsigma+Lmd)/(Rmf*Rref);                                          %Tidskonstanter
    Tdt=(Lfsigma+Lsigma*Lmd/(Lsigma+Lmd))/(Rmf*Rref);
    
    Tdtt0=(LmDd+Ldt)/RmD;
    Tdtt=Tdtt0*Ldtt/Ldt;
    Tqtt0=(LmDq+Lmq)/RmD;
    Tqtt=Tqtt0*Lqtt/Lmq;
       
    disp('Reactance and Time Constant Calculations Completed');
  
    
%Mekaniske beregninger


%Svingmoment

    gammacu=8930;                                                           %Massetetthet for kobber [kg/m^3]
    gammaFe=7870;                                                           %Massetetthet for jern
    Gf=Af*nf*gammacu*Lfmd*Np;                                               %Vekt av feltvikling
    Df=Di-2*(delta0+hps)-hpk;                                               %Diameter gjennom midten av feltviklingene
    Dps=Di-2*delta0-1/3*(4*hps-hpt);                                        %Diameter gjennom midten av polskoene
    Gpkpm=hpk*bpk*gammaFe;                                                  %Vekt av polkjerne per meter lengde
    Gpspm=1/3*(hpt+2*hps)*bps*gammaFe;                                      %Vekt av polsko per meter lengde
    
    GDp2=(1.04*Gf*Df^2+Np*lb*(Gpkpm*Df^2+Gpspm*Dps^2));                     %Svingmoment for poler og feltviklinger

    Dr=Df-hpk-hyr;                                                          %Rotorringens midlere diameter
    lrr=lb+2*bcuf+2*Le;                                                     %Lengde av rotorringen
    Gr=pi*Dr*hyr*lrr*gammaFe;                                               %Vekt av rotorring
    
    if GD2addxls~=0
        Gflywheel=GD2addxls;                                                %Vekt av svinghjul
    else
        Gflywheel=0;
    end
    
    GD2flywheel=Gflywheel*(Di*0.5)^2;                                       %Svingmoment til svinghjul
    
    GDr2=Gr*Dr^2;                                                           %Svingmoment for rotorringen
    GD2add=(GDp2+GDr2)*0.07;                                                %Tillegg i svingmoment for nav, bremsering, ventilatorer etc.
   
    GD2=GDp2+GDr2+GD2add+GD2flywheel;                                       %Maskinens totale svingmoment
    
    M2=GD2/4000;                                                            %Maskinens treghetsmoment

    
%Total maskinvekt
    
    Gpk=Gpkpm*Np*lb;                                                        %Vekt av polkjernene
    Gps=Gpspm*Np*lb;                                                        %Vekt av polskoene
    Gsw=Acus*lav*Qs*gammaFe;                                                %Vekt av statorvikling
    Gadd=0.86*(Gpk+Gps+Gf+Gr)+0.9*(mFe+mds+Gsw);                            %Tilleggsvekt pga. aksling, stttestruktur tilleggsdeler etc.
        
    Gtot=1.1*(mFe+mds+Gsw+Gpk+Gps+Gf+Gr+Gadd)+Gflywheel;                    %Total maskinvekt
    
    disp('Mechanical Calculations Completed');
    disp('Writing data to file');
    
%Outputs
    
    Ascm=As/100;
    
    %Stator Parameters
    SP(1,1)=C;    
    SP(2,1)=Ascm;    
    SP(3,1)=Di;    
    SP(4,1)=Dy;    
    SP(5,1)=lb;    
    SP(6,1)=ln;    
    SP(7,1)=Qs;    
    SP(8,1)=nv;    
    SP(9,1)=Ns;    
    SP(10,1)=tnr;    
    SP(11,1)=pnr;    
    SP(12,1)=q;    
    SP(13,1)=yQ;    
    SP(14,1)=Ww;    
    SP(15,1)=kw;       
    SP(16,1)=hs*1000;    
    SP(17,1)=bu*1000;    
    SP(18,1)=bd*1000;    
    SP(19,1)=tauu*1000;
    SP(20,1)=ndl;
    SP(21,1)=hcus*1000;
    SP(22,1)=bcus*1000;
    SP(23,1)=dij*1000;
    SP(24,1)=dicu*1000;
    SP(25,1)=lav;
    SP(26,1)=Acus*1e6;    
    SP(27,1)=Ssmm;
    SP(28,1)=Rdc20;
    SP(29,1)=Rdc;    
    SP(30,1)=Kra;
    SP(31,1)=Krad;
    SP(32,1)=Kmx;
    SP(33,1)=s;    
    
    xlswrite('Output.xls',SP,1,'E17');
    
    %Rotor Parameters
    RP(1,1)=delta0*1000;
    RP(2,1)=deltame*1000;
    RP(3,1)=bps*1000;
    RP(4,1)=hps*1000;
    RP(5,1)=bpk*1000;
    RP(6,1)=hpk*1000;
    RP(7,1)=nf;
    RP(8,1)=If;
    RP(9,1)=bcuf*1000;
    RP(10,1)=hcuf*1000;
    RP(11,1)=Af*1e6;
    RP(12,1)=Sfmm;
    RP(13,1)=Rf20;
    RP(14,1)=Rf;
    RP(15,1)=alfar;
    RP(16,1)=NDs;
    RP(17,1)=AcuD*1e6;
    RP(18,1)=polklaring*1000;
    
    xlswrite('Output.xls',RP,1,'E54');
        
    %Magnetic Parameters
    MPC(1,1)=Bdelta;
    MPC(2,1)=Bys;
    MPC(3,1)=Bdmax;
    MPC(4,1)=Byr;
    MPC(5,1)=Bdrmx;
    
    xlswrite('Output.xls',MPC,1,'C77');
    
    MPE1(1,1)=Umdelta;
    MPE1(2,1)=Umys;
    MPE1(3,1)=Umd;
    MPE1(4,1)=Umdr;
    MPE1(5,1)=Umyr;
    
    xlswrite('Output.xls',MPE1,1,'E77');
    
    MPE2(1,1)=Efpu;
    MPE2(2,1)=Eipu;
    MPE2(3,1)=Tetamn;
    MPE2(4,1)=FIL;
    
    xlswrite('Output.xls',MPE2,1,'E83');
    
    %Loss Calculations
    %No load
    LC1(1,1)=PFekw;
    LC1(2,1)=Pfwkw;
    LC1(3,1)=Prnlkw;
    
    xlswrite('Output.xls',LC1,1,'E91');
        
    %Nominal load
    LC2(1,1)=Pcusdckw;
    LC2(2,1)=Pcusackw;
    LC2(3,1)=Prflkw;
    LC2(4,1)=Paddkw;
    LC2(5,1)=Pmagnkw;
       
    xlswrite('Output.xls',LC2,1,'E95');
    xlswrite('Output.xls',Ptotkw,1,'E101');
    
    %Reactances and Time Constants
    RTC1(1,1)=Xmd;
    RTC1(2,1)=Xmq;
    RTC1(3,1)=Xsigma;
    RTC1(4,1)=Xdpu;
    RTC1(5,1)=Xqpu;
    RTC1(6,1)=Xdt;
    RTC1(7,1)=Xdtt;
    RTC1(8,1)=Xqtt;
    
    
    xlswrite('Output.xls',RTC1,1,'E106');
    
    RTC2(1,1)=Tdt;
    RTC2(2,1)=Tdtt;
    RTC2(3,1)=Tqtt;
    
    xlswrite('Output.xls',RTC2,1,'E115');
    
    %Thermal Calculations
    TC(1,1)=qth/1000;
    TC(2,1)=vim;
    
    TC1(1,1)=Temp2(6);
    TC1(2,1)=Temp2(4);
    TC1(3,1)=Temp2(2);
    TC1(4,1)=Temp2(7);
    TC1(5,1)=Temp2(13);
    TC1(6,1)=Temp2(10);
    TC1(7,1)=Temp2(14);
    
    TC2(1,1)=Temp2(21);
    TC2(2,1)=Temp2(20);
    TC2(3,1)=Temp2(19);
    TC2(4,1)=Temp2(18);
    TC2(5,1)=Temp2(17);
    TC2(6,1)=Temp2(16);
    
    xlswrite('Output.xls',TC,1,'E122');
    xlswrite('Output.xls',TC1,1,'E126');
    xlswrite('Output.xls',TC2,1,'E135');


    %Mechanical Calculations
    MC(1,1)=M2;
    MC(2,1)=Gtot/1000;
    MC(3,1)=Vr;
    
    xlswrite('Output.xls',MC,1,'E145');
       
    xlswrite('Output.xls',harm2,1,'A153');
    
    xlswrite('Output.xls',THF,1,'H168');
    
    %Main Data
    MD(1,1)=Sn;
    MD(2,1)=Un;
    MD(3,1)=In;
    MD(4,1)=Cosphi;
    MD(5,1)=Eff;
    MD(6,1)=ns;
       
    xlswrite('Output.xls',MD,1,'E7');
    
        %PM dimensions
    PM1(1,1)=0;
    PM1(2,1)=0;
    
    xlswrite('Output.xls',PM1,1,'E175');
    
    PM2(1,1)=0;
    PM2(2,1)=0;
    PM2(3,1)=0;
    PM2(4,1)=0;
    PM2(5,1)=0;
    
    xlswrite('Output.xls',PM2,1,'E179');
    
    
disp('The Calculations are Completed.');
disp('The results can be viewed in the Excel-file Output.xls');


    else                                                                    %Gjr beregninger for PM synkronmaskin, overflatemonterte
        disp(' ');

    disp('Chosen parameters:');                                             %Skriver ut valgte verdier fra tabell "Required Values"
    disp(' ');
    disp(['Sn = ',num2str(Sn),' MVA']);
    disp(['Cos(phi) = ',num2str(Cosphi),]);
    disp(['f = ',num2str(f),' Hz']);
    disp(['2p = ',num2str(Np),]);
    disp(['nr = ',num2str(nr),' rpm']);
    disp(['dTmx = ',num2str(dTmx),' degC']);
    disp(['M = ',num2str(M),' tm^2']);
    disp(['Vmx = ',num2str(Vmx),' KV']);
    disp(['xd = ',num2str(xd),' pu']);
    disp(['xd` = ',num2str(xd1),' pu']);
    disp(['xd`` = ',num2str(xd2),' pu']);
    disp(['Btmx = ',num2str(Btmx),' T']);
    disp(['Bpmx = ',num2str(Bpmx),' T']);
    disp(['Bymx = ',num2str(Bymx),' T']);
    disp(['bs/bt = ',num2str(budbd),]);
    disp(['lcs = ',num2str(bcs),'m']);
    disp(['lcd = ',num2str(bv),'m']);
    disp(['kFe = ',num2str(kFe),]);
    disp(['Ss = ',num2str(Ssxls),'A/mm2']);
    disp(['hcus = ',num2str(hcusxls),'mm']);
    disp(['Vnmx = ',num2str(Vnmx),'']);
    disp(['s = ',num2str(s),'']);
    disp(['Dri = ', num2str(Dri), 'm']);
    disp(['alfa = ',num2str(alfar),'']);
    disp(['Br = ',num2str(Br),'T']);
    disp(['myrPM = ',num2str(myr_pm),'']);


%Definering av konstanter og variabler

    my0=pi*4e-7;                                                            %Permeabilitiet for luft
    m=3;                                                                    %Antall faser
    p=Np/2;                                                                 %Antall polpar
    w=2*pi*f;                                                               %Ohmega, vinkelhastighet
       
    
%Diameter og jernlengde

    C=0.02*Sn+5.6;                                                          %Bestemmer utnyttelsessifferet
    
    if Cxls~=0
         C=Cxls;   
    end    
    
    if M==0
        M=30.38*((1.5+3.1e-3*(Sn*Np))/2.2)*(Sn/14)*(Np/14)-13.5;
    end    
        
        
    ns=120*f/(Np);                                                          %Beregner nominelt turtall
    D2l=Sn*1000/(C*ns);                                                     %Empirisk faktor for  bestemme Diameter og lengde
    beta=-0.06*Np/2+2.9;                                                    %Empirisk konstant for  beregne GD2
    GD2=4*M;                                                                %Faktor for  bestemme D4l
    D4l=GD2/beta;                                                           %Empirisk faktor for  bestemme Diameter og lengde
    
    if Dixls == 0
        Di=sqrt(D4l/D2l);                                                   %Indre statordiameter
    else
        Di=Dixls;
    end
    
    if lbxls == 0
            
        lb=D2l/(Di^2);                                                      %Brutto jernlengde
    else
        lb=lbxls;
    end                                                                     

    Vr=pi()*Di*nr/60;                                                      %Kontroll av maksimal periferihastighet[m/s], br ikke overstige 150[m/s]
    
    
%Valg av antall spor
    
    if Qsxls==0
                                                                            %Antall parallelle kretser
        pnr=1;                                                              %Variabel som brukes til for-slyfe for parallelle kretser

        Qmin=round(Di*pi/0.12);                                             %Beregning av minste sportall som skal kontrolleres
        Qmax=round(Di*pi/0.04);                                             %Beregning av strste sportall som skal kontrolleres
        Qs=Qmin;                                                            %Variabel som brukes til kontroll av sportallene

        sportab(100,30)=0;                                                  %Setter tabellen som de godkjente sportallene skrives inn i lik 0
        sporkonst=1;                                                        %Konstant til spormatrise
        parkonst=1;                                                         %Konstant til spormatrise

        for pnr=1:1:15


          for Qs=Qmin:1:Qmax    

            k1=Qs/6;                                                        %Konstant som brukes til  kontrollere krav om at sportall er delelig p 6 (2x3) (skal bil et heltall)
            k2=round(k1);                                                   %Konstant som brukes til  kontrollere krav om at sportall er delelig p 6 (2x3)

                if k1==k2

                    k11=Qs/pnr;                                             %Konstant som brukes til  kontrollere krav om at sportall er delelig p antall poler (skal bil et heltall)
                    k22=Np/pnr;                                             %Konstant som brukes til  kontrollere krav om at antall poler er delelig p antall parallelle krester (skal bil et heltall)
                    k111=round(k11);                                        %k11 rundes av for  kontrollere om den er et heltall (betingelse til if-slyfe)
                    k222=round(k22);                                        %k22 rundes av for  kontrollere om den er et heltall (betingelse til if-slyfe)

                    if k111==k11 && k222==k22

                        sportab(sporkonst,parkonst)=Qs;                     %Tillatt sportall legges inn i matrise

                        parkonst=parkonst+1;

                        q=(Qs/(m*Np));                                      %Antall spor per pol og fase beregnes for det aktuelle sportallet

                        sportab(sporkonst,parkonst)=q;                      %q legges til matrisen ved siden av det samsvarende sportallet

                        parkonst=parkonst-1;


                        sporkonst=sporkonst+1;  

                    end
                end   


            Qs=Qs+1;
          end

        parkonst=parkonst+2;
        sporkonst=1;
        end

        xlswrite('sporfil.xls',sportab,1,'C3');                             %Matrise for alle aktuelle sportall Qs og tilsvarenede q skrives til excel
        disp(' ');
    end
    
    if Qsxls~=0                                                             %Velger sprotall
        Qs=Qsxls; 
    else
        Qs=input('Select number of slots from table:');                      
        disp(' ');
    end
    
                                                                            
    if pnrxls~=0                                                            %Velger antall parallelle kretser
        pnr=pnrxls;        
    else
        pnr=input('Select the number of paralell cricuits:'); 
        disp(' ');
    end
    
    if tnrxls~=0                                                            %Velger antall turn per vinding
        tnr=tnrxls;                                                    
    else
        tnr=input('Select the number of turns per coil:');                    
        disp(' ');
    end
                                                                            
    
    q=(Qs/(m*Np));                                                          %Beregner antall spor per pol og fase
    
    tauu=pi*Di/Qs;                                                          %Spordeling i meter
    taup=pi*Di/(Np);                                                        %Poldeling i meter
    taups=Qs/Np;                                                            %Poldeling i antall spor
    taupr=alfar*taup;                                                       %Polbuebredde [m]
    Ns=Qs*tnr/(m*pnr);                                                      %Antall vindinger i serie per fase
    
    
%valg av spenning og ankerbelastning
    
    km=1.515;                                                               %Forholdet mellom maksimal luftgapinduksjon i tomgang og midlere induksjon
    kf=1.11;                                                                %Omregnigsfaktor
    fw=0.925;                                                               %Gjennomsnittlig viklingsfaktor
    fj=0.83;                                                                %Faktor som bestr av forholdet mellom netto og brutto jernlengde
                                                               
    Ams=(C*60*km*1000)/(pi^2*kf*fw*fj*Btmx/(1+(budbd)));                    %Estimert ankerbelastning ut i fra utnyttelsessiffer 
    Amsdelta=Ams;
    

% Fra ankerbelastningen kan strmmen i en stav berenges
 
    Inm=Ams*tauu/(tnr*2);                                                   %Beregner strmmen i en stav
    In=Inm*pnr;                                                             %Generatorens merkestrm
    Un=Sn*1e6/(In*sqrt(3));                                                 %Generatorens klemmespenning
    Ic=In*tnr/pnr;                                                          %Stavstrm
    
    As=Ic*2/tauu;                                                           %Ny ankerbelastning                                                                     
    
    if Unxls~=0                                                             %Valgt spenning fra inputfil
    
    Un=Unxls;                                                               %M beregne ny strm og ankerbelastning
    In=Sn*1e6/(sqrt(3)*Un);
    Ic=In*tnr/pnr;
    As=Ic*2/tauu;
   
    C2=pi^2/60*kf*fw/km*fj/(1+budbd)*As*0.001*Btmx;    
    C2delta=0.0001*As;
   
    Ckonst=abs(1-C/C2);                                                     %Ittererer for  f korrekt utnyttelsessiffer
    
    while Ckonst>=0.01
    
        C=C2;   

        ns=120*f/(Np);                                                      %Beregner nominelt turtall
        D2l=Sn*1000/(C*ns);                                                 %Empirisk faktor for  bestemme Diameter og lengde
        beta=-0.06*Np/2+2.9;                                                %Empirisk konstant for  beregne GD2
        GD2=4*M;                                                            %Faktor for  bestemme D4l
        D4l=GD2/beta;                                                       %Empirisk faktor for  bestemme Diameter og lengde
        
        if Dixls == 0
            Di=sqrt(D4l/D2l);                                               %Indre statordiameter
        else
            Di=Dixls;
        end
            
        if lbxls == 0                                                       %Brutto jernlengde
            
            lb=D2l/(Di^2);                                                  
        else
            lb=lbxls;
        end                                                                

        Vr=pi()*Di*nr/60;                                                   %Kontroll av maksimal periferihastighet[m/s], br ikke overstige 150[m/s]



    %Valg av antall spor

        m=3;                                                                %Antall parallelle kretser
        
        if Qsxls==0
            pnr=1;                                                          %Variabel som brukes til for-slyfe for parallelle kretser


            Qmin=round(Di*pi/0.12);                                         %Beregning av minste sportall som skal kontrolleres
            Qmax=round(Di*pi/0.04);                                         %Beregning av strste sportall som skal kontrolleres
            Qs=Qmin;                                                        %Variabel som brukes til kontroll av sportallene


            sportab(100,20)=0;                                              %Setter tabellen som de godkjente sportallene skrives inn i lik 0
            sporkonst=1;                                                    %Konstant til spormatrise
            parkonst=1;                                                     %Konstant til spormatrise

            for pnr=1:1:10


              for Qs=Qmin:1:Qmax    

                k1=Qs/6;                                                    %Konstant som brukes til  kontrollere krav om at sportall er delelig p 6 (2x3) (skal bil et heltall)
                k2=round(k1);                                               %Konstant som brukes til  kontrollere krav om at sportall er delelig p 6 (2x3)

                    if k1==k2

                    k11=Qs/pnr;                                             %Konstant som brukes til  kontrollere krav om at sportall er delelig p antall poler (skal bil et heltall)
                    k22=Np/pnr;                                             %Konstant som brukes til  kontrollere krav om at antall poler er delelig p antall parallelle krester (skal bil et heltall)
                    k111=round(k11);                                        %k11 rundes av for  kontrollere om den er et heltall (betingelse til if-slyfe)
                    k222=round(k22);                                        %k22 rundes av for  kontrollere om den er et heltall (betingelse til if-slyfe)

                        if k111==k11 && k222==k22

                            sportab(sporkonst,parkonst)=Qs;                 %Tillatt sportall legges inn i matrise

                            parkonst=parkonst+1;

                            q=(Qs/(m*Np));                                  %Antall spor per pol og fase beregnes for det aktuelle sportallet

                            sportab(sporkonst,parkonst)=q;                  %q legges til matrisen ved siden av det samsvarende sportallet

                            parkonst=parkonst-1;


                            sporkonst=sporkonst+1;  

                        end
                    end   


                Qs=Qs+1;
              end

            parkonst=parkonst+2;
            sporkonst=1;
            end

            xlswrite('sporfil.xls',sportab,1,'C3');                         %Matrise for alle aktuelle sportall Qs og tilsvarenede q skrives til excel
        end
        disp(' ');

        if Qsxls~=0
            Qs=Qsxls; 
        else
            Qs=input('Select number of slots from table:');
            disp(' ');
        end

        if pnrxls~=0                                                        %Velger antall parallelle kretser 
            pnr=pnrxls;        
        else
            pnr=input('Select the number of paralell cricuits:'); 
            disp(' ');
        end

        if tnrxls~=0                                                        %Velger antall turn
            tnr=tnrxls;        
        else
            tnr=input('Select the number of turns per coil:');  
            disp(' ');
        end


        q=(Qs/(m*Np));                                                      %Beregner antall spor per pol og fase

        tauu=pi*Di/Qs;                                                      %Spordeling i meter
        taup=pi*Di/(Np);                                                    %Poldeling i meter
        taups=Qs/Np;                                                        %Poldeling i antall spor
        Ns=Qs*tnr/(m*pnr);                                                  %Antall vindinger i serie per fase

    
    %valg av spenning og ankerbelastning

        km=1.515;                                                           %Forholdet mellom maksimal luftgapindusjon i tomgang og midlere indusjon
        kf=1.11;                                                            %Omregnigsfaktor
        fw=0.925;                                                           %Gjennomsnittlig viklingsfaktor
        fj=0.83;                                                            %Faktor som bestr av forholdet mellom netto og brutto jernlengde

        Ams=(C*60*km*1000)/(pi^2*kf*fw*fj*Btmx/(1+(budbd)));                %Estimert ankerbelastning ut i fra utnyttelsessiffer 
        Amsdelta=(C2delta*60*km*1000)/(pi^2*kf*fw*fj*Btmx/(1+(budbd)));

        As=Ic*2/tauu; 

        C2=pi^2/60*kf*fw/km*fj/(1+budbd)*As*0.001*Btmx;    

        Ckonst=abs(1-C/C2);

    end
    
    Ascm=As/100;
    C=C2;
    
    end
    
    
    Rref=Un^2/(Sn*1e6);                                                     %Referanseverdi for resistans/reaktans
    
    if buxls ~= 0                                                           %Beregning av sporbredde
        bu=buxls;
    else
        bu=tauu/(1+1/budbd);                                                
    end
    
    bd=tauu-bu;                                                             %Beregning av tannbredde
    
    %Beregning av sporet
    
    if hsxls ~= 0
        if tnr==1

%             Ss=Ssxls*1e6;                                                   %Strmtetthet i spor
%             hcus=hcusxls/1e3;                                               %Hyde p en delleder
%             hspk=hspkxls;                                                   %Hyde p sporkile
%             hm=hmxls;                                                       %Hyde p mellomstrimmel
%             hgls=hglsxls;                                                   %Hyde p glidestrimmel
%             hds=hdsxls;                                                     %Hyde avstand mellom sporkile og luftgap
%             drs=drsxls;                                                     %Bredde p rbelseparator
%             dij=dijxls;                                                     %Beregner jordisolasjon
%             dicu=dicuxls;                                                   %Dellederisolasjon 1.-sidig
%             bcus=bcusxls;                                                   %Bredde p en delleder  
%             bcu=2*bcus;                                                     %Beregner kobberbredde for sporet                                                                 
%             ndl=ndlxls;                                                     %Antall delledere
%             ndlp=2;
%             ndlh=1;
%             Ss=In/(ndl*bcus*hcus);                                          %Ny strmtetthet i stator
%             hcu=hcus*ndl;                                                   %Total kobberhyde i et spor
%             hs=hsxls;                                                       %Hyde av sporet
%             diw=0;                                                          %Turnisolasjon i tillegg til lakkisolasjon
%             fsp=0;                                                          %Faktor til temperaturberegning
%             hstav=hcu/2+ndl*dicu+2*dij;                                     %Beregner hyde av stav
          
            Ss=Ssxls*1e6;                                                   %Strmtetthet i spor
            hcus=hcusxls/1e3;                                               %Hyde p en delleder
            hspk=0.006;                                                     %Hyde p sporkile
            hm=0.007;                                                       %Hyde p mellomstrimmel
            hgls=0.002;                                                     %Hyde p glidestrimmel
            hds=0.001;                                                      %Hyde avstand mellom sporkile og luftgap
            drs=0.0005;                                                     %Bredde p rbelseparator
            dij=0.0003+2.35e-7*Un;                                          %Beregner jordisolasjon
            dicu=0.0001;                                                    %Dellederisolasjon 1.-sidig
            bcus=(bu-2*dij-4*dicu-drs)/2;                                   %Bredde p en delleder
            bcu=bcus*2;                                                     %Beregner kobberbredde for sporet
            ndl=(Ic/(Ss*bcus*hcus));                                        %Mellomregning for antall delledere
            ndl=round(ndl/2);                                               %Mellomregning for antall delledere
            ndl=ndl*2;                                                      %Antall delledere
            ndlp=2;
            ndlh=1;
            Ss=In/(ndl*bcus*hcus);                                          %Ny strmtetthet i stator
            hcu=hcus*ndl;                                                   %Total kobberhyde i et spor
            hs=hsxls;                                                       %Hyde av sporet
            diw=0;                                                          %Turnisolasjon i tillegg til lakkisolasjon
            
            fsp=0;                                                          %Faktor til temperaturberegning
            
            hstav=hcu/2+ndl*dicu+2*dij;                                     %Beregner hyde av stav
            
        end

        if tnr~=1

            Ss=Ssxls*1e6;
            hcus=hcusxls/1e3;                                               %Gjr om til millimeter
            hspk=hspkxls;                                                   %Hyde p sporkile
            hm=hmxls;                                                       %Hyde p mellomstrimmel
            hgls=hglsxls;                                                   %Hyde glidestrimmel
            hds=hdsxls;                                                     %Hyde mellom sporkile og luftgap
            dij=dijxls;                                                     %Jordisolasjon
            Uturn=Un/(sqrt(3)*Ns);                                          %Spenning mellom hver vinding
            ndlp=ndlpxls;                                                   %Antall delledere i parallell
            ndlh=ndlhxls;                                                   %Antall delledere i hyden per turn
            diw=diwxls;
            dicu=dicuxls;                                                   %Runder av til nrmeste tiendedels milimeter
            bcus=bcusxls;                                                   %Bredde p hver delleder
            bcu=bcus*ndlp/ndlh;                                             %Kobberbredde
            ndl=ndlxls;                                                     %Finner antall delledere
            hcu=2*tnr*ndlh*hcus;                                            %Total hyde med kobber i hvert spor
            hs=hsxls;                                                       %Sporhyde
                                                                  
            fsp=round(0.14*Uturn)/1e4;                                      %Faktor til temperaturberegning

            hstav=hcu/2+2*ndlh*tnr*dicu+2*dij;                              %Beregner hyde av stav
        end
    else
        if tnr==1


            Ss=Ssxls*1e6;                                                   %Strmtetthet i spor
            hcus=hcusxls/1e3;                                               %Hyde p en delleder
            hspk=0.006;                                                     %Hyde p sporkile
            hm=0.007;                                                       %Hyde p mellomstrimmel
            hgls=0.002;                                                     %Hyde p glidestrimmel
            hds=0.001;                                                      %Hyde avstand mellom sporkile og luftgap
            drs=0.0005;                                                     %Bredde p rbelseparator
            dij=0.0003+2.35e-7*Un;                                          %Beregner jordisolasjon
            dicu=0.0001;                                                    %Dellederisolasjon 1.-sidig
            bcus=(bu-2*dij-4*dicu-drs)/2;                                   %Bredde p en delleder
            bcu=bcus*2;                                                     %Beregner kobberbredde for sporet
            ndl=(Ic/(Ss*bcus*hcus));                                        %Mellomregning for antall delledere
            ndl=round(ndl/2);                                               %Mellomregning for antall delledere
            ndl=ndl*2;                                                      %Antall delledere
            ndlp=2;
            ndlh=1;
            Ss=In/(ndl*bcus*hcus);                                          %Ny strmtetthet i stator
            hcu=hcus*ndl;                                                   %Total kobberhyde i et spor
            hs=hcu+ndl*dicu+hm+hspk+hgls+hds+4*dij;                         %Hyde av sporet
            diw=0;                                                          %Turnisolasjon i tillegg til lakkisolasjon
            
            fsp=0;                                                          %Faktor til temperaturberegning
            
            hstav=hcu/2+ndl*dicu+2*dij;                                     %Beregner hyde av stav
        end

        if tnr~=1

            Ss=Ssxls*1e6;
            hcus=hcusxls/1e3;                                               %Gjr om til millimeter
            hspk=0.006;                                                     %Hyde p sporkile
            hm=0.007;                                                       %Hyde mellomstrimmel
            hgls=0.002;                                                     %Hyde glidestrimmel
            hds=0.001;                                                      %Hyde mellom sporkile og luftgap
            dij=0.0003+2.35e-7*Un;                                          %Jordisolasjon
            Uturn=Un/(sqrt(3)*Ns);                                          %Spenning mellom hver vinding
            diw=0;                                                          %Turnisolasjon i tillegg til lakkisolasjon
            dicu=0.0002;                                                    %Runder av til nrmeste tiendedels milimeter
            bcus=(bu-2*dij-2*dicu-2*diw);                                   %Bredde p hver delleder
            ndlp=ceil(Ic/(tnr*Ss*bcus*hcus));                               %Finner antall delledere
            ndlh=ndlp;
            ndl=ndlp*tnr;                                                   %Beregner antall delledere per stav
            hcu=2*ndl*hcus;                                                 %Total hyde med kobber i hvert spor
            hs=hcu+2*ndl*dicu+hm+hspk+hgls+hds+4*dij+4*tnr*diw;             %Sporhyde
            bcu=bcus;                                                       %Kobberbredde
            
            fsp=round(0.14*Uturn)/1e4;                                      %Faktor til temperaturberegning

            hstav=hcu/2+2*ndl*dicu+2*dij;                                   %Beregner hyde av stav
        end
    end
        
    OBst=1.3*(0.135-0.003*Un/1000)*(1+0.02*(dTmx-60));                      %Tillatt overflatebelastning
    Acus=0.98*bcus*hcus*ndl/tnr;                                            %Kobberarealet av en stav
    OBsa=2.1e-12*Ic^2/(Acus*(bu+hs-hspk-hds));                              %Aktuell overflatebelastning    
    Ss=In/(pnr*Acus);                                                       %Strmtetthet
    Ssmm=Ss*1e-6;                                                           %Strmtetthet i [mm2]
    
    if OBsa>OBst
        disp('NB!: The winding surface loading is too high, the stator may overheat!')
        disp(' ');
    end
    
    [Nw,Dw]=rat(taups);                                                     %Beregner antall forskjellige spenningsvektorer (Westgaard Nw=N og Dw=U)
    Fw=Qs/Nw;
    
    qm=Qs/(3*Fw);                                                           %Bereger antall forskjellige spenningsvektorer
    kd=sin(pi/6)/(qm*sin(pi/(qm*6)));                                       %Beregner fordelingsfaktoren
      
    
    if yxls~=0
        Ww=yxls; 
    else
        disp(['The fullpitch coil span of this machine is ',num2str(taups),' slots '])
        disp(' ');
        Ww=input('Select the desired coil span (has to be an integer):');
        disp(' ');
    end
    
    kp=sin(Ww*pi/(taups*2));                                                %Beregner skrittforkortningsfaktor
    
    yQ=Ww/taups;                                                            %Relativt spoleskritt
    
    Y=1;
    N=2;
   
    if s~=0
    
        aksq=1;                                                             %Med skewing
    else
        aksq=2;                                                             %Uten skewing
    end
    
    disp(' ');

    if (aksq==1)                                                            %Beregner den totale viklingsfaktoren for en vikling med og uten skewing
        
        ksq=sin(s*pi/(taups*2))/(s*pi/(taups*2));                           %Skewing faktor
        kw=kd*kp*ksq;                                                       %Viklingsfaktor med skewing
              
    elseif (aksq==2)
    
        kw=kd*kp;                                                           %Viklingsfaktor uten skewing
        ksq=1;
        
    end
    
   
    FIm=Un/(sqrt(3)*4*kf*kw*f*Ns);                                          %Beregner masimal flukstetthet gjennom faseviklingen % ndvendig fluks for  oppn nsket spenning i fasevikling
    
    if Bdeltaxls ~= 0 && lbxls == 0
        lb=km*FIm/(Bdeltaxls*taup);                                         %Beregning av brutto jernlengde
    end
        
    gamma=3e-7;                                                             %Faktor for  bestemme minimum luftgap for maskin med rund rotor
    
    if delta0xls~=0
        delta0=delta0xls/1e3;                                               %Minimum luftgap
    else
        delta0=gamma*taup*Amsdelta/0.9;                                    %Beregning av minimum luftgap % 0.9 = nsket maks flukstetthet
    end
    
    tauukj=bv+bcs;                                                          %Bredde p en kjlekanal i tillegg til blikkpakke
    nv=lb/(bv+bcs);                                                         %Beregning av antall kjlekanaler
    nv=round(nv);                                                                                                                       
    kckj=tauukj/(tauukj-((bv/delta0)/(5+(bv/delta0))*bv));                  %Karters koeffisient for kjlekanal
    bve=kckj*bv;                                                            %Ekvivalent bredde p luftgap    
    lm=lb-nv*bve+2*delta0;                                                  %Ekvivalent jernlengde
    lb=nv*bv+(nv+1)*bcs;                                                    %Brutto jernlengde
    ln=lb-nv*bv;                                                            %Netto jernlengde
    
    Bdelta=FIm*km/(lb*taup);                                                %Flukstetthet i luftgap, maksimal induksjon
    Bdeltam=Bdelta/km;                                                      %Midlere verdi av flukstetthet i luftgap
    
    hys=FIm/(2*kFe*ln*Bymx);                                                %Hyde p statork
    
    Dy=Di+2*(hs+hys);                                                       %Yttre diameter p stator
    
    
%Beregning av Rac
rho75=2.165e-8;                                                             %Resistivitet for vikling ve 75 grader
rho20=1.78e-8;                                                              %Resistivitet for vikling ve 20 grader


%Rbelstav

    if tnrxls==1 
        if lavxls ~= 0                                                      %Vindingslengde (total vindingslengde per 2 staver)
            lav=lavxls;
        else
            lav=2*lb+tauu*Ww*2/cos(0.95);                                   %Kobberlengde per vinding
        end
                                                                        
        lfs=lav*Qs/(3*pnr);                                                 %Kobberlengde for en fasevikling
           
        Rdc=1.06*rho75*lfs/(Acus*pnr);                                      %DC-resistans for en fasevikling
        alphaKra=sqrt(pi*f*4*pi*1e-7*(1/(rho75))*(2*bcus/bu));              %Faktor for beregning av Rac
        zeta=alphaKra*hcus ;                                                %Faktor for beregning av Rac    
        mcu=ndl/2;    
        ficu=zeta*(sinh(2*zeta)+sin(2*zeta))/(cosh(2*zeta)-cos(2*zeta));    %Faktor for beregning av Rac
        psicu=2*zeta*(sinh(zeta)-sin(zeta))/(cosh(zeta)+cos(zeta));         %Faktor for beregning av Rac

        Krau=ficu+(((ndl/2)^2-1)/3)*psicu;                                  %Resistansfaktor for understav
        Krao=Krau*(1+(2*(mcu^2))/3*zeta^4);                                 %Resistansfaktor for overstav
        
        lrac=lb*Ns;                                                         %Beregning av lengden for den delen som ligger i sporet
        Rdcprm=Rdc/lfs;                                                     %DC-resistans per meter
          
        Raco=Krao*Rdcprm*lrac;                                              %Resistans for overstav
        Racu=Krau*Rdcprm*lrac;                                              %Resistans for understav
        
        Rac=Rdcprm*(lfs-2*lrac)+Raco+Racu;                                  %AC-resistans for viklingen                      
        
        Krad=ficu+((ndl)^2-1)/3*psicu;                                      %Resistansfaktor for viklingen i sporet (br vre mindre enn 1.15)
        Kra=Rac/Rdc;                                                        %Resistansfaktor for viklingen
        Kmx=1+0.294e8*(bcu/bu*hcu*hcus*f/50)^2;                             %Resistansfaktor for verste delleder
    
        Rdc20=Rdc/rho75*rho20;                                              %DC-resistans ved 20 grader
    else
        
        
%Formspole        

        if lavxls ~= 0
            lav=lavxls;
        else
            lav=tnr*(2*lb+4*taup*Ww/taups+0.5);
        end
        
        lfs=lav*Qs/3;                                                       %Lengde p
                
        Rdc=1.06*rho75*lfs/(Acus*pnr^2);
        alphaKra=sqrt(pi*f*4*pi*1e-7*(1/(rho75))*(bcu/bu));                 %Faktor for beregning av Rac
        zeta=alphaKra*hcus ;                                                %Faktor for beregning av Rac    
        ficu=zeta*(sinh(2*zeta)+sin(2*zeta))/(cosh(2*zeta)-cos(2*zeta));    %Faktor for beregning av Rac
        psicu=2*zeta*(sinh(zeta)-sin(zeta))/(cosh(zeta)+cos(zeta));         %Faktor for beregning av Rac
        Krad=ficu+((2*tnr*ndlh)^2-1)/3*psicu;
        
        if hsxls == 0 && tnr > 1
            Krau=ficu+(((ndl)^2-1)/3)*psicu;                                %Resistansfaktor for understav
            Krao=Krau*(1+(2*(ndl)^2)/3*zeta^4);                             %Resistansfaktor for overstav
        else
            Krau=ficu+(((ndl/2)^2-1)/3)*psicu;                              %Resistansfaktor for understav
            Krao=Krau*(1+(2*(ndl/2)^2)/3*zeta^4);                           %Resistansfaktor for overstav
        end    
        lrac=lb*Ns;                                                         %Beregning av lengden for den delen som ligger i sporet
        Rdcprm=Rdc*pnr^2/lfs;                                               %DC-resistans per meter
        Raco=Krao*Rdcprm*lrac;                                              %Resistans for overstav
        Racu=Krau*Rdcprm*lrac;                                              %Resistans for understav
        Rac=(Rdcprm*(lfs/pnr-2*lrac)+Raco+Racu)/pnr;                        %AC-resistans for viklingen 
        Kra=Rac/Rdc;                                                        %Resistansfaktor for viklingen
        
        Kmx=1+0.294e8*(bcu/bu*hcu*hcus*f/50)^2;                             %Resistansfaktor for verste delleder
        
        Rdc20=Rdc/rho75*rho20;                                              %DC-resistans ved 20 grader
    end
    
    disp('Stator Calculations Completed');
 

%Rotorberegninger
  
                                                        
    
%Ekvivalent luftgap

    kCs=tauu/(tauu-((bu/delta0)/(5+bu/delta0))*bu);                         %Carterskoeffisient for statorspor
    bD=0.003;                                                               %Sporpningen for dempestavene [m]
    %kCr=taur/(taur-((bD/delta0)/(5+bD/delta0))*bD);                         %Carterskoeffiseint for rotorspor (dempevikling)
    kC=kCs;                                                                 %Den totale Carterskoeffisienten (ingen dempevikling)
    delta0e=kCs*delta0;                                                     %Ekvivalent luftgap [m]
    

%Magnetiske beregninger

    
    %Beregning av hyde p magnet   

    my_pm=myr_pm*my0;
           
%     Bg=0;                                                                   %Oppretter ny, midlertidig variabel for beregning av lengde p mangnet.
%     hpm=1e-4;                                                               %Startpunkt for hyde av mangnet
%     
        
%     while Bg < 0.68                                                         %Itererer til riktig hyde av magnet
%     
%     kCs=tauu/(tauu-((bu/(delta0+hpm))/(5+bu/(delta0+hpm)))*bu);             %Carterfaktor beregnes med luftgap tilsvarende avstand mellom stator- og rotork
%     delta0epm=delta0*kCs;                                                   %Ekvivalent luftgap. PM maskin med overflatemonterte magneter har kun spor i stator
%     Am=alfar*taup*lb;                                                       %Areal av magnet
%     Adelta=taup*lb*(1+alfar)/2;                                             %Areal av luftgap
%     C_phi=Am/Adelta;                                                        %Forhold mellom areal av magnet og luftgap
%     Pc=hpm/(delta0epm*C_phi);                                                  %Permeance coefficient
%     kml=1+(4*hpm/(pi*myr_pm*alfar*taup))*log(1+(pi*delta0epm)/((1-alfar)*taup)); %Faktor for bereging av lekkfluks
%     Bg=(C_phi/((1+(myr_pm*kCs*kml)/(Pc))))*Br;                              %Luftgapsfluks skapt med magnethyde hpm
%   
%   
%     hpm=hpm+1e-4;                                                           %Hyde av magnet
%     end
%         
%     hpm
%     kml
%     alfar
  

   %Forbedret metode for beregning av hyde p magnet

    hpm2=1e-4;
    Bg=0;
    while Bg <  Bdeltam                                                  %Itererer til riktig hyde av magnet til nsket gjennomsnittlig flukstetthet er ndd
     
    kCs=tauu/(tauu-((bu/(delta0+hpm2))/(5+bu/(delta0+hpm2)))*bu);           %Carterfaktor beregnes med luftgap tilsvarende avstand mellom stator- og rotork
    delta0epm=delta0*kCs;                                                   %Ekvivalent luftgap. PM maskin med overflatemonterte magneter har kun spor i stator
    
    Am=alfar*taup*lb;
    wpm=taup*alfar;
    wf=taup-wpm;
    eta=(hpm2/(pi*myr_pm*wpm))*log(1+pi*delta0epm/hpm2);
    Delta=(hpm2/(pi*myr_pm*wpm))*log(1+pi*delta0epm/wf);
 
    Bg=(((1+wf/wpm+(myr_pm*delta0epm*(wpm+wf))/(hpm2*(wpm+2*delta0epm)))*(1+2*eta+4*Delta))^-1)*Br; %Midlere luftgapfluks
    
    KLg=1/(1+((myr_pm*delta0epm*alfar*taup)/(hpm2*(alfar*taup+2*delta0epm)))*(2*eta+4*Delta));  %Lekkfluksfaktor
    
    hpm2=hpm2+1e-4;
    end
    
    
    hpm=hpm2;
        
    Bm=Bg/(KLg*alfar);                                                      %Flukstetthet i magnet
    FIL=(1-KLg)*100;                                                        %Prosentvis lekkfluks
    
    Umdelta=Bdelta*delta0e/(my0);                                           %Magnetisk spenningsfall over luftgapet
    
    Sd=kFe*(lb-nv*bv)*bd;                                                   %Statortannens minsteareal
    Su=lm*tauu-Sd;                                                          %Statorsporets areal
    Bd=(lb*tauu*Bdelta/Sd)*0.99;                                            %Maksimal flukstetthet i statortennene
    FId=Sd*Bd;                                                              %Maksimal fluks i en statortann
    
    bdmin=bd;                                                               %Minste tannbredde [m]
    bdmax=(Di+2*hs)*pi/Qs-bu;                                               %Strste tannbredde [m]
    
    Bdmax=FId/(kFe*(lb-nv*bv)*(bdmin+(bdmax-bdmin)/hs*0));                  %Maksimal flukstettheten i statortennene som funksjon av hyden i sporet
    Bdmin=FId/(kFe*(lb-nv*bv)*(bdmin+(bdmax-bdmin)));
                                            
    INT=1;
    
    save('Test','hs','hys','FId','FIm','kFe','lb','nv','bv','bdmin',...
        'bdmax','INT','FeOldxls')                                           %Matrise for bruk i quad-funksjon

    Umd=quad(@Int,0,hs);                                                    %Integralberegning for magnetisk spenningsfall i spor
   
    Bys=FIm/(2*kFe*(lb-nv*bv)*hys)*sin(pi/2);                               %Flukstettheten i ket
    
    tauys=pi*(Dy-hys)/Np;                                                   %Lengden p fluksveien i ket
    INT=2;
    
    save('Test','hs','hys','FId','FIm','kFe','lb','nv','bv','bdmin',...
        'bdmax','INT','tauys','FeOldxls')
    
    Umys=quad(@Int,0,tauys);                                                %Integralberegning for magnetisk spenningsfall i k
       
    myryr=2000;                                                             %Antatt permeabilitet for rotorringen
    
    if hyrxls == 0
        hyr=FIm/(2*kFe*lb*Bymx);                                            %Hyde p rotorring nr nsket flukstetthet settes til 1.4T
    else
        hyr=hyrxls;
    end
    
   
    Dry=Di-2*(delta0+hpm);                                                  %Rotorringens ytre diameter
    tauyr=pi*(Dry-hyr)/(2*p);                                               %Midlere buelengde for rotorring mellom to nabopoler
   
    
    Bxx=Bymx;                                                               %Antatt flukstettheten i rotorringen
    
    if FeOldxls ~= 0
        Umyr=(-2250000*Bxx^6 + 18941667*Bxx^5 - 66025000*Bxx^4 + ...
            122029053*Bxx^3 - 126164843*Bxx^2 + 69200135*Bxx - ...
            15733616)*tauyr;
    else
        Umyr=(5627*Bxx^6-20591*Bxx^5+27732*Bxx^4-16559*Bxx^3+...
            4154*Bxx^2-172.71*Bxx+13.144)*tauyr;                            %Magnetisk spenningsfall i rotorringen
    end
    
    
    
    epsilon_hpm=(Umd+Umys/2+Umyr/2)/Umdelta;                                %Tilleggsfaktor for magnetisk spenningsfall i stator tenner, staor k og rotor k
    
    
    hpm=hpm*(1+epsilon_hpm)*1.1;                                            %Endelig hyde p magnet med 10% tillegg for metning
    
          
 %Beregning av volum og masse av magnet
 
    ropm=Di/2-delta0;                                                       %Ytre radius av magnet
    ripm=ropm-hpm;                                                          %Indre radus av magnet
    Am_cross=alfar*pi*(ropm^2-ripm^2)/Np;                                   %Tverrsnittareal av magnet per pol
    V_pm=Am_cross*lb;                                                       %Volum av magnet per pol
    V_pm_tot=V_pm*Np;                                                       %Totalt volum av magnet
  
    rho_pm=7300;                                                            %Massetetthet av neodymiummagnet, ref. Pyrhonen
    m_pm_tot=rho_pm*V_pm_tot;                                               %Total masse av permanentmagnet(neodymium)
    Gpm=m_pm_tot;

    Le=0.025;                                                               %Tykkelse av endeplate
    hpk=0;                                                                  %Ndvendig for  f kode til  fungere, siden polene ikke lenger er utformet med feltviklinger
    hps=0;                                                                  %-"-
    hkr=0;                                                                  %-"-
    bf=0;                                                                   %-"-
    bcuf=0;                                                                 %-"-
    hf=0;                                                                   %-"-
    bif=0;                                                                  %-"-
    Lfp=0;                                                                  %-"-
    bpk=0;                                                                  %-"-
    bi=0;                                                                   %-"-
    bps=0;                                                                  %-"-
    polklaring=0;                                                           %-"-
    
disp('Rotor Calculations Completed');


%Lekkinduktanser
    
    deltadef=delta0epm;

    Ldelta=0;                                                                      
    harm(20,2)=0;
    harm(1,1)=1;
    harm(1,2)=kw;
    hk=2;
    
    if (aksq==1)                                                            %Med skew                                                      
        
        for v=3:2:41
        kwsv=sin(v*Ww*pi/(2*taups))*(sin(v*pi/(m*2))/(qm*sin(v*pi/...
            (m*2*qm))))*(sin(v*s*pi/(taup*2))/(v*s*pi/(taup*2)));           %Viklingsfaktoren for v.-harmoniske
                                                                                
        harm(hk,1)=v;
        harm(hk,2)=kwsv;
                                                                            
        Ldeltav=my0*m*Di*lm/(pi*deltadef)*(Ns/p)^2*(kwsv/v)^2;
        Ldelta=Ldelta+Ldeltav;                                              %Luftgaplekkinduktansen
        hk=hk+1;
        end 
              
    elseif (aksq==2)                                                        %Uten skew
    
        for v=3:2:41
        kwsv=sin(v*Ww*pi/(2*taups))*(sin(v*pi/(m*2))/...
            (qm*sin(v*pi/(m*2*qm))));                                       %Viklingsfaktoren for v.-harmoniske 
                                                                               
        harm(hk,1)=v;
        harm(hk,2)=kwsv;
                                                                            
        Ldeltav=my0*m*Di*lm/(pi*deltadef)*(Ns/p)^2*(kwsv/v)^2;
        Ldelta=Ldelta+Ldeltav;                                              %Luftgaplekkinduktansen
        hk=hk+1;        
        end    
   
    end    
  
    hk3=1;
    
    
    for hk3=1:1:19                                                          %Beregning av maskinens harmoniske komponenter
        
        harma=harm(hk3,1);
        harmb=harm(hk3,2);
        harmb=abs((1/harma)*harmb);
        
        hk4=round(harma/3);
        hk44=harma/3;
        
        harm2(hk3,1)=harma;
        
        if hk4~=hk44
            harm2(hk3,2)=harmb*100;
            harm3(hk3,2)=harmb;
        end
    
    end
    
    THF=100*sqrt(harm3(1,2)^2*4.44e-5^2+harm3(2,2)^2*6.65e-3^2+...
        harm3(3,2)^2*55.6e-3^2+harm3(4,2)^2*0.165^2+harm3(5,2)^2*...
        0.327^2+harm3(6,2)^2*0.505^2+harm3(7,2)^2*0.61^2+harm3(8,2)^2*...
        0.895^2+harm3(9,2)^2*1.1^2+harm3(10,2)^2*1.32^2+harm3(11,2)^2*...
        1.46^2+harm3(12,2)^2*1.49^2+harm3(13,2)^2*1.53^2+harm3(14,2)^2*...
        1.57^2+harm3(15,2)^2*1.6^2+harm3(16,2)^2*1.63^2+harm3(17,2)^2*...
        1.66^2+harm3(18,2)^2*1.7^2+harm3(19,2)^2*1.72)^2;                   %Telephone Harmonic Factor fra statorvikling
        
    harm2(1,2)=0;


%Lekkinduktanser
    lambdalew=0.477;                                                        %Permeansfaktor for spolehodet
    lambdaw=0.187;                                                          %Permeansfaktor for spolehodet
    Wewm=taup*Ww/taups;                                                     %Spoleskritt i meter
    Wew=0.6*Wewm;                                                           %Midlere spoleskritt for spolehodet
    lew=0.7*((lav/tnr-2*lb)/2-Wewm)/2;                                      %Aksial lengde av spolehodet
        
    Lw=(4*m/Qs)*q*my0*Ns^2*(2*lew*lambdalew+Wew*lambdaw);                   %Spolehodelekkinduktansen
   
    Lm=(my0*m*Di*ln*(Ns*kw/p)^2)/(pi*(delta0epm+hpm));                      %Magneriseringsinduktans, eq. 3.110 Pyrhonen
    
    Lg=(tnr^2*my0*lb*taup)/(2*(hpm+delta0epm))*Ns;                          %Luftgap lekkinduktans, eq. 4.16 Hanselman
    Lu=(tnr^2/3)*(my0*hs*lb/bu)*Ns;                                         %Sporlekkinduktans, eq. 4.19 Hanselman 
    Lsq=(1-ksq^2)*Lm;                                                       %Vridningslekkinduktans
    Lsigma = Lg + Lu + Lw + Lsq;                                       %Sum av legginduktanser
  
    Xmd = w*(Lsigma+Lm);                                                    %Magnetiseringsreaktans i d-akse
    Xmqpu=0;                                                                %Magnetiseringsreaktans i q-akse
    Xqpu=0;                                                                 %pu verdi av synkronreaksjonsreaktansen i q-aksen
    
    %Magnetiseringsbehov for PM-maskin
    
    Inpu=1;                                                                 %pu verdi av nominell generatorstrm
    Unpu=1;                                                                 %pu verdi av nominell generatorspenning
    Racpu=Rac/Rref;                                                         %pu verdi av statorresistansen
    Xmdpu=w*Lm/Rref;                                                        %pu verdi av magnetiseringsreaktansen
    Xsigmapu=w*Lsigma/Rref;                                                 %pu verdi av lekkreaktansen    
    Xdpu=Xmdpu+Xsigmapu;                                                     %pu verdi av synkronreaksjonsreaktansen i d-aksen
  
    fi2=acos(Cosphi);                                                       %Faseforskyvning ved nominell last
    InpuCx=Inpu*(cos(fi2)-1i*sin(fi2));                                     %Kompleks nominell generatorstrm i pu
    EfpuCx=(Unpu+(Racpu+1i*Xdpu)*InpuCx/1.1);                               %Kompleks emf, inkludert faktor for  ta hyde for metning
    Efpu=abs(EfpuCx);                                      
    delta=angle(EfpuCx);                                                    %power angle
    
    EipuCx=Unpu+(Racpu+1i*Xsigmapu)*InpuCx;
    Eipu=abs(EipuCx);                                                       %Relativ indusert spenning i belastning
    
    
    U_re=1;
    U_im=0;
    I_re=real(InpuCx)/3;                                                    %Deler p 3 for  skalere phasor til passende strrelse i plott
    I_im=imag(InpuCx)/3;                                                    %Deler p 3 for  skalere phasor til passende strrelse i plott
    Ef_re=real(EfpuCx);
    Ef_im=imag(EfpuCx);
    Ei_re=real(EipuCx);
    Ei_im=imag(EipuCx);
    
    clf;                                                                    %Nullstiller figurvindu
    
    t=linspace(0,delta);
    x=Efpu*cos(t);
    y=Efpu*sin(t);
    x = [x 0 x(1)];
    y = [y 0 y(1)];
    plot(x,y,'--k');                                                        %Potter buesegment for  illustrere overspenning 
    hold on;
    
    Phasors = [U_re, I_re, Ef_re Ei_re;
        U_im, I_im, Ef_im Ei_im];                                           %Plotter viser diagram
    
    plotv(Phasors, '-');
            
    axis([-0.1 1.5 -0.3 0.6]);
    grid on;
    
   
    
%     Tetamn_pm=Efpu*Umtot;                                                 %Totalt magnetiseringsbehov
 
%Flukstettheter i belastning

 Byr=(Eipu*FIm)/(2*kFe*lb*hyr*KLg);                                         %Flukstettheten i rotorringen inkludert bidrag fra lekkfluks
 Bdmax=Bdmax*Eipu;                                                          %Flukstetthet i statortennene, hyeste verdi
 Bys=Bys*Eipu;                                                              %Flukstetthet i stator k

 
 
%Tapsberegninger
 
    
%Kobbertap
    
    Pcusdc=3*Rdc*In^2;                                                      %DC kobberstap i statorvikling
    Pcusdckw=Pcusdc/1000;
    Pcusac=3*(Rac-Rdc)*In^2;                                                %AC kobberstap i statorvikling
    Pcusackw=Pcusac/1000;
    
    %Rrdc=2.165e-8*nf*Np*Lfmd/Af;                                            %Rotorresistans             
    %Pr=Rrdc*If^2;                                                           %Rotortap                   
    %Prkw=Pr/1000;
    %Pre=Pr/Lfmd*2*(bf+2*bcuf);                                              %Rotortap p ende av polen
    %Prl=Pr-Pre;                                                             %Rotortap langs polen
    
    %Prnl=Pr/Efpu;                                                           %Kobbertap i rotor i tomgang
    %Prnlkw=Prnl/1000;
    %Prfl=Pr-Prnl;                                                           %Tillegg for rotortap ved merkedrift
    %Prflkw=Prfl/1000;
    
    Pr=0;                                                                   %Ingen feltvikling i PM-maskin, og dermed ingen tap
    Pre=0;
    Prl=0;
    Prnl=0;                                                           
    Prnlkw=0;
    Prfl=0;                                                         
    Prflkw=0;
    
    
%Jerntap                                                   

    kFey=1.6;                                                               %Faktor for  ta hensyn til metning i k
    kFed=2;                                                                 %Faktor for  ta hensyn til metning i tann
    
    if P10xls ~= 0                                                          %Jernap per kilo stl[W/kg]
        P10=P10xls;
    else
        P10=1.07;                                                           
    end
    
    mFe=pi*((Dy/2)^2-(Di/2+hs)^2)*ln*7.75e3*kFe;                            %Total masse for blikket i stator (uten tenner)                   
    mds=((bdmax+bdmin)/2)*hs*ln*Qs*7.75e3*kFe;                              %Massen til tenner             
    PFey=kFey*P10*Bys^2*mFe;                                                %Jerntap i k
    PFed=kFed*P10*((Bdmax+Bdmin)/2)^2*mds;                                  %Jerntap i tenner                                 
    PFe=(f/50)^1.3*(PFey+PFed);                                             %Totalt jerntap i k
    PFekw=PFe/1000;
    
    
% Tap i magnetisering
%     
%     if Pmagnxls ~= 0                                                        %Beregning av megnetiseringstap
%         Pmagnkw=Pmagnxls;
%         Pmagn=Pmagnkw*1000;
%     else
%         Pmagn=Pr*0.07;
%         Pmagnkw=Pmagn/1000;
%     end
       Pmagn=0;
    

%Luftfriksjonstap    
    
    myair=1.93e-5;                                                          %Viskositet for luft i 40 grader
    %kmek=1.4;                                                               %Overflatekonstant som forteller hvor ujevn overflaten er varier mellom 1 og 1,4
    kmek=1.0;                                                               %Overflatekonstant som forteller hvor ujevn overflaten er varier mellom 1 og 1,4
    wm=ns*2*pi/60;                                                          %Mekanisk vinkelfrekvens
    rhoth=1.13;                                                             %Tettheten til luft ved 40graderC
    kpw=10;                                                                 %Varierer mellom 5 og 15. Er avhening av kjling
    
    deltame=delta0epm;                                                      %deltame er opprinnelig parameter, deltaepm er brukt i PM-del av kode
    
        Rlsdelta=rhoth*wm*(Di-deltame)*deltame/(2*myair);                   %Reynoldnummer for rotoroverflaten
    
    if Rlsdelta<64  
        
        Cm=10*(2*deltame/(Di-deltame))^0.3/Rlsdelta;
        
    end
    
    if 64<Rlsdelta<5e2
       
        Cm=2*(2*deltame/(Di-deltame))^0.3/Rlsdelta^0.6;
        
    end
    
    if 5e2<Rlsdelta<1e4
        
        Cm=1.03*(2*deltame/(Di-deltame))^0.3/Rlsdelta^0.5;
        
    end
    
    if Rlsdelta>1e4
       
        Cm=0.065*(2*deltame/(Di-deltame))^0.3/Rlsdelta^0.2;
        
    end
    
    Prhow1=1/32*kmek*Cm*pi*rhoth*wm^3*(Di-deltame)^4*lb;                    %Overflatetap rotor, verifisert SCW
    
    Rlrdelta=rhoth*wm*(Di-deltame)^2/(4*myair);                             %Reynoldnummer for ende p rotor
    
    if Rlrdelta<3e5
    
        Cm2=3.87/Rlrdelta^0.5;
    
    end
    
    if Rlrdelta>3e5
        
        Cm2=0.146/Rlrdelta^0.5;
    
    end
    
    Prhow2=1/64*Cm2*rhoth*wm^3*((Di-deltame)^5-Dri^5);                      %Overflatetap rotorende
    
    Prhow=Prhow1+Prhow2;     
    
%Tilleggstap
    
    Padd=0.0015*Sn*1e6*Cosphi+Prhow;                                        %Tilleggstap, varierer mellom 0,1% til 0,2% av levert effekt (0,05-0,15 for non-salient machines)
    Paddkw=Padd/1000;                                                       %Tillegstapet bestr at fieldske tap i endeplater, polsko, statorkonstruksjon og AC-tap i spolehodene 
    
    
%Lager og viftetap

    kvw=(1.7+0.4*Di)*(1.75/Di)^0.1*(ns/428)^0.4;                            %Faktor for beregning av lagertap og viftetap    
    Pfw=800*kvw*Di^3*ns^2*sqrt(lb)*1e-5;                                    %Lager og viftetap
    Pfwkw=Pfw/1000;
    
    
%Totale tap
    
    Pwarming=Pcusac+Pcusdc+PFe+Pr+Padd;                                     %Tap som frer til oppvarming av kjleluft
    Ptot=Pcusac+Pcusdc+PFe+Padd+Pr+Pfw+Pmagn;                               %Totale tap
    Ptotkw=Ptot/1000;
    
    P=Sn*1e6*Cosphi;
    Eff=(P/(Ptot+P))*100;                                                   %Virkningsgrad

    
%Termiske beregninger
    

%Beregning av temperatur og ndvendig kjleluft
    %Denne delen gir ikke resultater i PM-del av kode
    cp=1.0;                                                                 %Spesifikk varmekapasitit for kjleluften [kJ/kg K]
    thc=0.2;                                                                %Termisk ledningsevne for den elektriske isolasjonen
    rhoth=1.13;                                                             %Kjleluftens tetthet ved 40 grader C [kg/m^2]
    lambdaair=0.025;                                                        %Termisk konduktivitet for kjleluften
    myair=1.93e-5;                                                          %Dynamisk viskositet for kjleluften
    Pqth=Pwarming;                                                          %Tap som m fraktes ut av maskinen
    aqth1=0;
    aqth2=0;
    
    while aqth1 == 0
        if qthxls == 0 && aqth2 == 0
            qth=2*Pqth/(rhoth*cp*dTmx);                                     %Ndvendig kjleluftstrm [m^3/s]
        elseif qthxls == 0 && aqth2 == 1
            qth=qth+1000;
        else
            qth=qthxls*1000;
            aqth1=1;
        end

        Rqth=1/(2*rhoth*cp*qth);

        Amin=Di*pi*nv*bv*bd/tauu;
        vim=qth/(1000*Amin);                                                %Hastigheten p kjleluften i kjlekanalene mellom stavene
        vi=vim*(Di/(1+budbd))/(Di+2*hs);                                    %Hastigheten p kjleluften i kjlekanalene bak staven
        vy=vim*(Di/(1+budbd))/(Dy);                                         %Hastigheten p kjleluften i kjlekanalene ved ytre diameter
        vmid=(vi+vy)/2;                                                     %Midlere hastigheten p kjleluften i kjlekanalene

    %Rth1
        ath1=350;                                                           %Varmeoverfringskoeffisient mellom statorramme og statorblikk [W/(K m^2)]
        lth1=40;                                                            %Termisk konduktivitet for strukturstl [W/(K m)]
        d1=0;                                                               %Tykkelsen p materialet som varmestrmmen m passere [m]
        h1=Dy*pi;                                                           %hyden av objektet [m]
        l1=ln;                                                              %Lengden av objektet [m]
        G1=h1*l1/(d1/lth1+1/ath1);                                          %Varmeledningskonduktansen for Rth1 [K/W]
        Rth1=1/G1;                                                          %Varmeledningsmotstanden mellom statorblikket og statorrammen [W/K]
        
    %Rth2, Rth4, Rth5 og Rth6
        lth2=32;                                                            %Termisk konduktivitet for blikket i samme reting som lamineringene
        lth4=0.6;                                                           %Termisk konduktivitet for blikket normalt p lamineringene
        d2=(Dy/2-Di/2-hs)/2;
        d4=bcs/2;                                                              
        h2=pi*(Dy-d2*2);
        l2=ln;
        S4=pi*((Dy/2)^2-(Di/2+hs)^2);                                                                     
        G2=1/(d4/(lth4*S4));
        R2=d2/(lth2*h2*l2);
        Rth2=sqrt(R2/G2)*tanh(sqrt(R2*G2)/2);                               %Varmeledningsmotstand fra midt i blikket og ut til ytre diameter
        Rth4=1/G2;                                                          %Varmeledningsmotstand fra midten av en blikkpakke og til nrmeste kjlekanal
        Rth5=1/G2*(sqrt(R2*G2)/sinh(sqrt(R2*G2))-1);                        %Varmeledningsmotstand for varme produsert i statorblikket
        Rth6=Rth2;    
    
    %Rth3
        %vv=8.75;                                                           %Lufthastigheten i kjlekanalene [m/s]
        ath3=7*sqrt(vmid/(Dy/2-Di/2-hs));                                                           
        lth3=32;                                                            
        d3=0;                                                    
        S3=2*pi*((Dy/2)^2-(Di/2+hs)^2);                                                            
        G3=S3/(d3/lth3+1/ath3);
        Rth3=1/G3;                                                          %Varmeoverfringsmotstanden mellom statorblikket og luftstrmmen i en kjlekanal

    %Rth8                                                              
        ath8=7.97*sqrt(vmid/(hs));                                                                                                               
        S8=2*hs*Qs*(bdmax+bdmin)/2;                                                            
        G8=S8*ath8;
        Rth8=1/G8;                                                          %Varmeoverfringsmotstanden mellom statortennene og luftstrmmen i en kjlekanal
        
    %Rth7, Rth9, Rth10 og Rth14
        lth7=32;                                                            %Termisk konduktivitet for blikket i samme reting som lamineringene
        lth9=0.6;                                                           %Termisk konduktivitet for blikket normalt p lamineringene
        d7=hs/2;
        d9=bcs/2;                                                              
        h7=pi*(Di+d7);
        l7=ln;
        S9=hs*Qs*(bdmax+bdmin)/2;
        G7=1/(d9/(lth9*S9));
        R7=d7/(lth7*h7*l7);
        Rth7=sqrt(R7/G7)*tanh(sqrt(R7*G7)/2);                               %Varmeledningsmotstand fra midt i blikket og ut til ytre diameter
        Rth9=1/G7;                                                          %Varmeledningsmotstand fra midten av en blikkpakke og til nrmeste kjlekanal
        Rth10=1/G7*(sqrt(R7*G7)/sinh(sqrt(R7*G7))-1);                       %Varmeledningsmotstand for varme produsert i statorblikket
        Rth14=Rth7;  
    
    %Rth11
        ath11=180;                                                          %Varmeoverfringskoffisienten mellom statorvikling og statorblekk
        S11=hs*ln*2*Qs;
        G11=S11*ath11;
        Rth11=1/G11;                                                        %Varmeoverfringsmotstanden mellom statorviklingen og statortennene
    
    %Rth12, Rth15, Rth20 og Rth21
        lth12=thc;                                                          %Termisk konduktivitet for vindingsisolasjonen (typisk verdi)
        lth15=394;                                                          %Termisk konduktivitet for kobber (elektroteknisk)
        d12=dij+dicu+diw+fsp;
        d15=lb/2;                                                              
        dl12=bcu/2;
        S12=(hs-hspk-hgls-hds+(bu+bcu)/2)*2*lb*Qs;
        Sl12=(hcu*3/4+bcu*3/4)*2*lb*Qs;
        S15=hcu*bcu*Qs;                                                       
        G15=1/(d12/(lth12*S12)+dl12/(lth15*Sl12));
        R15=d15/(lth15*S15);
        Rth12=1/G15;                                                        %Varmeledningsmotstand fra midt i staven og ut til yttersiden av isolasjonen
        Rth15=1/G15*(sqrt(R15*G15)/sinh(sqrt(R15*G15))-1);                  %Varmeledningsmotstand fra midten av en stav til endene av staven
        Rth20=sqrt(R15/G15)*tanh(sqrt(R15*G15)/2);                          %Varmeledningsmotstand for varme produsert i statorviklingen
        Rth21=Rth20;  
    
    %Rth13
        if tnr ~= 1
            ath13=17.39*sqrt(vim/(hs));
        else
            ath13=24.39*sqrt(vim/(hs));
        end
        S13=2*(hs+bu)*bv*nv*Qs;                                                            
        G13=S13*ath13;
        Rth13=1/G13;                                                        %Varmeoverfringsmotstanden mellom statorstavene og luftstrmmen i en kjlekanal
        
    %Rth16 og Rth25
        deltath16=hspk+hgls+hds+delta0+hps+hkr;
        Ta=rhoth^2*(ns*(2*pi)/60)^2*Di/2*deltath16^3/myair^2;
        Fg=pi^4*((Di-2.304*deltath16)/(Di-deltath16))/(1697*(0.0056+...
            0.0571*((Di-2.304*deltath16)/(Di-deltath16))^2)*...
            (1-deltath16/Di)^2);
        
        Tam=Ta/Fg;
        
        if Tam < 1700
            Nu=2;
        elseif 1700 < Tam < 1e4
            Nu=0.128*Tam^0.367;
        elseif 1e4 < Tam < 1e7    
            Nu=0.409*Tam^0.241;
        end
        
        ath16=1.23*Nu*lambdaair/deltath16;
        lspolh=(lav/tnr-2*lb)/2;
        S16=(hstav+bu)*2*lspolh*Qs;
        G16=S16*ath16;
        Rth16=1/G16;                                                        %Varmeovergangsmotstand fra spolehodene til kjleluften i spolehodeomrdet
        Rth25=Rth16;                                                        %Varmeovergangsmotstand fra spolehodene til kjleluften i spolehodeomrdet
    
    %Rth17, Rth18, Rth19, Rth22, Rth23 og Rth24
        lth17=thc;                                                          %Termisk konduktivitet for vindingsisolasjonen (typisk verdi)
        lth18=394;                                                          %Termisk konduktivitet for kobber (elektroteknisk)
        d17=dij+dicu;
        d18=lspolh/2;                                                              
        dl17=bcu/2;
        S17=(hstav+bu)*2*lspolh*Qs;
        Sl17=(hcu/4+bcu/2)*2*lspolh*Qs;
        S18=hcu/2*bcu*Qs;                                                          
        G18=1/(d17/(lth17*S17)+dl17/(lth18*Sl17));
        R18=d18/(lth18*S18);
        Rth17=1/G18;                                                        %Varmeledningsmotstand fra midt i spolehodet og ut til yttersiden av isolasjonen
        Rth19=sqrt(R18/G18)*tanh(sqrt(R18*G18)/2);                          %Varmeledningsmotstand fra midten av et spolehode til endene av spolehodet
        Rth18=1/G18*(sqrt(R18*G18)/sinh(sqrt(R18*G18))-1);                  %Varmeledningsmotstand for varme produsert i spolehodet
        Rth22=Rth19;                                                        %Varmeledningsmotstand for varme produsert i spolehodet
        Rth23=Rth18;                                                        %Varmeledningsmotstand fra midten av et spolehode til endene av spolehodet
        Rth24=Rth17;                                                        %Varmeledningsmotstand fra midt i spolehodet og ut til yttersiden av isolasjonen
        
    %Rth26 og Rth27
        Ta=rhoth^2*(ns*(2*pi)/60)^2*Di/2*(deltame/kC)^3/myair^2;
        Fg=pi^4*((Di-2.304*(deltame/kC))/(Di-(deltame/kC)))/...
            (1697*(0.0056+0.0571*((Di-2.304*(deltame/kC))/...
            (Di-(deltame/kC)))^2)*(1-(deltame/kC)/Di)^2);
        
        Tam=Ta/Fg;
        
        if Tam < 1700
            Nu=2;
        elseif 1700 < Tam < 1e4
            Nu=0.128*Tam^0.367;
        elseif 1e4 < Tam < 1e7    
            Nu=0.409*Tam^0.241;
        end
        
        ath26=1.25*Nu*lambdaair/(deltame/kC);
        ath27=ath26*2;
        S26=Di*pi*ln*bd/tauu;
        S27=taupr*lb*Np;
        G26=S26*ath26;
        G27=S27*ath27;
        Rth26=1/G26;                                                        %Varmeovergangsmotstand fra statorens til kjleluftstrmmen i luftgapet
        Rth27=1/G27;                                                        %Varmeovergangsmotstand fra overflaten av polskoene til kjleluftstrmmen i luftgapet
        
    %Rth28 og Rth37
        deltath28=hspk+hgls+hds+delta0+hps+hkr;
        Ta=rhoth^2*(ns*(2*pi)/60)^2*Di/2*deltath28^3/myair^2;
        Fg=pi^4*((Di-2.304*deltath28)/(Di-deltath28))/(1697*...
            (0.0056+0.0571*((Di-2.304*deltath28)/(Di-deltath28))^2)*...
            (1-deltath28/Di)^2);
        
        Tam=Ta/Fg;
        
        if Tam < 1700
            Nu=2;
        elseif 1700 < Tam < 1e4
            Nu=0.128*Tam^0.367;
        elseif 1e4 < Tam < 1e7    
            Nu=0.409*Tam^0.241;
        end
        
        ath28=2*Nu*lambdaair/deltath28;
        S28=((bf+2*bcuf)*(hf+bcuf+0.008)+2*bcuf*hf)*Np;
        G28=S28*ath28;
        Rth28=1/G28;                                                        %Varmeovergangsmotstand fra rotorens endeviklinger til kjleluften i spolehodeomrdet
        Rth37=Rth28;                                                        %Varmeovergangsmotstand fra rotorens endeviklinger til kjleluften i spolehodeomrdet
        
    %Rth29, Rth30, Rth31, Rth34, Rth35 og Rth36
        lth29=thc;                                                          %Termisk konduktivitet for vindingsisolasjonen (typisk verdi)
        lth30=394;                                                          %Termisk konduktivitet for kobber (elektroteknisk)
        d29=bif;
        dl29=bcuf/2;
        d30=(bf+bcuf)/2;                                                              
        S29=((bf+2*bcuf)*(hf+bcuf+0.008)+2*bcuf*hf)*Np;
        Sl29=(bf+2*bcuf)*hf*Np;
        S30=bcuf*hf*Np;                                                           
        G29=1/(d29/(lth29*S29)+dl29/(lth30*Sl29));
        R30=d30/(lth30*S30);
        Rth29=1/G29;                                                        %Varmeledningsmotstand fra midten av rotorens endevikling og ut til yttersiden av isolasjonen
        Rth30=1/G29*(sqrt(R30*G29)/sinh(sqrt(R30*G29))-1);                  %Varmeledningsmotstand for varme produsert i rotorens endevikling
        Rth31=sqrt(R30/G29)*tanh(sqrt(R30*G29)/2);                          %Varmeledningsmotstand fra midten av endeviklingen og til endene av endeviklingen
        Rth34=Rth31;                                                        %Varmeledningsmotstand fra midten av endeviklingen og til endene av endeviklingen
        Rth35=Rth30;                                                        %Varmeledningsmotstand for varme produsert i rotorens endevikling
        Rth36=Rth29;                                                        %Varmeledningsmotstand fra midten av rotorens endevikling og ut til yttersiden av isolasjonen
    
    %Rth32, Rth33, Rth39 og Rth42
        lth42=thc;                                                          %Termisk konduktivitet for vindingsisolasjonen (typisk verdi)
        lth39=394;                                                          %Termisk konduktivitet for kobber (elektroteknisk)
        d39=(Lfp+bcuf)/2;                                                              
        d42=bif;
        dl42=bcuf/2;
        S39=hf*bcuf*4*Np; 
        S42=hf*(Lfp+2*bcuf)*2*Np;
        Sl42=hf*(Lfp+bcuf)*2*Np;                                                       
        G39=1/(d42/(lth42*S42)+dl42/(lth39*Sl42));
        R39=d39/(lth39*S39);
        Rth42=1/G39;                                                        %Varmeledningsmotstand fra midten av feltviklingen og ut til yttersiden av isolasjonen i polluken
        Rth39=1/G39*(sqrt(R39*G39)/sinh(sqrt(R39*G39))-1);                  %Varmeledningsmotstand fra midten av feltviklingen og ut til endene av feltviklingen
        Rth32=sqrt(R39/G39)*tanh(sqrt(R39*G39)/2);                          %Varmeledningsmotstand for varme produsert i feltviklingen
        Rth33=Rth32;  
    
    %Rth38, Rth40 og Rth41
        lth38=38;                                                           %Termisk konduktivitet for blikket i samme reting som lamineringene
        lth41=14;                                                           %Termisk konduktivitet for blikket normalt p lamineringene
        lthl41=8;
        d38=hpk/2+hps;
        d41=bpk/2; 
        dl41=bi;
        S38=bpk*lb*Np;
        S41=hpk*lb*2*Np;
        Sl41=(hpk+(bps-bpk)/2+bcuf)*lb*2*Np;
        G38=1/(d41/(lth41*S41)+dl41/(lthl41*Sl41));
        R38=d38/(lth38*S38);
        Rth38=sqrt(R38/G38)*tanh(sqrt(R38*G38)/2);                          %Varmeledningsmotstand fra midten av en rotorpol og ut til polskoens overflate
        Rth40=1/G38*(sqrt(R38*G38)/sinh(sqrt(R38*G38))-1);                  %Varmeledningsmotstand for varme produsert i rotorpolen
        Rth41=1/G38;                                                        %Varmeledningsmotstand fra midten av en rotorpol og til feltviklingen

    %Rth43
        vpl=(3+7*(vim/15)^1.5)*(polklaring/0.019)^1.38*(ns/500)*(hf/0.14);
        ath43=11.5*sqrt(vpl/(lb/2));                                                                                                               
        S43=hf*lb*2*Np*5/3;                                                            
        G43=S43*ath43;
        Rth43=1/G43;                                                        %Varmeovergangsmotstand fra rotorens endeviklinger til kjleluften i spolehodeomrdet
     
        
%Termisk konduktansmatrise

    G=ones(21,21)*0;

    G(1,1)=1/(Rth1+Rth2)+1/(Rth5)+1/(Rth6+Rth7);
    G(1,2)=-1/(Rth5);
    G(2,1)=-1/(Rth5);
    G(1,3)=-1/(Rth6+Rth7);
    G(3,1)=-1/(Rth6+Rth7);
    G(2,2)=1/(Rth5)+1/(Rth3+Rth4);
    G(3,3)=1/(Rth6+Rth7)+1/(Rth10)+1/(Rth14+Rth26);
    G(3,4)=-1/(Rth10);
    G(4,3)=-1/(Rth10);
    G(3,20)=-1/(Rth14+Rth26);
    G(20,3)=-1/(Rth14+Rth26);
    G(4,4)=1/(Rth8+Rth9)+1/(Rth10)+1/(Rth11);
    G(4,5)=-1/(Rth11);
    G(5,4)=-1/(Rth11);
    G(5,5)=1/(Rth11)+1/(Rth12)+1/(Rth13);
    G(5,19)=-1/(Rth13);
    G(19,5)=-1/(Rth13);
    G(5,6)=-1/(Rth12);
    G(6,5)=-1/(Rth12);
    G(6,6)=1/(Rth12)+1/(Rth15);
    G(6,8)=-1/(Rth15);
    G(8,6)=-1/(Rth15);
    G(7,7)=1/(Rth16+Rth17)+1/(Rth18+Rth19+Rth20);
    G(7,8)=-1/(Rth18+Rth19+Rth20);
    G(8,7)=-1/(Rth18+Rth19+Rth20);
    G(8,8)=1/(Rth18+Rth19+Rth20)+1/(Rth21+Rth22+Rth23)+1/(Rth15);
    G(8,9)=-1/(Rth21+Rth22+Rth23);
    G(9,8)=-1/(Rth21+Rth22+Rth23);
    G(9,9)=1/(Rth21+Rth22+Rth23)+1/(Rth24+Rth25);
    G(9,21)=-1/(Rth24+Rth25);
    G(21,9)=-1/(Rth24+Rth25);
    G(10,10)=1/(Rth28+Rth29)+1/(Rth30+Rth31+Rth32);
    G(10,11)=-1/(Rth30+Rth31+Rth32);
    G(11,10)=-1/(Rth30+Rth31+Rth32);
    G(11,11)=1/(Rth30+Rth31+Rth32)+1/(Rth30+Rth31+Rth32)+1/(Rth39);
    G(11,12)=-1/(Rth30+Rth31+Rth32);
    G(12,11)=-1/(Rth30+Rth31+Rth32);
    G(11,13)=-1/(Rth39);
    G(13,11)=-1/(Rth39);
    G(12,12)=1/(Rth30+Rth31+Rth32)+1/(Rth36+Rth37);
    G(12,20)=-1/(Rth36+Rth37);
    G(20,12)=-1/(Rth36+Rth37);
    G(13,13)=1/(Rth39)+1/(Rth42);
    G(13,15)=-1/(Rth42);
    G(15,13)=-1/(Rth42);
    G(14,14)=1/(Rth27+Rth38+Rth40)+1/(Rth41);
    G(14,15)=-1/(Rth41);
    G(15,14)=-1/(Rth41);
    G(15,15)=1/(Rth41)+1/(Rth42)+1/(Rth43);
    G(15,20)=-1/(Rth43);
    G(20,15)=-1/(Rth43);
    G(16,16)=1/(Rth1+Rth2);
    G(16,1)=-1/(Rth1+Rth2);
    G(1,16)=-1/(Rth1+Rth2);
    G(17,17)=1/(Rth3+Rth4);
    G(17,2)=-1/(Rth3+Rth4);
    G(2,17)=-1/(Rth3+Rth4);
    G(18,18)=1/(Rth8+Rth9);
    G(18,4)=-1/(Rth8+Rth9);
    G(4,18)=-1/(Rth8+Rth9);
    G(19,19)=1/(Rth13);
    G(21,21)=1/(Rth16+Rth17)+1/(Rth24+Rth25)+1/(Rth28+Rth29)+1/(Rth36+Rth37);
    G(21,7)=-1/(Rth16+Rth17);
    G(7,21)=-1/(Rth16+Rth17);
    G(20,20)=1/(Rth14+Rth26)+1/(Rth27+Rth38+Rth40)+1/(Rth43);
    G(21,14)=-1/(Rth27+Rth38+Rth40);
    G(14,21)=-1/(Rth27+Rth38+Rth40);
    G(21,10)=-1/(Rth28+Rth29);
    G(10,21)=-1/(Rth28+Rth29);
    
    
%Varmestrmsmatrise
    
    P=ones(15,1)*0;
    
    P(2,1)=PFey;                                                            %Tap i k
    P(4,1)=PFed;                                                            %Tap i statortenner
    P(6,1)=(Pcusdc+Pcusac)*(2*lb/(lav/tnr));                                %Tap i spor
    P(7,1)=(Pcusdc+Pcusac)*(lspolh/(lav/tnr));                              %Tap i ett spolehode
    P(9,1)=(Pcusdc+Pcusac)*(lspolh/(lav/tnr));                              %Tap i ett spolehode
    P(10,1)=Pre/2;                                                          %Tap i rotorviklingen i polenden
    P(12,1)=Pre/2;                                                          %Tap i rotorviklingen i polenden
    P(13,1)=Prl;                                                            %Tap i rotorviklingen i luftgapet
    P(14,1)=0;                                                              %Tap i polkjernen
    
   
%Termisk resistansmatrise

    Re=ones(6,6)*0;
    
    Re(1,1)=Rqth;
    Re(1,2)=2*Rqth;
    Re(1,3)=2*Rqth;
    Re(1,4)=2*Rqth;
    Re(1,5)=2*Rqth;
    Re(1,6)=2*Rqth;
    
    Re(2,2)=Rqth;
    Re(2,3)=2*Rqth;
    Re(2,4)=2*Rqth;
    Re(2,5)=2*Rqth;
    Re(2,6)=2*Rqth;
    
    Re(3,3)=Rqth;
    Re(3,4)=2*Rqth;
    Re(3,5)=2*Rqth;
    Re(3,6)=2*Rqth;
    
    Re(4,4)=Rqth;
    Re(4,5)=2*Rqth;
    Re(4,6)=2*Rqth;
    
    Re(5,5)=Rqth;
    Re(5,6)=Rqth;
    
    Re(6,6)=Rqth;
    
    
%Friksjonstapmatrise

    Tp=ones(6,1)*0;
    
    Tp(1,1)=2*Rqth*Prhow2+2*Rqth*Prhow1;
    Tp(2,1)=2*Rqth*Prhow2+2*Rqth*Prhow1;
    Tp(3,1)=2*Rqth*Prhow2+2*Rqth*Prhow1;
    Tp(4,1)=2*Rqth*Prhow2+2*Rqth*Prhow1;
    Tp(5,1)=2*Rqth*Prhow2+Rqth*Prhow1;
    Tp(6,1)=Rqth*Prhow2;
        
    
%Temperaturmatrise

        Temp=ones(21,1)*0;

        Re2=Re^-1;
        P2=[P;(Re^-1)*Tp];

        Re3=ones(21,21)*0;

        for Re3x=1:1:6
            for Re3y=1:1:6

                Re3(15+Re3x,15+Re3y)=Re2(Re3x,Re3y);

            end
        end

        Temp=((G+Re3)^-1)*P2;
        Temp2=round(Temp);
        dTmxt=dTmx-14;
        
        if Temp2(2,1) > dTmxt || Temp2(4,1) > dTmxt || Temp2(6,1) > ...
                dTmxt || Temp2(7,1) > dTmxt || Temp2(10,1) > dTmxt || ...
                Temp2(13,1) > dTmxt || Temp2(14,1) > dTmxt || ...
                Temp2(16,1) > dTmxt || Temp2(17,1) > dTmxt || ...
                Temp2(18,1) > dTmxt || Temp2(19,1) > dTmxt || ...
                Temp2(20,1) > dTmxt || Temp2(21,1) > dTmxt
            
            aqth2=1;
        else
            aqth1=1;
        end
        
    end
    
    %disp('Thermal Calculations Completed');
    

%Reaktanser og tidskonstanter
    %Transiente reaktanser og tidskonstante er ikke tilstede i PMSM

%Transiente reaktanser
    
%     a=taumx/taumn-1;                                                        %Faktor for beregning av pollekkfluks
%     kfi=0.99;                                                               %Faktor for beregning av feltviklingens relative lekkreaktans
%     kmf=1/(a^3)*(1+a/8)*(log(1+a)+a*(a/2-1));                               %Reduksjonsfaktor for pollekkfluks
%     Ampk=Apk*kmf/kl;                                                        %Lekkledningsevne mellom polkjernene tatt hensyn til stigning i forslynget fluks fra bunnen av polen
%     Rf=2.1e-8*Lfmd*nf*Np/(Af);                                              %Feltviklingens resistans ved 75 grader
%     Rf20=Rf/rho75*rho20;                                                    %Feltviklingens resistans ved 20 grader 
%     
%     Rmf=(Fa*kdx/Tetamn)^2*Rf*If^2/(Sn*1e6);                                 %Feltviklingsresistans referert til stator
%     Xf=(4/pi)*(Fa*kdx^2/FIm)*(Ampk+Aps)+Xmd*((4/pi)*kfi*kdx-1);             %Feltviklingens relative lekkreaktans
%     sigf=Xf/Xmd;                                                            %Faktor for beregning av reaktanser
%     Xdt=Xsigma+Xmd*(sigf/(1+sigf));                                         %Transient d-akse reaktans
%     Xdtt=Xsigma+0.6*(sigf/(1+sigf));                                    %Sub-transient d-akse reaktans
%     Xqtt=Xdtt*1.15;                                                         %Sub-transient q-akse reaktans
%     
%     Lfsigma=Xf*Rref/w;                                                      %Feltviklingens lekkinduktans
%     Ldt=Xdt*Rref/w;                                                         %Transient d-akse induktans
%     Ldtt=Xdtt*Rref/w;                                                       %Sub-transient d-akse induktans
%     Lqtt=Xqtt*Rref/w;                                                       %Sub-transient q-akse induktas
   
%Transiente tidskonstanter
    
%     as=(NDs-1)*taur/taup;                                                   %Avstans mellom de to ytterste dempestavene p en pol
%     k=(kw*Ns)^2/(Np/2);                                                     %Faktor for beregning av dempestavens resistans referet til stator
%     RmD=1.37*m*2.1e-8*(as*lb/(NDs*AcuD)+(Di/(pi*3.5*AcuD*(Np/2))))^2*k*1e-2;%Dempestavens resistans referet til stator
% 
%     ADs=0.47+0.066*(bu/bcu)+hds/bcu;                                        %Permeansfaktor for en dempestav
%     LmD=8*4*pi*1e-7*w*m*lm*(as/NDs)*(ADs+0.133*(as*Di/((Np/2)*NDs*...       %Dempeviklingen lekkinduktans referet til stator
%         delta0)))*k*1e-2;
% 
%     zetad=1.746-0.422*as-0.2913/(as-0.138);                                 %Faktor for beregning av tidskonstant i d-akse
%     zetaq=1.222-0.1*as-0.102/(as-0.1);                                      %Faktor for beregning av tidskonstant i q-akse
% 
%     LmDd=LmD/zetad;                                                         %Dempeviklingens d-akse lekkinduktans referet til stator
%     LmDq=LmD/zetaq;                                                         %Dempeviklingens q-akse lekkinduktans referet til stator
%         
%     Tdt0=(Lfsigma+Lmd)/(Rmf*Rref);                                          %Tidskonstanter
%     Tdt=(Lfsigma+Lsigma*Lmd/(Lsigma+Lmd))/(Rmf*Rref);
%     
%     Tdtt0=(LmDd+Ldt)/RmD;
%     Tdtt=Tdtt0*Ldtt/Ldt;
%     Tqtt0=(LmDq+Lmq)/RmD;
%     Tqtt=Tqtt0*Lqtt/Lmq;
%        
%     disp('Reactance and Time Constant Calculations Completed');
%   
    
%Mekaniske beregninger


%Svingmoment

    gammacu=8930;                                                           %Massetetthet for kobber [kg/m^3]
    gammaFe=7870;                                                           %Massetetthet for jern
%     Gf=Af*nf*gammacu*Lfmd*Np;                                               %Vekt av feltvikling
     Gf=0;
%     Df=Di-2*(delta0+hps)-hpk;                                               %Diameter gjennom midten av feltviklingene
%     Dps=Di-2*delta0-1/3*(4*hps-hpt);                                        %Diameter gjennom midten av polskoene
%     Gpkpm=hpk*bpk*gammaFe;                                                  %Vekt av polkjerne per meter lengde
%     Gpspm=1/3*(hpt+2*hps)*bps*gammaFe;                                      %Vekt av polsko per meter lengde
%     
%     GDp2=(1.04*Gf*Df^2+Np*lb*(Gpkpm*Df^2+Gpspm*Dps^2))                     %Svingmoment for poler og feltviklinger
    GDp2=0;    
    %Dr=Df-hpk-hyr;                                                          %Rotorringens midlere diameter
    Dr=2*ripm-hyr;                                                          %Rotorringens midlere diameter
    lrr=lb+2*bcuf+2*Le;                                                     %Lengde av rotorringen
    Gr=pi*Dr*hyr*lrr*gammaFe;                                               %Vekt av rotorring
    
    
    if GD2addxls~=0
        Gflywheel=GD2addxls;                                                %Vekt av svinghjul
    else
        Gflywheel=0;
    end
    
    GD2flywheel=Gflywheel*(Di*0.5)^2;                                       %Svingmoment til svinghjul
    
    Dpm=2*ripm+hpm;
    GDpm=Gpm*Dpm^2;                                                          %Svingmoment av PM, br verifiseres, da dette er en forenkling siden PM ikke utgjr en hul sylinder, men deler av den
    GDr2=Gr*Dr^2;                                                           %Svingmoment for rotorringen
    GD2add=(GDpm+GDr2)*0.07;                                                %Tillegg i svingmoment for nav, bremsering, ventilatorer etc.
   
    GD2=GDp2+GDr2+GD2add+GD2flywheel+GDpm;                                  %Maskinens totale svingmoment
    
    M2=GD2/4000;                                                            %Maskinens treghetsmoment

    
%Total maskinvekt
    
    %Gpk=Gpkpm*Np*lb;                                                        %Vekt av polkjernene
    Gpk=0;
    %Gps=Gpspm*Np*lb;                                                        %Vekt av polskoene
    Gps=0;
    Gsw=Acus*lav*Qs*gammaFe;                                                %Vekt av statorvikling
    Gadd=0.86*(Gpk+Gps+Gf+Gr)+0.9*(mFe+mds+Gsw);                            %Tilleggsvekt pga. aksling, stttestruktur tilleggsdeler etc.
        
    Gtot=1.1*(mFe+mds+Gsw+Gpk+Gps+Gf+Gr+Gadd)+Gflywheel+Gpm;               %Total maskinvekt
    
    disp('Mechanical Calculations Completed');
    disp('Writing data to file');
    
    
%Outputs
    
    Ascm=As/100;
    
    %Stator Parameters
    SP(1,1)=C;    
    SP(2,1)=Ascm;    
    SP(3,1)=Di;    
    SP(4,1)=Dy;    
    SP(5,1)=lb;    
    SP(6,1)=ln;    
    SP(7,1)=Qs;    
    SP(8,1)=nv;    
    SP(9,1)=Ns;    
    SP(10,1)=tnr;    
    SP(11,1)=pnr;    
    SP(12,1)=q;    
    SP(13,1)=yQ;    
    SP(14,1)=Ww;    
    SP(15,1)=kw;       
    SP(16,1)=hs*1000;    
    SP(17,1)=bu*1000;    
    SP(18,1)=bd*1000;    
    SP(19,1)=tauu*1000;
    SP(20,1)=ndl;
    SP(21,1)=hcus*1000;
    SP(22,1)=bcus*1000;
    SP(23,1)=dij*1000;
    SP(24,1)=dicu*1000;
    SP(25,1)=lav;
    SP(26,1)=Acus*1e6;    
    SP(27,1)=Ssmm;
    SP(28,1)=Rdc20;
    SP(29,1)=Rdc;    
    SP(30,1)=Kra;
    SP(31,1)=Krad;
    SP(32,1)=Kmx;
    SP(33,1)=s;    
    
    xlswrite('Output.xls',SP,1,'E17');
    
    %Rotor Parameters
     RP(1,1)=delta0*1000;
     RP(2,1)=deltame*1000;
    RP(3,1)=0; %bps*1000;
    RP(4,1)=0; %hps*1000;
    RP(5,1)=0; %bpk*1000;
    RP(6,1)=0; %hpk*1000;
    RP(7,1)=0; %nf;
    RP(8,1)=0; %If;
    RP(9,1)=0; %bcuf*1000;
    RP(10,1)=0; %hcuf*1000;
    RP(11,1)=0; %Af*1e6;
    RP(12,1)=0; %Sfmm;
    RP(13,1)=0; %Rf20;
    RP(14,1)=0; %Rf;
     RP(15,1)=alfar;
    RP(16,1)=0; %NDs;
    RP(17,1)=0; %AcuD*1e6;
    RP(18,1)=0; %polklaring*1000;
    
     xlswrite('Output.xls',RP,1,'E54');
        
    %Magnetic Parameters
    MPC(1,1)=Bdelta;
    MPC(2,1)=Bys;
    MPC(3,1)=Bdmax;
    MPC(4,1)=Byr;
    MPC(5,1)=Bm;
     
     xlswrite('Output.xls',MPC,1,'C77');
    
    MPE1(1,1)=0; %Umdelta;
    MPE1(2,1)=0; %Umys;
    MPE1(3,1)=0; %Umd;
    MPE1(4,1)=0; %Umdr;
    MPE1(5,1)=0; %Umyr;
   
    xlswrite('Output.xls',MPE1,1,'E77');
    
    MPE2(1,1)=Efpu;
    MPE2(2,1)=Eipu;
    MPE2(3,1)=0; %Tetamn;
    MPE2(4,1)=FIL;
    
    xlswrite('Output.xls',MPE2,1,'E83');
    
    %Loss Calculations
    %No load
     LC1(1,1)=PFekw;
     LC1(2,1)=Pfwkw;
     LC1(3,1)=Prnlkw;
     
     xlswrite('Output.xls',LC1,1,'E91');
        
    %Nominal load
     LC2(1,1)=Pcusdckw;
     LC2(2,1)=Pcusackw;
     LC2(3,1)=Prflkw;
     LC2(4,1)=Paddkw;
     LC2(5,1)=0; %Pmagnkw; %ingen magnetiseringstap ved PM
       
    xlswrite('Output.xls',LC2,1,'E95');
    xlswrite('Output.xls',Ptotkw,1,'E101');
    
    %Reactances and Time Constants
     RTC1(1,1)=Xmdpu;
     RTC1(2,1)=Xmqpu;
     RTC1(3,1)=Xsigmapu;
     RTC1(4,1)=Xdpu;
     RTC1(5,1)=Xqpu;
     RTC1(6,1)=0; %Xdt;
     RTC1(7,1)=0; %Xdtt;
     RTC1(8,1)=0; %Xqtt;
     
     
     xlswrite('Output.xls',RTC1,1,'E106');
    
    RTC2(1,1)=0; %Tdt;
    RTC2(2,1)=0; %Tdtt;
    RTC2(3,1)=0; %Tqtt;
    
    xlswrite('Output.xls',RTC2,1,'E115');
    
    %Thermal Calculations
    TC(1,1)=qth/1000;
    TC(2,1)=vim;
    
    TC1(1,1)=Temp2(6);
    TC1(2,1)=Temp2(4);
    TC1(3,1)=Temp2(2);
    TC1(4,1)=Temp2(7);
    TC1(5,1)=Temp2(13);
    TC1(6,1)=Temp2(10);
    TC1(7,1)=Temp2(14);
    
    TC2(1,1)=Temp2(21);
    TC2(2,1)=Temp2(20);
    TC2(3,1)=Temp2(19);
    TC2(4,1)=Temp2(18);
    TC2(5,1)=Temp2(17);
    TC2(6,1)=Temp2(16);
    
    xlswrite('Output.xls',TC,1,'E122');
    xlswrite('Output.xls',TC1,1,'E126');
    xlswrite('Output.xls',TC2,1,'E135');


    %Mechanical Calculations
    MC(1,1)=M2;
    MC(2,1)=Gtot/1000;
    MC(3,1)=Vr;
    
    xlswrite('Output.xls',MC,1,'E145');
       
    xlswrite('Output.xls',harm2,1,'A153');
    
    xlswrite('Output.xls',THF,1,'H168');
    
    %Main Data
    MD(1,1)=Sn;
    MD(2,1)=Un;
    MD(3,1)=In;
    MD(4,1)=Cosphi;
    MD(5,1)=Eff;
    MD(6,1)=ns;
       
    xlswrite('Output.xls',MD,1,'E7');
    
    %PM dimensions
    PM1(1,1)=Br;
    PM1(2,1)=myr_pm;
    
    xlswrite('Output.xls',PM1,1,'E175');
    
    PM2(1,1)=hpm*1000;
    PM2(2,1)=Am;
    PM2(3,1)=Am_cross;
    PM2(4,1)=V_pm;
    PM2(5,1)=m_pm_tot;
    
    xlswrite('Output.xls',PM2,1,'E179');
    
disp('The Calculations are Completed.');
disp('The results can be viewed in the Excel-file Output.xls');    
    end
